package spads1;

// Class created by Simon Dellicour (july 2011)

import java.util.ArrayList;

public class Barrierm 
{
	public SimThread simTestThread;
	private InputFileReader input;
	public ArrayList<Integer> popID;
	public ArrayList<ArrayList<Node>> lociNodes;
	public ArrayList<String> results;
	public ArrayList<String> externalMessage;
	
	public Barrierm(InputFileReader input0, Interface window, SimThread simTestThread0)
		{
			simTestThread = simTestThread0;
			simTestThread.run("Beginning of multi-loci Monmonier algorithm");
			
			input = input0;
			results = new ArrayList<String>();
			externalMessage = new ArrayList<String>();
			double B = 0; // number of barriers to construct (defined by the user)
			int Bmin = 1;
			if (input.minimumNumberOfBarriers > 0)
				{
					Bmin = (int) input.minimumNumberOfBarriers;
				}
			B = input.maximumNumberOfBarriers;
			
			// Creation of the "PopID" ArrayList:
			ArrayList<Node> nodes0 = new ArrayList<Node>();
			for (int i = 0; i < input.loci.get(0).populations.size(); i++)
				{
					nodes0.addAll(input.loci.get(0).populations.get(i).nodes);
				}
			ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
			popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
			popID0.add(Integer.valueOf(nodes0.get(0).currentPop));
			for (int i = 1; i < nodes0.size(); i++)
				{
					int a = 0;
					for (int j = 0; j < i; j++)
						{
							if (nodes0.get(i).currentPop == nodes0.get(j).currentPop)
								{
									a = a + 1;
								}
						}
					if (a == 0)
						{
							popID0.add(Integer.valueOf(nodes0.get(i).currentPop)); 
						}
				}
			int popIDsize = 0; popIDsize = popID0.size(); 
			for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
				{
					int index = 0;
					int bufferID = 0;
					bufferID = popID0.get(0).intValue();
					for (int j = 1; j < popID0.size(); j++)
						{
							if (popID0.get(j).intValue() < bufferID)
								{
									bufferID = popID0.get(j).intValue();
									index = j;
								}
						}
					popID0.remove(index);
					popID.add(bufferID);
				}
			
			results.add("Monmonier algorithm RESULTS (multi-loci): ");
			results.add("");
			
					String popNamesString = new String();
					for (int k0 = 0; k0 < popID.size(); k0++)
						{
							popNamesString = popNamesString + input.loci.get(0).populations.get(k0).popName + "	";
						}
					results.add("Clusters ID	" + popNamesString);
					
					for (int currentB = Bmin; currentB < (B+1); currentB++)
						{
							String Gs = new String();
							int[][] delaunayTriangulation = new int[input.loci.get(0).populations.size()][input.loci.get(0).populations.size()];
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(0).populations.size(); j++)
										{
											delaunayTriangulation[i][j] = input.loci.get(0).delaunayTriangulation[i][j];
										}
								}
							
							lociNodes = new ArrayList<ArrayList<Node>>();
							for (int b = 0; b < input.loci.size(); b++)
								{
									lociNodes.add(input.loci.get(b).nodes);
								}
							
							double highestmFst = -2;
							for (int b = 0; b < currentB; b++)							
								{
									highestmFst = -2;
									int[][] initialBarrier0 = new int[1][2];
									// Finding the (b+1)eme highest Fst between 2 sampled populations:
									for (int i = 1; i < input.loci.get(0).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													double mFst = 0;
													if (input.pairwiseMonmonierDistances == true)
														{
															for (int h = 0; h < input.loci.size(); h++)
																{
																	double fst = input.loci.get(h).monmonierDistances[i][j];
																	mFst = mFst + fst;
																}
															mFst = (mFst/(double) input.loci.size());
														}
													else
														{
															double mFstN = 0; double mFstD = 0;
															for (int h = 0; h < input.loci.size(); h++)
																{
																	double fstN = input.loci.get(h).pairwiseFstPopNumerator[i][j];
																	double fstD = input.loci.get(h).pairwiseFstPopDenominator[i][j];
																	mFstN = mFstN + fstN;
																	mFstD = mFstD + fstD;
																}
															mFst = mFstN/mFstD;
														}
													if (delaunayTriangulation[i][j] == 1 && highestmFst < mFst)
														{
															highestmFst = mFst;
															initialBarrier0[0][0] = i; initialBarrier0[0][1] = j;
														}
												}
										}
									// System.out.println(highestmFst + "	" + (initialBarrier0[0][0]+1) + "	" + (initialBarrier0[0][1]+1));
									delaunayTriangulation[initialBarrier0[0][0]][initialBarrier0[0][1]] = -1;
									delaunayTriangulation[initialBarrier0[0][1]][initialBarrier0[0][0]] = -1;	
									
									for (int f = 0; f < 2; f++)
										{
											ArrayList<Integer> barrierPops = new ArrayList<Integer>();
											Integer int1 = new Integer(input.loci.get(0).populations.get(initialBarrier0[0][0]).popID); barrierPops.add(int1);
											Integer int2 = new Integer(input.loci.get(0).populations.get(initialBarrier0[0][1]).popID); barrierPops.add(int2);	
											int[][] initialBarrier = new int[1][2];
											initialBarrier[0][0] = initialBarrier0[0][0];
											initialBarrier[0][1] = initialBarrier0[0][1];
											int[][] barrier = new int[1][2];
											int[][] lastBarrier = new int[1][2];
											lastBarrier[0][0] = -1; lastBarrier[0][1] = -1;
				
											for (int i = 0; i < (input.loci.get(0).populations.size()*input.loci.get(0).populations.size()); i++)
												{	
													double d1 = 0; // double d2 = 0;
													
													// In case of a triangle:
													double c1 = 0;
													for (int j = 0; j < input.loci.get(0).populations.size(); j++)
														{	
															double c2 = 0;
															if (delaunayTriangulation[initialBarrier[0][0]][j] == 1
																&& delaunayTriangulation[initialBarrier[0][1]][j] == 1
																&& c1 == 0)
																{	
																	c1 = c1 + 1;
																	double mFst1 = 0;
																	double mFst2 = 0;
																	if (input.pairwiseMonmonierDistances == true)
																		{
																			for (int h = 0; h < input.loci.size(); h++)
																				{
																					double fst1 = input.loci.get(h).monmonierDistances[initialBarrier[0][0]][j];
																					double fst2 = input.loci.get(h).monmonierDistances[initialBarrier[0][1]][j];
																					mFst1 = mFst1 + fst1;
																					mFst2 = mFst2 + fst2;
																				}
																			mFst1 = (mFst1/(double) input.loci.size());
																			mFst2 = (mFst2/(double) input.loci.size());
																		}
																	else
																		{
																			double mFstN1 = 0; double mFstD1 = 0;
																			double mFstN2 = 0; double mFstD2 = 0;
																			for (int h = 0; h < input.loci.size(); h++)
																				{
																					double fstN1 = input.loci.get(h).pairwiseFstPopNumerator[initialBarrier[0][0]][j];
																					double fstD1 = input.loci.get(h).pairwiseFstPopDenominator[initialBarrier[0][0]][j];
																					mFstN1 = mFstN1 + fstN1;
																					mFstD1 = mFstD1 + fstD1;
																					double fstN2 = input.loci.get(h).pairwiseFstPopNumerator[initialBarrier[0][1]][j];
																					double fstD2 = input.loci.get(h).pairwiseFstPopDenominator[initialBarrier[0][1]][j];
																					mFstN2 = mFstN2 + fstN2;
																					mFstD2 = mFstD2 + fstD2;
																				}
																			mFst1 = mFstN1/mFstD1;
																			mFst2 = mFstN2/mFstD2;
																		}
																	if ((mFst1 < mFst2) | Double.isNaN(mFst1))
																		{
																			barrier[0][0] = initialBarrier[0][1]; barrier[0][1] = j;
																			c2 = c2 + 1;
																		}
																	else if ((mFst2 < mFst1) | Double.isNaN(mFst2))
																		{
																			barrier[0][0] = initialBarrier[0][0]; barrier[0][1] = j;
																			c2 = c2 + 1;
																		}
																	else if ((mFst1 == mFst2) | (Double.isNaN(mFst1) & Double.isNaN(mFst2)))
																		{
																			double r = Math.random();
																			if (r < 0.5)
																				{	barrier[0][0] = initialBarrier[0][0]; barrier[0][1] = j;	}
																			else {	barrier[0][0] = initialBarrier[0][1]; barrier[0][1] = j;	}
																			c2 = c2 + 1;
																		}
																	// System.out.println((barrier[0][0]+1) + "	" + (barrier[0][1]+1));
																}
															if (c2 > 0)
																{	
																	lastBarrier[0][0] = initialBarrier[0][0]; lastBarrier[0][1] = initialBarrier[0][1];
																	initialBarrier[0][0] = barrier[0][0]; initialBarrier[0][1] = barrier[0][1];
																	d1 = d1 + 1;
																}
														}
													if (d1 == 1)
														{	
															delaunayTriangulation[initialBarrier[0][0]][initialBarrier[0][1]] = -1;
															delaunayTriangulation[initialBarrier[0][1]][initialBarrier[0][0]] = -1;
															Integer newInt = new Integer(input.loci.get(0).populations.get(initialBarrier[0][1]).popID); barrierPops.add(newInt);
														}
												}
										}
								}
							
							
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									input.loci.get(0).populations.get(i).barrierGroupID = -1;
								}
							int id = 0;	
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									if (input.loci.get(0).populations.get(i).barrierGroupID == -1)
										{
											id = id + 1;
											input.loci.get(0).populations.get(i).barrierGroupID = id;
											
											ArrayList<Integer> groupPopulations = new ArrayList<Integer>();
											Integer a = new Integer(i); groupPopulations.add(a);
											
											for (int k = 0; k < groupPopulations.size(); k++)
												{
													for (int j = 0; j < input.loci.get(0).populations.size(); j++)
														{
															if (delaunayTriangulation[groupPopulations.get(k)][j] == 1
																&  input.loci.get(0).populations.get(j).barrierGroupID == -1)
																{
																	Integer b = new Integer(j); groupPopulations.add(b);
																	input.loci.get(0).populations.get(j).barrierGroupID = id;
																}
														}
												}
										}
								}							
							
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									Gs = Gs + input.loci.get(0).populations.get(i).barrierGroupID + "	";
								}							
							results.add("for B = " + currentB + ":	" + Gs);
							simTestThread.run("End of multi-loci Monmonier algorithm for B = " + currentB);
						}
			results.add("");
		}
}
