package spads1;

// Class created by Simon Dellicour (December 2012)

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

public class FileConversion 
{
	public SimThread simTestThread;
	private InputFileReader input;
	private double ploidyLevel;
	public ArrayList<Integer> popID;
	public ArrayList<String> results;
	public ArrayList<String> externalMessage;
	public ArrayList<String> fileMessage;
	
	public FileConversion (InputFileReader input0, Interface window, SimThread simTestThread0) throws IOException
		{
			simTestThread = simTestThread0;
			input = input0;
			externalMessage = new ArrayList<String>();

			// Creation of the "haplotype" field of each Node object:
			int numberOfDigits = 0; int maxHaplotypeID = 0;
			ArrayList<ArrayList<Node>> lociHaplotypes = new ArrayList<ArrayList<Node>>();
			ArrayList<Node> locusHaplotypes = new ArrayList<Node>();
			for (int i = 0; i < input.loci.size(); i++)
				{
					locusHaplotypes = new ArrayList<Node>();
					int haplotypeIDCounter = 0;
					locusHaplotypes.add(input.loci.get(i).nodes.get(0));
					for (int j = 1; j < input.loci.get(i).nodes.size(); j++)			
						{
							boolean newHaplotype = true;
							for (int k = 0; k < j; k++)
								{
									double a = 0;	
									a = input.loci.get(i).nodesMismatches[input.loci.get(i).nodes.get(j).nodeMismatchesIndex][input.loci.get(i).nodes.get(k).nodeMismatchesIndex];
									if (a == 0)
										{
											newHaplotype = false;
											input.loci.get(i).nodes.get(j).haplotypeID = (k+1);
										}
								}
							if (newHaplotype == true)
								{
									haplotypeIDCounter = haplotypeIDCounter + 1;
									input.loci.get(i).nodes.get(j).haplotypeID = haplotypeIDCounter;
									locusHaplotypes.add(input.loci.get(i).nodes.get(j));
								}
						}
					
					for (int j = 0; j < input.loci.get(i).populations.size(); j++)			
						{
							for (int k = 0; k < input.loci.get(i).populations.get(j).nodes.size(); k++)
								{
									boolean newHaplotype = true;
									for (int l = 0; l < locusHaplotypes.size(); l++)
										{
											double a = 0;	
											a = input.loci.get(i).nodesMismatches[input.loci.get(i).populations.get(j).nodes.get(k).nodeMismatchesIndex][locusHaplotypes.get(l).nodeMismatchesIndex];
											if (a == 0)
												{
													newHaplotype = false;
													input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID = (l+1);
												}
										}
									if (newHaplotype == true)
										{
											haplotypeIDCounter = haplotypeIDCounter + 1;
											input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID = haplotypeIDCounter;
											locusHaplotypes.add(input.loci.get(i).populations.get(j).nodes.get(k));
										}
								}
						}
					lociHaplotypes.add(locusHaplotypes);
					if (haplotypeIDCounter > maxHaplotypeID)
						{
							maxHaplotypeID = haplotypeIDCounter;
							if (maxHaplotypeID < 10)
								{
									numberOfDigits = 1;
								}
							else if (maxHaplotypeID < 100)
								{
									numberOfDigits = 2;
								}
							else if (maxHaplotypeID < 1000)
								{
									numberOfDigits = 3;
								}
							else if (maxHaplotypeID < 10000)
								{
									numberOfDigits = 4;
								}
							else if (maxHaplotypeID < 100000)
								{
									numberOfDigits = 5;
								}
						}
				}
			
			// Creation of the haplotypes lists in a Phylip format:
			externalMessage.add("");
			externalMessage.add("");
			externalMessage.add("Haplotypes lists (in a Phylip format):");
			String firstLine3 = new String();
			String newLine = new String();
			for (int i = 0; i < input.loci.size(); i++)
				{
					externalMessage.add("");
					externalMessage.add("LOCUS " + (i+1) + ":");
					externalMessage.add("");
					firstLine3 = new String();
					int numberOfLocusHaplotypes = lociHaplotypes.get(i).size();
					int locusLength = (int) input.loci.get(i).length;
					firstLine3 = firstLine3 + numberOfLocusHaplotypes + " " + locusLength;
					externalMessage.add(firstLine3);
					for (int j = 0; j < lociHaplotypes.get(i).size(); j++)
						{
							newLine = new String();
							if ((j+1) < 10000)
								{
									newLine = newLine + "haplo" + (j+1);
									if ((j+1) < 10)
										{
											newLine = newLine + "    ";
										}
									else if ((j+1) < 100)
										{
											newLine = newLine + "   ";
										}
									else if ((j+1) < 1000)
										{
											newLine = newLine + "  ";
										}
									else if ((j+1) < 10000)
										{
											newLine = newLine + " ";
										}
								}
							else
								{
									newLine = newLine + "hap" + (j+1);
									if ((j+1) < 100000)
										{
											newLine = newLine + "  ";
										}
									else if ((j+1) < 1000000)
										{
											newLine = newLine + " ";
										}
								}
							newLine = newLine + lociHaplotypes.get(i).get(j).finalSequence;
							externalMessage.add(newLine);
						}				
				}
			
			boolean samePloidy = true;
			int ploidyMax = (int) input.loci.get(0).ploidy;
			ploidyLevel = input.loci.get(0).ploidy;
			if (input.loci.size() > 1)
				{
					for (int i = 1; i < input.loci.size(); i++)
						{
							if (ploidyLevel == input.loci.get(i).ploidy)
								{	}
							else
								{
									samePloidy = false;
								}
							if (ploidyMax < (int) input.loci.get(i).ploidy)
								{
									ploidyMax = (int) input.loci.get(i).ploidy;
								}
						}
				}
			
			for (int i = 0; i < input.loci.size(); i++)
				{
					for (int j = 0; j < input.loci.get(i).populations.size(); j++)			
						{
							for (int k = 0; k < input.loci.get(i).populations.get(j).individualsGhosts.size(); k++)
								{
									if (input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.size() < ploidyMax)
										{
											for (int l = 0; l < (ploidyMax-input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.size()); l++)
												{
													Node node = new Node("ghost", -1, input.loci.get(i).populations.get(j).popName, input.loci.get(i).populations.get(j).popID);
													node.haplotypeID = -9;
													node.haplotypeIDString = "-9";
													input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.add(node);
												}
										}
								}
						}
				}
			
			// Creation of the haplotypes lists in a table format:
			externalMessage.add("");
			externalMessage.add("Haplotypes lists (in a table format):");
			externalMessage.add("");
			firstLine3 = new String();
			firstLine3 = firstLine3 + "		locus" + input.loci.get(0).ID;
			for (int i = 1; i < input.loci.size(); i++)
				{
					firstLine3 = firstLine3 + "		locus" + input.loci.get(i).ID;
				}
			externalMessage.add(firstLine3);
			ArrayList<Population> populations = new ArrayList<Population>();
			for (int i = 0; i < input.loci.size(); i++)
				{
					for (int j = 0; j < input.loci.get(i).populations.size(); j++)
						{
							boolean newPopulation = true;
							for (int k = 0; k < populations.size(); k++)
								{
									if (input.loci.get(i).populations.get(j).popName.equals(populations.get(k).popName))
										{
											newPopulation = false;
										}
								}
							if (newPopulation == true)
								{
									populations.add(input.loci.get(i).populations.get(j));
								}
						}
				}
			for (int i = 0; i < populations.size(); i++)
				{
					newLine = new String();
					newLine = populations.get(i).popName + "	" + (float) populations.get(i).position[0] + "N, " + (float) populations.get(i).position[1] + "E";
					for (int j = 0; j < input.loci.size(); j++)
						{
							int numberOfGeneCopies = 0;
							ArrayList<Integer> haplotypes = new ArrayList<Integer>();
							ArrayList<Integer> nberOfHaplotypes = new ArrayList<Integer>();
							for (int k = 0; k < input.loci.get(j).populations.size(); k++)
								{
									if (populations.get(i).popName.equals(input.loci.get(j).populations.get(k).popName))
										{
											numberOfGeneCopies = input.loci.get(j).populations.get(k).nodes.size();
											for (int l = 0; l < input.loci.get(j).populations.get(k).nodes.size(); l++)
												{
													boolean newHaplotype = true;
													for (int m = 0; m < haplotypes.size(); m++)
														{
															if (haplotypes.get(m).intValue() == input.loci.get(j).populations.get(k).nodes.get(l).haplotypeID)
																{
																	newHaplotype = false;
																	ArrayList<Integer> buffer = new ArrayList<Integer>();
																	for (int n = 0; n < nberOfHaplotypes.size(); n++)
																		{
																			if (n == m)
																				{
																					int a = nberOfHaplotypes.get(n) + 1;
																					Integer integer1 = new Integer(a);
																					buffer.add(integer1);
																				}
																			else
																				{
																					buffer.add(nberOfHaplotypes.get(n));
																				}
																		}
																	nberOfHaplotypes = new ArrayList<Integer>();
																	nberOfHaplotypes.addAll(buffer);
																}
														}
													if (newHaplotype == true)
														{
															Integer integer2 = new Integer(input.loci.get(j).populations.get(k).nodes.get(l).haplotypeID);
															haplotypes.add(integer2);
															Integer integer3 = new Integer(1);
															nberOfHaplotypes.add(integer3);
														}
												}
										}
								}
							newLine = newLine + "	" + numberOfGeneCopies;
							if (haplotypes.size() < 1)
								{
									newLine = newLine + "	-";
								}
							else
								{
									newLine = newLine + "	" + haplotypes.get(0).intValue();
									if (nberOfHaplotypes.get(0).intValue() > 1)
										{
											newLine = newLine + "(" + nberOfHaplotypes.get(0).intValue() + ")";
										}
									for (int k = 1; k < haplotypes.size(); k++)
										{
											newLine = newLine + ", " + haplotypes.get(k).intValue();
											if (nberOfHaplotypes.get(k).intValue() > 1)
												{
													newLine = newLine + "(" + nberOfHaplotypes.get(k).intValue() + ")";
												}
										}
								}
						}
					externalMessage.add(newLine);
				}
			
			boolean sameNumberOfSequencesPerIndividual = true;
			for (int i = 0; i < input.loci.size(); i++)
				{
					for (int j = 0; j < input.loci.get(i).populations.size(); j++)
						{
							for (int k = 0; k < input.loci.get(i).populations.get(j).individuals.size(); k++)
								{
									if (input.loci.get(i).populations.get(j).individuals.get(k).nodes.size() < (int) input.loci.get(i).ploidy)
										{
											sameNumberOfSequencesPerIndividual = false;
										}
								}
						}
				}
			if (sameNumberOfSequencesPerIndividual == false)
				{
					externalMessage.add("");
					String warning1 = new String(); String warning2 = new String();
					warning1 = "There is a problem with the input file conversion(s).";
					warning2 = "Please verify that you have the same number of sequences per individual per locus.";
					externalMessage.add(warning1); externalMessage.add(warning2);
					simTestThread.run("   of sequences per individual per locus.");
					simTestThread.run("   Please verify that you have the same number");
					simTestThread.run("There is a problem with the input file conversion(s).");
				}
			
			if (input.ploidy == false)
				{
					externalMessage.add(""); String warning1 = new String();
					warning1 = "Input file conversion requires that the ploidy level is specified in the Phylip input files.";
					externalMessage.add(warning1);
					simTestThread.run("   is specified in the Phylip input files.");
					simTestThread.run("Input file conversion requires that the ploidy level");
				}
			else if (samePloidy == false)
				{
					externalMessage.add("");
					String warning1 = new String(); String warning2 = new String();
					warning1 = "There is a problem with the input file conversion(s).";
					warning2 = "Input files conversions require that the different loci all present the same ploidy level.";
					externalMessage.add(warning1); externalMessage.add(warning2);
					simTestThread.run("   loci all present the same ploidy level.");
					simTestThread.run("Input files conversions require that the different");
					simTestThread.run("There is a problem with the input conversion.");
				}
			else if (sameNumberOfSequencesPerIndividual == true)
				{
					double haplotypeIDStringSize = 10;
					for (int i = 1; i < numberOfDigits; i++)
						{
							haplotypeIDStringSize = haplotypeIDStringSize*10;
						}
					for (int i = 0; i < input.loci.size(); i++)
						{
							for (int j = 0; j < input.loci.get(i).populations.size(); j++)
								{
									for (int k = 0; k < input.loci.get(i).populations.get(j).nodes.size(); k++)
										{
											String zeroString = new String();
											if (input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID < (haplotypeIDStringSize/10))
												{
													zeroString = "0";
													if (input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID < (haplotypeIDStringSize/100))
														{
															zeroString = "00";
															if (input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID < (haplotypeIDStringSize/1000))
																{
																	zeroString = "000";
																	if (input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID < (haplotypeIDStringSize/10000))
																		{
																			zeroString = "0000";
																		}
																}
														}
												}
											input.loci.get(i).populations.get(j).nodes.get(k).haplotypeIDString = zeroString + input.loci.get(i).populations.get(j).nodes.get(k).haplotypeID;
										}
								}
						}
					
					// Creation of the individuals list with haplotype numbers for SPAGeDi:
					if (window.checkBoxSpagedi.isSelected())
						{
							if (samePloidy == false)
								{
									externalMessage.add("");
									String warning1 = new String(); String warning2 = new String();
									warning1 = "There is a problem with the SPAGeDi input file conversion(s).";
									warning2 = "Input files conversions for SPAGeDi require that the different loci all present the same ploidy level.";
									externalMessage.add(warning1); externalMessage.add(warning2);
									simTestThread.run("   different loci all present the same ploidy level.");
									simTestThread.run("Input files conversions for SPAGeDi require that the");
									simTestThread.run("There is a problem with the SPAGeDi input conversion.");
								}
							else 
								{
									simTestThread.run("Input file conversion for SPAGeDi");
									externalMessage.add("");
									externalMessage.add("");
									externalMessage.add("List of individuals for SPAGeDi inputs (Hardy & Vekemans, 2002):");
									externalMessage.add("");
									for (int i = 0; i < input.loci.size(); i++)
										{
											for (int j = 0; j < input.loci.get(i).populations.size(); j++)
												{
													for (int k = 0; k < input.loci.get(i).populations.get(j).individuals.size(); k++)
														{
															input.loci.get(i).populations.get(j).individuals.get(k).useOfIndividual = false;
														}
												}
										}						
									ArrayList<String> buffer = new ArrayList<String>();
									ArrayList<String> externalFile1 = new ArrayList<String>();
									ArrayList<String> externalFile2 = new ArrayList<String>();
									int individualsCounter = 0;
									for (int i = 0; i < input.loci.get(0).populations.size(); i++)
										{
											for (int j = 0; j < input.loci.get(0).populations.get(i).individuals.size(); j++)
												{
													individualsCounter = individualsCounter + 1;
													String line = new String();
													line = input.loci.get(0).populations.get(i).individuals.get(j).indName;
													line = line + "-" + input.loci.get(0).populations.get(i).popName;
													line = line + "	" + input.loci.get(0).populations.get(i).popName;
													line = line + "	" + (float) input.loci.get(0).populations.get(i).position[0];
													line = line + "	" + (float) input.loci.get(0).populations.get(i).position[1];
													line = line + "	";
													for (int k = 0; k < (int) input.loci.get(0).ploidy; k++)
														{
															line = line + input.loci.get(0).populations.get(i).individuals.get(j).nodes.get(k).haplotypeIDString;
														}
													input.loci.get(0).populations.get(i).individuals.get(j).useOfIndividual = true;
													for (int k = 1; k < input.loci.size(); k++)
														{
															boolean correspondantHaplotype = false;
															for (int l = 0; l < input.loci.get(k).populations.size(); l++)
																{
																	if (input.loci.get(k).populations.get(l).popName.equals(input.loci.get(0).populations.get(i).popName))
																		{
																			for (int m = 0; m < input.loci.get(k).populations.get(l).individuals.size(); m++)
																				{
																					if (input.loci.get(k).populations.get(l).individuals.get(m).indName.equals(input.loci.get(0).populations.get(i).individuals.get(j).indName))
																						{
																							line = line + "	";
																							for (int n = 0; n < (int) input.loci.get(0).ploidy; n++)
																								{
																									line = line + input.loci.get(k).populations.get(l).individuals.get(m).nodes.get(n).haplotypeIDString;
																								}
																							input.loci.get(k).populations.get(l).individuals.get(m).useOfIndividual = true;
																							correspondantHaplotype = true;
																						}
																				}
																		}
																}
															if (correspondantHaplotype == false)
																{
																	line = line + "	" + 0;
																}
														}							
													buffer.add(line);
													externalFile1.add(line);
												}
											for (int j = 1; j < input.loci.size(); j++)
												{
													for (int k = 0; k < input.loci.get(j).populations.size(); k++)
														{
															if (input.loci.get(j).populations.get(k).popName.equals(input.loci.get(0).populations.get(i).popName))
																{
																	for (int l = 0; l < input.loci.get(j).populations.get(k).individuals.size(); l++)
																		{
																			if (input.loci.get(j).populations.get(k).individuals.get(l).useOfIndividual == false)
																				{
																					individualsCounter = individualsCounter + 1;
																					String line = new String();
																					line = input.loci.get(j).populations.get(k).individuals.get(l).indName;
																					line = line + "-" + input.loci.get(j).populations.get(k).popName;
																					line = line + "	" + input.loci.get(j).populations.get(k).popName;
																					line = line + "	" + (float) input.loci.get(j).populations.get(k).position[0];
																					line = line + "	" + (float) input.loci.get(j).populations.get(k).position[1];
																					for (int m = 0; m < j; m++)
																						{
																							line = line + "	" + 0;
																						}
																					line = line + "	";
																					for (int m = 0; m < (int) input.loci.get(j).ploidy; m++)
																						{
																							line = line + input.loci.get(j).populations.get(k).individuals.get(l).nodes.get(m).haplotypeIDString;
																						}
																					input.loci.get(j).populations.get(k).individuals.get(l).useOfIndividual = true;
																					for (int m = (j+1); m < input.loci.size(); m++)
																						{
																							boolean correspondantHaplotype1 = false;
																							for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																								{
																									if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																										{
																											for (int o = 0; o < input.loci.get(m).populations.get(n).individuals.size(); o++)
																												{
																													if (input.loci.get(m).populations.get(n).individuals.get(o).indName.equals(input.loci.get(j).populations.get(k).individuals.get(l).indName))
																														{
																															line = line + "	";
																															for (int p = 0; p < (int) input.loci.get(0).ploidy; p++)
																																{
																																	line = line + (String) input.loci.get(m).populations.get(n).individuals.get(o).nodes.get(p).haplotypeIDString;
																																}
																															input.loci.get(m).populations.get(n).individuals.get(o).useOfIndividual = true;
																															correspondantHaplotype1 = true;
																														}
																												}
																										}
																								}
																							if (correspondantHaplotype1 == false)
																								{
																									line = line + "	" + 0;
																								}
																						}
																					buffer.add(line);
																					externalFile1.add(line);
																				}
																		}
																}
														}
												}
										}
									for (int j = 1; j < input.loci.size(); j++)
										{
											for (int k = 0; k < input.loci.get(j).populations.size(); k++)
												{
													for (int l = 0; l < input.loci.get(j).populations.get(k).individuals.size(); l++)
														{
															if (input.loci.get(j).populations.get(k).individuals.get(l).useOfIndividual == false)
																{
																	individualsCounter = individualsCounter + 1;
																	String line = new String();
																	line = input.loci.get(j).populations.get(k).individuals.get(l).indName;
																	line = line + "-" + input.loci.get(j).populations.get(k).popName;
																	line = line + "	" + input.loci.get(j).populations.get(k).popName;
																	line = line + "	" + (float) input.loci.get(j).populations.get(k).position[0];
																	line = line + "	" + (float) input.loci.get(j).populations.get(k).position[1];
																	for (int m = 0; m < j; m++)
																		{
																			line = line + "	" + 0;
																		}
																	line = line + "	";
																	for (int m = 0; m < (int) input.loci.get(j).ploidy; m++)
																		{
																			line = line + input.loci.get(j).populations.get(k).individuals.get(l).nodes.get(m).haplotypeIDString;
																		}
																	input.loci.get(j).populations.get(k).individuals.get(l).useOfIndividual = true;
																	for (int m = (j+1); m < input.loci.size(); m++)
																		{
																			boolean correspondantHaplotype1 = false;
																			for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																				{
																					if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																						{
																							for (int o = 0; o < input.loci.get(m).populations.get(n).individuals.size(); o++)
																								{
																									if (input.loci.get(m).populations.get(n).individuals.get(o).indName.equals(input.loci.get(j).populations.get(k).individuals.get(l).indName))
																										{
																											line = line + "	";
																											for (int p = 0; p < (int) input.loci.get(0).ploidy; p++)
																												{
																													line = line + (String) input.loci.get(m).populations.get(n).individuals.get(o).nodes.get(p).haplotypeIDString;
																												}
																											input.loci.get(m).populations.get(n).individuals.get(o).useOfIndividual = true;
																											correspondantHaplotype1 = true;
																										}
																								}
																						}
																				}
																			if (correspondantHaplotype1 == false)
																				{
																					line = line + "	" + 0;
																				}
																		}
																	buffer.add(line);
																	externalFile1.add(line);
																}
														}
												}
										}
									
									int maxNberOfPops = input.loci.get(0).populations.size();
									for (int i = 1; i < input.loci.size(); i++)
										{
											if (input.loci.get(i).populations.size() > maxNberOfPops)
												{
													maxNberOfPops = input.loci.get(i).populations.size();
												}
										}
										
									String firstLine1a = new String();
									firstLine1a = individualsCounter + "	" + maxNberOfPops + "	" + 2 + "	" + input.loci.size() + "	" + numberOfDigits + "	" + (int) ploidyLevel;
									externalMessage.add(firstLine1a);
									externalFile2.add(firstLine1a);
									String firstLine1b = new String();
									firstLine1b = "# (add here the different distances intervals)";
									externalMessage.add(firstLine1b);
									externalFile2.add(firstLine1b);
									String firstLine1c = new String();
									firstLine1c = "Ind	Pop	Lat	Lon";
									for (int i = 0; i < input.loci.size(); i++)
										{
											firstLine1c = firstLine1c + "	locus" + (i+1);
										}
									externalMessage.add(firstLine1c);
									externalFile2.add(firstLine1c);
									for (int i = 0; i < buffer.size(); i++)
										{
											externalMessage.add(buffer.get(i));
											externalFile2.add(externalFile1.get(i));
										}
										
									externalMessage.add("");
									externalMessage.add("Allelic distances matrices:");
									externalFile2.add("END");
									for (int i = 0; i < input.loci.size(); i++)
										{
											double[][] allelicDistances = new double[lociHaplotypes.get(i).size()][lociHaplotypes.get(i).size()];
											for (int j = 0; j < lociHaplotypes.get(i).size(); j++)
												{
													for (int k = 0; k < lociHaplotypes.get(i).size(); k++)
														{
															double a = 0;	
															a = input.loci.get(i).nodesMismatches[lociHaplotypes.get(i).get(j).nodeMismatchesIndex][lociHaplotypes.get(i).get(k).nodeMismatchesIndex];
															a = a/(input.loci.get(i).polymorphicSites);
															allelicDistances[j][k] = a;
														}
												}
											externalMessage.add("");
											String firstLine1d = new String();
											String newLine1 = new String();
											firstLine1d = "locus" + (i+1);
											for (int j = 0; j < lociHaplotypes.get(i).size(); j++)
												{
													firstLine1d = firstLine1d + "	" + (j+1);
												}
											externalMessage.add(firstLine1d);
											externalFile2.add(firstLine1d);
											for (int j = 0; j < lociHaplotypes.get(i).size(); j++)
												{
													newLine1 = new String();
													newLine1 = newLine1 + (j+1);
													for (int k = 0; k < lociHaplotypes.get(i).size(); k++)
														{
															newLine1 = newLine1 + "	" + (float) allelicDistances[j][k];
														}
													externalMessage.add(newLine1);
													externalFile2.add(newLine1);
												}
										}
									OutputFileWriter.writeOutput1(externalFile2, window.getInputName() + "_SPAGeDi_input.txt");
								}
						}
					
					// Creation of the individuals list with haplotype numbers for STRUCTURE:
					if (window.checkBoxStructure.isSelected())
						{
							simTestThread.run("Input file conversion for STRUCTURE");
							externalMessage.add("");
							externalMessage.add("");
							externalMessage.add("List of individuals for STRUCTURE inputs (Pritchard et al, 2000):");
							externalMessage.add("	(you have to remove the first line)");
							externalMessage.add("");
							for (int i = 0; i < input.loci.size(); i++)
								{
									for (int j = 0; j < input.loci.get(i).populations.size(); j++)
										{
											for (int k = 0; k < input.loci.get(i).populations.get(j).individuals.size(); k++)
												{
													input.loci.get(i).populations.get(j).individuals.get(k).useOfIndividual = false;
												}
										}
								}
							// Creation of the first line:
							String firstLine = new String();
							firstLine = "ID	Pop	Group";
							for (int i = 0; i < input.loci.size(); i++)
								{
									firstLine = firstLine + " locus" + (i+1);
								}
							externalMessage.add(firstLine);
							ArrayList<String> buffer = new ArrayList<String>();
							int individualsCounter = 0;
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(0).populations.get(i).individualsGhosts.size(); j++)
										{
											individualsCounter = individualsCounter + 1;
											ArrayList<String> lines = new ArrayList<String>(); // for the Message file
											for (int k = 0; k < ploidyMax; k++)
												{
													String line = new String();
													line = input.loci.get(0).populations.get(i).individualsGhosts.get(j).indName;
													line = line + "-" + input.loci.get(0).populations.get(i).popName;
													line = line + " " + input.loci.get(0).populations.get(i).popName;
													line = line + " " + input.loci.get(0).populations.get(i).popName;
													lines.add(line);
												}
											ArrayList<String> linesBuffer = new ArrayList<String>();
											for (int k = 0; k < ploidyMax; k++)
												{
													String line = new String();
													line = lines.get(k) + " " + input.loci.get(0).populations.get(i).individualsGhosts.get(j).nodes.get(k).haplotypeID;
													linesBuffer.add(line);
												}
											lines = new ArrayList<String>(); lines.addAll(linesBuffer);
											input.loci.get(0).populations.get(i).individualsGhosts.get(j).useOfIndividual = true;
											for (int k = 1; k < input.loci.size(); k++)
												{
													boolean correspondantHaplotype = false;
													for (int l = 0; l < input.loci.get(k).populations.size(); l++)
														{
															if (input.loci.get(k).populations.get(l).popName.equals(input.loci.get(0).populations.get(i).popName))
																{
																	for (int m = 0; m < input.loci.get(k).populations.get(l).individualsGhosts.size(); m++)
																		{
																			if (input.loci.get(k).populations.get(l).individualsGhosts.get(m).indName.equals(input.loci.get(0).populations.get(i).individualsGhosts.get(j).indName))
																				{
																					linesBuffer = new ArrayList<String>();
																					for (int n = 0; n < ploidyMax; n++)
																						{
																							String line = new String();
																							line = lines.get(n) + " " + input.loci.get(k).populations.get(l).individualsGhosts.get(m).nodes.get(n).haplotypeID;
																							linesBuffer.add(line);
																						}
																					lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																					input.loci.get(k).populations.get(l).individualsGhosts.get(m).useOfIndividual = true;
																					correspondantHaplotype = true;
																				}
																		}
																}
														}
													if (correspondantHaplotype == false)
														{
															linesBuffer = new ArrayList<String>();
															for (int l = 0; l < ploidyMax; l++)
																{
																	String line = new String();
																	line = lines.get(l) + " " + "-9";
																	linesBuffer.add(line);
																}
															lines = new ArrayList<String>(); lines.addAll(linesBuffer);
														}
												}
											buffer.addAll(lines);
										}
									for (int j = 1; j < input.loci.size(); j++)
										{
											for (int k = 0; k < input.loci.get(j).populations.size(); k++)
												{
													if (input.loci.get(j).populations.get(k).popName.equals(input.loci.get(0).populations.get(i).popName))
														{
															for (int l = 0; l < input.loci.get(j).populations.get(k).individualsGhosts.size(); l++)
																{
																	if (input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual == false)
																		{
																			individualsCounter = individualsCounter + 1;
																			ArrayList<String> lines = new ArrayList<String>(); // for the Message file
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line = new String();
																					line = input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName;
																					line = line + "-" + input.loci.get(j).populations.get(k).popName;
																					line = line + " " + input.loci.get(j).populations.get(k).popName;
																					line = line + " " + input.loci.get(j).populations.get(k).popName;
																					lines.add(line);
																				}
																			ArrayList<String> linesBuffer = new ArrayList<String>();
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line = new String();
																					line = lines.get(m);
																					for (int n = 0; n < j; n++)
																						{
																							if (n == 0)
																								{
																									line = line + "-9";
																								}
																							else
																								{	
																									line = line + " " + "-9";	
																								}
																						}
																					linesBuffer.add(line);
																				}
																			lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																			linesBuffer = new ArrayList<String>();
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line = new String();
																					line = lines.get(m) + " " + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeID;
																					linesBuffer.add(line);
																				}
																			lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																			input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual = true;
																			for (int m = (j+1); m < input.loci.size(); m++)
																				{
																					boolean correspondantHaplotype = false;
																					for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																						{
																							if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																								{
																									for (int o = 0; o < input.loci.get(m).populations.get(n).individualsGhosts.size(); o++)
																										{
																											if (input.loci.get(m).populations.get(n).individualsGhosts.get(o).indName.equals(input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName))
																												{
																													linesBuffer = new ArrayList<String>();
																													for (int p = 0; p < ploidyMax; p++)
																														{
																															String line = new String();
																															line = lines.get(p) + " " + input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeID;
																															linesBuffer.add(line);
																														}
																													lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																													input.loci.get(m).populations.get(n).individualsGhosts.get(o).useOfIndividual = true;
																													correspondantHaplotype = true;
																												}
																										}
																								}
																						}
																					if (correspondantHaplotype == false)
																						{
																							linesBuffer = new ArrayList<String>();
																							for (int n = 0; n < ploidyMax; n++)
																								{
																									String line = new String();;
																									line = lines.get(n) + " " + "-9";
																									linesBuffer.add(line);
																								}
																							lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																						}
																				}
																			buffer.addAll(lines);
																		}
																}
														}
												}
										}
								}
							for (int j = 1; j < input.loci.size(); j++)
								{
									for (int k = 0; k < input.loci.get(j).populations.size(); k++)
										{
											for (int l = 0; l < input.loci.get(j).populations.get(k).individualsGhosts.size(); l++)
												{
													if (input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual == false)
														{
															individualsCounter = individualsCounter + 1;
															ArrayList<String> lines = new ArrayList<String>(); // for the Message file
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line = new String();
																	line = input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName;
																	line = line + "-" + input.loci.get(j).populations.get(k).popName;
																	line = line + " " + input.loci.get(j).populations.get(k).popName;
																	line = line + " " + input.loci.get(j).populations.get(k).popName;
																	lines.add(line);
																}
															ArrayList<String> linesBuffer = new ArrayList<String>();
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line = new String();
																	line = lines.get(m);
																	for (int n = 0; n < j; n++)
																		{
																			if (n == 0)
																				{
																					line = line + "-9";
																				}
																			else
																				{	
																					line = line + " " + "-9";	
																				}
																		}
																	linesBuffer.add(line);
																}
															lines = new ArrayList<String>(); lines.addAll(linesBuffer);
															linesBuffer = new ArrayList<String>();
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line = new String();
																	line = lines.get(m) + " " + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeID;
																	linesBuffer.add(line);
																}
															lines = new ArrayList<String>(); lines.addAll(linesBuffer);
															input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual = true;
															for (int m = (j+1); m < input.loci.size(); m++)
																{
																	boolean correspondantHaplotype = false;
																	for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																		{
																			if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																				{
																					for (int o = 0; o < input.loci.get(m).populations.get(n).individualsGhosts.size(); o++)
																						{
																							if (input.loci.get(m).populations.get(n).individualsGhosts.get(o).indName.equals(input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName))
																								{
																									linesBuffer = new ArrayList<String>();
																									for (int p = 0; p < ploidyMax; p++)
																										{
																											String line = new String();
																											line = lines.get(p) + " " + input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeID;
																											linesBuffer.add(line);
																										}
																									lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																									input.loci.get(m).populations.get(n).individualsGhosts.get(o).useOfIndividual = true;
																									correspondantHaplotype = true;
																								}
																						}
																				}
																		}
																	if (correspondantHaplotype == false)
																		{
																			linesBuffer = new ArrayList<String>();
																			for (int n = 0; n < ploidyMax; n++)
																				{
																					String line = new String();
																					line = lines.get(n) + " " + "-9";
																					linesBuffer.add(line);
																				}
																			lines = new ArrayList<String>(); lines.addAll(linesBuffer);
																		}
																}
															buffer.addAll(lines);
														}
												}
										}
								}
							externalMessage.addAll(buffer);
							OutputFileWriter.writeOutput1(buffer, window.getInputName() + "_Structure_input.txt");
						}
					
					// Creation of the individuals list with haplotype numbers for BAPS:
					if (window.checkBoxBAPS.isSelected())
						{
							simTestThread.run("Input file conversion for BAPS");
							externalMessage.add("");
							externalMessage.add("");
							externalMessage.add("BAPS input for the spatial clustering of individuals based on allelic frequencies (Corander et al, 2003, 2004, 2008a):");
							externalMessage.add("	(you have to remove the first column)");
							externalMessage.add("");
							for (int i = 0; i < input.loci.size(); i++)
								{
									for (int j = 0; j < input.loci.get(i).populations.size(); j++)
										{
											for (int k = 0; k < input.loci.get(i).populations.get(j).individualsGhosts.size(); k++)
												{
													input.loci.get(i).populations.get(j).individualsGhosts.get(k).useOfIndividual = false;
												}
										}
								}
							ArrayList<String> coordinates = new ArrayList<String>();
							ArrayList<String> buffer1 = new ArrayList<String>(); // for the Message file
							ArrayList<String> buffer2 = new ArrayList<String>(); // for the input file building
							int individualsCounter = 0;
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(0).populations.get(i).individualsGhosts.size(); j++)
										{
											individualsCounter = individualsCounter + 1;
											ArrayList<String> lines1 = new ArrayList<String>(); // for the Message file
											ArrayList<String> lines2 = new ArrayList<String>(); // for the input file building
											for (int k = 0; k < ploidyMax; k++)
												{
													String line1 = new String(); String line2 = new String();
													line1 = input.loci.get(0).populations.get(i).individualsGhosts.get(j).indName;
													line1 = line1 + "-" + input.loci.get(0).populations.get(i).popName + "	";
													lines1.add(line1); lines2.add(line2);
												}
											ArrayList<String> lines1Buffer = new ArrayList<String>();
											ArrayList<String> lines2Buffer = new ArrayList<String>();
											for (int k = 0; k < ploidyMax; k++)
												{
													String line1 = new String(); String line2 = new String();
													line1 = lines1.get(k) + input.loci.get(0).populations.get(i).individualsGhosts.get(j).nodes.get(k).haplotypeID;
													line2 = lines2.get(k) + input.loci.get(0).populations.get(i).individualsGhosts.get(j).nodes.get(k).haplotypeID;
													lines1Buffer.add(line1); lines2Buffer.add(line2);
												}
											lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
											lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
											input.loci.get(0).populations.get(i).individualsGhosts.get(j).useOfIndividual = true;
											for (int k = 1; k < input.loci.size(); k++)
												{
													boolean correspondantHaplotype = false;
													for (int l = 0; l < input.loci.get(k).populations.size(); l++)
														{
															if (input.loci.get(k).populations.get(l).popName.equals(input.loci.get(0).populations.get(i).popName))
																{
																	for (int m = 0; m < input.loci.get(k).populations.get(l).individualsGhosts.size(); m++)
																		{
																			if (input.loci.get(k).populations.get(l).individualsGhosts.get(m).indName.equals(input.loci.get(0).populations.get(i).individualsGhosts.get(j).indName))
																				{
																					lines1Buffer = new ArrayList<String>();
																					lines2Buffer = new ArrayList<String>();
																					for (int n = 0; n < ploidyMax; n++)
																						{
																							String line1 = new String(); String line2 = new String();
																							line1 = lines1.get(n) + "	" + input.loci.get(k).populations.get(l).individualsGhosts.get(m).nodes.get(n).haplotypeID;
																							line2 = lines2.get(n) + "	" + input.loci.get(k).populations.get(l).individualsGhosts.get(m).nodes.get(n).haplotypeID;
																							lines1Buffer.add(line1); lines2Buffer.add(line2);
																						}
																					lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																					lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																					input.loci.get(k).populations.get(l).individualsGhosts.get(m).useOfIndividual = true;
																					correspondantHaplotype = true;
																				}
																		}
																}
														}
													if (correspondantHaplotype == false)
														{
															lines1Buffer = new ArrayList<String>();
															lines2Buffer = new ArrayList<String>();
															for (int l = 0; l < ploidyMax; l++)
																{
																	String line1 = new String(); String line2 = new String();
																	line1 = lines1.get(l) + "	" + "-9";
																	line2 = lines2.get(l) + "	" + "-9";
																	lines1Buffer.add(line1); lines2Buffer.add(line2);
																}
															lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
															lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
														}
												}
											lines1Buffer = new ArrayList<String>();
											lines2Buffer = new ArrayList<String>();
											for (int k = 0; k < ploidyMax; k++)
												{
													String line1 = new String(); String line2 = new String();
													line1 = lines1.get(k) + "	" + (individualsCounter);
													line2 = lines2.get(k) + "	" + (individualsCounter);
													lines1Buffer.add(line1); lines2Buffer.add(line2);
												}
											lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
											lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
											buffer1.addAll(lines1);
											buffer2.addAll(lines2);
											coordinates.add(input.loci.get(0).populations.get(i).position[1] + "	" + input.loci.get(0).populations.get(i).position[0]);
										}
									for (int j = 1; j < input.loci.size(); j++)
										{
											for (int k = 0; k < input.loci.get(j).populations.size(); k++)
												{
													if (input.loci.get(j).populations.get(k).popName.equals(input.loci.get(0).populations.get(i).popName))
														{
															for (int l = 0; l < input.loci.get(j).populations.get(k).individualsGhosts.size(); l++)
																{
																	if (input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual == false)
																		{
																			individualsCounter = individualsCounter + 1;
																			ArrayList<String> lines1 = new ArrayList<String>(); // for the Message file
																			ArrayList<String> lines2 = new ArrayList<String>(); // for the input file building
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line1 = new String(); String line2 = new String();
																					line1 = input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName;
																					line1 = line1 + "-" + input.loci.get(j).populations.get(k).popName + "	";
																					lines1.add(line1); lines2.add(line2);
																				}
																			ArrayList<String> lines1Buffer = new ArrayList<String>();
																			ArrayList<String> lines2Buffer = new ArrayList<String>();
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line1 = new String(); String line2 = new String();
																					line1 = lines1.get(m); line2 = lines2.get(m);
																					for (int n = 0; n < j; n++)
																						{
																							if (n == 0)
																								{
																									line1 = line1 + "-9";
																									line2 = line2 + "-9";
																								}
																							else
																								{
																									line1 = line1 + "	" + "-9";
																									line2 = line2 + "	" + "-9";
																								}
																						}
																					 lines1Buffer.add(line1); lines2Buffer.add(line2);
																				}
																			lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																			lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																			lines1Buffer = new ArrayList<String>();
																			lines2Buffer = new ArrayList<String>();
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line1 = new String(); String line2 = new String();
																					line1 = lines1.get(m) + "	" + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeID;
																					line2 = lines2.get(m) + "	" + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeID;
																					lines1Buffer.add(line1); lines2Buffer.add(line2);
																				}
																			lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																			lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																			input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual = true;
																			for (int m = (j+1); m < input.loci.size(); m++)
																				{
																					boolean correspondantHaplotype = false;
																					for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																						{
																							if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																								{
																									for (int o = 0; o < input.loci.get(m).populations.get(n).individualsGhosts.size(); o++)
																										{
																											if (input.loci.get(m).populations.get(n).individualsGhosts.get(o).indName.equals(input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName))
																												{
																													lines1Buffer = new ArrayList<String>();
																													lines2Buffer = new ArrayList<String>();
																													for (int p = 0; p < ploidyMax; p++)
																														{
																															String line1 = new String(); String line2 = new String();
																															line1 = lines1.get(p) + "	" + input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeID;
																															line2 = lines2.get(p) + "	" + input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeID;
																															lines1Buffer.add(line1); lines2Buffer.add(line2);
																														}
																													lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																													lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																													input.loci.get(m).populations.get(n).individualsGhosts.get(o).useOfIndividual = true;
																													correspondantHaplotype = true;
																												}
																										}
																								}
																						}
																					if (correspondantHaplotype == false)
																						{
																							lines1Buffer = new ArrayList<String>();
																							lines2Buffer = new ArrayList<String>();
																							for (int n = 0; n < ploidyMax; n++)
																								{
																									String line1 = new String(); String line2 = new String();
																									line1 = lines1.get(n) + "	" + "-9";
																									line2 = lines2.get(n) + "	" + "-9";
																									lines1Buffer.add(line1); lines2Buffer.add(line2);
																								}
																							lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																							lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																						}
																				}
																			lines1Buffer = new ArrayList<String>();
																			lines2Buffer = new ArrayList<String>();
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					String line1 = new String(); String line2 = new String();
																					line1 = lines1.get(m) + "	" + (individualsCounter);
																					line2 = lines2.get(m) + "	" + (individualsCounter);
																					lines1Buffer.add(line1); lines2Buffer.add(line2);
																				}
																			lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																			lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																			buffer1.addAll(lines1);
																			buffer2.addAll(lines2);
																			coordinates.add(input.loci.get(j).populations.get(k).position[1] + "	" + input.loci.get(j).populations.get(k).position[0]);
																		}
																}
														}
												}
										}
								}
							for (int j = 1; j < input.loci.size(); j++)
								{
									for (int k = 0; k < input.loci.get(j).populations.size(); k++)
										{
											for (int l = 0; l < input.loci.get(j).populations.get(k).individualsGhosts.size(); l++)
												{
													if (input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual == false)
														{
															individualsCounter = individualsCounter + 1;
															ArrayList<String> lines1 = new ArrayList<String>(); // for the Message file
															ArrayList<String> lines2 = new ArrayList<String>(); // for the input file building
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line1 = new String(); String line2 = new String();
																	line1 = input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName;
																	line1 = line1 + "-" + input.loci.get(j).populations.get(k).popName + "	";
																	lines1.add(line1); lines2.add(line2);
																}
															ArrayList<String> lines1Buffer = new ArrayList<String>();
															ArrayList<String> lines2Buffer = new ArrayList<String>();
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line1 = new String(); String line2 = new String();
																	line1 = lines1.get(m); line2 = lines2.get(m);
																	for (int n = 0; n < j; n++)
																		if (n == 0)
																			{
																				line1 = line1 + "-9";
																				line2 = line2 + "-9";
																			}
																		else
																			{
																				line1 = line1 + "	" + "-9";
																				line2 = line2 + "	" + "-9";
																			}
																	lines1Buffer.add(line1); lines2Buffer.add(line2);
																}
															lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
															lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
															lines1Buffer = new ArrayList<String>();
															lines2Buffer = new ArrayList<String>();
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line1 = new String(); String line2 = new String();
																	line1 = lines1.get(m) + "	" + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeID;
																	line2 = lines2.get(m) + "	" + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeID;
																	lines1Buffer.add(line1); lines2Buffer.add(line2);
																}
															lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
															lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
															input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual = true;
															for (int m = (j+1); m < input.loci.size(); m++)
																{
																	boolean correspondantHaplotype = false;
																	for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																		{
																			if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																				{
																					for (int o = 0; o < input.loci.get(m).populations.get(n).individualsGhosts.size(); o++)
																						{
																							if (input.loci.get(m).populations.get(n).individualsGhosts.get(o).indName.equals(input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName))
																								{
																									lines1Buffer = new ArrayList<String>();
																									lines2Buffer = new ArrayList<String>();
																									for (int p = 0; p < ploidyMax; p++)
																										{
																											String line1 = new String(); String line2 = new String();
																											line1 = lines1.get(p) + "	" + input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeID;
																											line2 = lines2.get(p) + "	" + input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeID;
																											lines1Buffer.add(line1); lines2Buffer.add(line2);
																										}
																									lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																									lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																									input.loci.get(m).populations.get(n).individualsGhosts.get(o).useOfIndividual = true;
																									correspondantHaplotype = true;
																								}
																						}
																				}
																		}
																	if (correspondantHaplotype == false)
																		{
																			lines1Buffer = new ArrayList<String>();
																			lines2Buffer = new ArrayList<String>();
																			for (int n = 0; n < ploidyMax; n++)
																				{
																					String line1 = new String(); String line2 = new String();
																					line1 = lines1.get(n) + "	" + "-9";
																					line2 = lines2.get(n) + "	" + "-9";
																					lines1Buffer.add(line1); lines2Buffer.add(line2);
																				}
																			lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
																			lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
																		}
																}
															lines1Buffer = new ArrayList<String>();
															lines2Buffer = new ArrayList<String>();
															for (int m = 0; m < ploidyMax; m++)
																{
																	String line1 = new String(); String line2 = new String();
																	line1 = lines1.get(m) + "	" + (individualsCounter);
																	line2 = lines2.get(m) + "	" + (individualsCounter);
																	lines1Buffer.add(line1); lines2Buffer.add(line2);
																}
															lines1 = new ArrayList<String>(); lines1.addAll(lines1Buffer);
															lines2 = new ArrayList<String>(); lines2.addAll(lines2Buffer);
															buffer1.addAll(lines1);
															buffer2.addAll(lines2);
															coordinates.add(input.loci.get(j).populations.get(k).position[1] + "	" + input.loci.get(j).populations.get(k).position[0]);
														}
												}
										}
								}
							OutputFileWriter.writeOutput1(buffer2, window.getInputName() + "_BAPS_input_genotypes.txt");
							externalMessage.addAll(buffer1);
							externalMessage.add("");
							externalMessage.add("BAPS coordinates input for the clustering of individuals based on allelic frequencies:");
							externalMessage.add("");
							ArrayList<String> buffer3 = new ArrayList<String>(); // for the input file building
							for (int i = 0; i < coordinates.size(); i++)
								{
									String line = new String();
									line = coordinates.get(i);
									externalMessage.add(line);
									buffer3.add(line);
								}			
							OutputFileWriter.writeOutput1(buffer3, window.getInputName() + "_BAPS_input_coordinates.txt");
							
							externalMessage.add("");
							externalMessage.add("");
							externalMessage.add("BAPS MLST-input for the clustering with linked loci (Corander et al, 2003, 2004, 2008a; Cheng et al, 2013):");
							externalMessage.add("	(you have to remove the first column)");
							externalMessage.add("");
							ArrayList<String> buffer4 = new ArrayList<String>(); // for the input file building
							// creation of the first line:
							String firstLine4 = new String();
							firstLine4 = "ID	ST";
							for (int i = 0; i < input.loci.size(); i++)
								{
									firstLine4 = firstLine4 + "	locus" + (i+1);
								}
							externalMessage.add(firstLine4);
							buffer4.add(firstLine4);
							for (int i = 0; i < input.loci.size(); i++)
								{
									for (int j = 0; j < input.loci.get(i).populations.size(); j++)
										{
											for (int k = 0; k < input.loci.get(i).populations.get(j).nodes.size(); k++)
												{
													input.loci.get(i).populations.get(j).nodes.get(k).useOfHaplotypeID = false;
												}
										}
								}
							
							// Creation of the individuals list with sequences for BAPS:
							individualsCounter = 0;
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(0).populations.get(i).nodes.size(); j++)
										{
											individualsCounter = individualsCounter + 1;
											String line = new String();
											line = input.loci.get(0).populations.get(i).nodes.get(j).nodeName;
											line = line + "-" + input.loci.get(0).populations.get(i).popName;
											line = line + "	" + (individualsCounter);
											line = line + "	" + input.loci.get(0).populations.get(i).nodes.get(j).finalSequence;
											input.loci.get(0).populations.get(i).nodes.get(j).useOfHaplotypeID = true;
											
											for (int k = 1; k < input.loci.size(); k++)
												{
													boolean correspondantHaplotype = false;
													for (int l = 0; l < input.loci.get(k).populations.size(); l++)
														{
															if (input.loci.get(k).populations.get(l).popName.equals(input.loci.get(0).populations.get(i).popName))
																{
																	for (int m = 0; m < input.loci.get(k).populations.get(l).nodes.size(); m++)
																		{
																			if (input.loci.get(k).populations.get(l).nodes.get(m).nodeName.equals(input.loci.get(0).populations.get(i).nodes.get(j).nodeName))
																				{
																					line = line + "	" + input.loci.get(k).populations.get(l).nodes.get(m).finalSequence;
																					input.loci.get(k).populations.get(l).nodes.get(m).useOfHaplotypeID = true;
																					correspondantHaplotype = true;
																				}
																		}
																}
														}
													if (correspondantHaplotype == false)
														{
															line = line + "	";
															for (int l = 0; l < (int) input.loci.get(k).length; l++)
																{
																	line = line + "?";
																}
														}
												}							
											externalMessage.add(line);
											buffer4.add(line);
										}
									for (int j = 1; j < input.loci.size(); j++)
										{
											for (int k = 0; k < input.loci.get(j).populations.size(); k++)
												{
													if (input.loci.get(j).populations.get(k).popName.equals(input.loci.get(0).populations.get(i).popName))
														{
															for (int l = 0; l < input.loci.get(j).populations.get(k).nodes.size(); l++)
																{
																	if (input.loci.get(j).populations.get(k).nodes.get(l).useOfHaplotypeID == false)
																		{
																			individualsCounter = individualsCounter + 1;
																			String line = new String();
																			line = input.loci.get(j).populations.get(k).nodes.get(l).nodeName;
																			line = line + "-" + input.loci.get(j).populations.get(k).popName;
																			line = line + "	" + (individualsCounter);
																			for (int m = 0; m < j; m++)
																				{
																					line = line + "	";
																					for (int n = 0; n < (int) input.loci.get(m).length; n++)
																						{
																							line = line + "?";
																						}
																				}
																			line = line + "	" + input.loci.get(j).populations.get(k).nodes.get(l).finalSequence;
																			input.loci.get(j).populations.get(k).nodes.get(l).useOfHaplotypeID = true;
																			for (int m = (j+1); m < input.loci.size(); m++)
																				{
																					boolean correspondantHaplotype1 = false;
																					for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																						{
																							if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																								{
																									for (int o = 0; o < input.loci.get(m).populations.get(n).nodes.size(); o++)
																										{
																											if (input.loci.get(m).populations.get(n).nodes.get(o).nodeName.equals(input.loci.get(j).populations.get(k).nodes.get(l).nodeName))
																												{
																													line = line + "	" + input.loci.get(m).populations.get(n).nodes.get(o).finalSequence;
																													input.loci.get(m).populations.get(n).nodes.get(o).useOfHaplotypeID = true;
																													correspondantHaplotype1 = true;
																												}
																										}
																								}
																						}
																					if (correspondantHaplotype1 == false)
																						{
																							line = line + "	";
																							for (int n = 0; n < (int) input.loci.get(m).length; n++)
																								{
																									line = line + "?";
																								}
																						}
																				}
																			externalMessage.add(line);
																			buffer4.add(line);
																		}
																}
														}
												}
										}
								}
							for (int j = 1; j < input.loci.size(); j++)
								{
									for (int k = 0; k < input.loci.get(j).populations.size(); k++)
										{
											for (int l = 0; l < input.loci.get(j).populations.get(k).nodes.size(); l++)
												{
													if (input.loci.get(j).populations.get(k).nodes.get(l).useOfHaplotypeID == false)
														{
															individualsCounter = individualsCounter + 1;
															String line = new String();
															line = input.loci.get(j).populations.get(k).nodes.get(l).nodeName;
															line = line + "-" + input.loci.get(j).populations.get(k).popName;
															line = line + "	" + (individualsCounter);
															for (int m = 0; m < j; m++)
																{
																	line = line + "	";
																	for (int n = 0; n < (int) input.loci.get(m).length; n++)
																		{
																			line = line + "?";
																		}
																}
															line = line + "	" + input.loci.get(j).populations.get(k).nodes.get(l).finalSequence;
															input.loci.get(j).populations.get(k).nodes.get(l).useOfHaplotypeID = true;
															for (int m = (j+1); m < input.loci.size(); m++)
																{
																	boolean correspondantHaplotype1 = false;
																	for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																		{
																			if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																				{
																					for (int o = 0; o < input.loci.get(m).populations.get(n).nodes.size(); o++)
																						{
																							if (input.loci.get(m).populations.get(n).nodes.get(o).nodeName.equals(input.loci.get(j).populations.get(k).nodes.get(l).nodeName))
																								{
																									line = line + "	" + input.loci.get(m).populations.get(n).nodes.get(o).finalSequence;
																									input.loci.get(m).populations.get(n).nodes.get(o).useOfHaplotypeID = true;
																									correspondantHaplotype1 = true;
																								}
																						}
																				}
																		}
																	if (correspondantHaplotype1 == false)
																		{
																			line = line + "	";
																			for (int n = 0; n < (int) input.loci.get(m).length; n++)
																				{
																					line = line + "?";
																				}
																		}
																}
															externalMessage.add(line);
															buffer4.add(line);
														}
												}
										}
								}
							try
								{
									HSSFWorkbook workbook = new HSSFWorkbook();
									HSSFSheet sheet = workbook.createSheet(window.getInputName() + "_BAPS_input_MLST.xls");
									ArrayList<String> lineComponents = new ArrayList<String>();
									for (int i = 0; i < buffer4.size(); i++)
										{
											Row row = sheet.createRow(i);
											lineComponents = new ArrayList<String>();
											String[] line = buffer4.get(i).split("[ 	]+");
											for (int j = 0; j < line.length; j++)
												{
													lineComponents.add(line[j]);
												}
											for (int j = 0; j < lineComponents.size(); j++)
												{
													Cell cell = row.createCell(j);
													cell.setCellValue(lineComponents.get(j));
												}
										}
										FileOutputStream out = new FileOutputStream(window.getInputName() + "_BAPS_input_MLST.xls");
										workbook.write(out); out.close();
										// OutputFileWriter.writeOutput1(buffer4, window.getInputName() + "_BAPS_input_MLST.xls");
									}
							catch (Exception e1) 
								{	}
						}
					
					// Creation of the individuals list with haplotype numbers for GENELAND:
					if (window.checkBoxGeneland.isSelected())
						{
							simTestThread.run("Input file conversion for GENELAND");
							externalMessage.add("");
							externalMessage.add("");
							externalMessage.add("List of individuals for GENELAND inputs (Guillot et al, 2005a, 2005b, 2008; Guillot, 2008; Guedj & Guillot, 2011):");
							externalMessage.add("	(you have to remove the first column)");
							externalMessage.add("");
							for (int i = 0; i < input.loci.size(); i++)
								{
									for (int j = 0; j < input.loci.get(i).populations.size(); j++)
										{
											for (int k = 0; k < input.loci.get(i).populations.get(j).individualsGhosts.size(); k++)
												{
													input.loci.get(i).populations.get(j).individualsGhosts.get(k).useOfIndividual = false;
												}
										}
								}
							String zeroString = new String();
							for (int i = 0; i < numberOfDigits; i++)
								{
									zeroString = zeroString + "0";
								}
							for (int i = 0; i < input.loci.size(); i++)
								{
									for (int j = 0; j < input.loci.get(i).populations.size(); j++)			
										{
											for (int k = 0; k < input.loci.get(i).populations.get(j).individualsGhosts.size(); k++)
												{
													for (int l = 0; l < input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.size(); l++)
														{
															if (input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.get(l).haplotypeID == -9)
																{
																	input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.get(l).haplotypeIDString = new String();
																	input.loci.get(i).populations.get(j).individualsGhosts.get(k).nodes.get(l).haplotypeIDString = new String(zeroString);
																}
														}
												}
										}
								}
							ArrayList<String> buffer = new ArrayList<String>();
							ArrayList<String> coordinates = new ArrayList<String>();
							ArrayList<String> externalFile1 = new ArrayList<String>();
							ArrayList<String> externalFile2 = new ArrayList<String>();
							int individualsCounter = 0;
							for (int i = 0; i < input.loci.get(0).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(0).populations.get(i).individualsGhosts.size(); j++)
										{
											individualsCounter = individualsCounter + 1;
											String line0 = new String();
											line0 = input.loci.get(0).populations.get(i).individualsGhosts.get(j).indName;
											line0 = line0 + "-" + input.loci.get(0).populations.get(i).popName + "	";
											String line = new String();
											for (int k = 0; k < ploidyMax; k++)
												{
													if (k == 0)
														{
															line = line + input.loci.get(0).populations.get(i).individualsGhosts.get(j).nodes.get(k).haplotypeIDString;
														}
													else
														{
															line = line + "	" + input.loci.get(0).populations.get(i).individualsGhosts.get(j).nodes.get(k).haplotypeIDString;
														}
												}
											input.loci.get(0).populations.get(i).individualsGhosts.get(j).useOfIndividual = true;
											for (int k = 1; k < input.loci.size(); k++)
												{
													boolean correspondantHaplotype = false;
													for (int l = 0; l < input.loci.get(k).populations.size(); l++)
														{
															if (input.loci.get(k).populations.get(l).popName.equals(input.loci.get(0).populations.get(i).popName))
																{
																	for (int m = 0; m < input.loci.get(k).populations.get(l).individualsGhosts.size(); m++)
																		{
																			if (input.loci.get(k).populations.get(l).individualsGhosts.get(m).indName.equals(input.loci.get(0).populations.get(i).individualsGhosts.get(j).indName))
																				{
																					for (int n = 0; n < ploidyMax; n++)
																						{
																							line = line + "	" + input.loci.get(k).populations.get(l).individualsGhosts.get(m).nodes.get(n).haplotypeIDString;
																						}
																					input.loci.get(k).populations.get(l).individualsGhosts.get(m).useOfIndividual = true;
																					correspondantHaplotype = true;
																				}
																		}
																}
														}
													if (correspondantHaplotype == false)
														{
															for (int l = 0; l < ploidyMax; l++)
																{
																	line = line + "	" + zeroString;
																}
														}
												}							
											buffer.add(line0 + line);
											externalFile1.add(line);
											coordinates.add(input.loci.get(0).populations.get(i).position[1] + "	" + input.loci.get(0).populations.get(i).position[0]);
										}
									for (int j = 1; j < input.loci.size(); j++)
										{
											for (int k = 0; k < input.loci.get(j).populations.size(); k++)
												{
													if (input.loci.get(j).populations.get(k).popName.equals(input.loci.get(0).populations.get(i).popName))
														{
															for (int l = 0; l < input.loci.get(j).populations.get(k).individualsGhosts.size(); l++)
																{
																	if (input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual == false)
																		{
																			individualsCounter = individualsCounter + 1;
																			String line0 = new String();
																			line0 = input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName;
																			line0 = line0 + "-" + input.loci.get(j).populations.get(k).popName + "	";
																			String line = new String();
																			for (int m = 0; m < j; m++)
																				{
																					if (m == 0)
																						{
																							line = line + zeroString;
																							for (int n = 1; n < ploidyMax; n++)
																								{
																									line = line + "	" + zeroString;
																								}
																						}
																					else
																						{
																							for (int n = 0; n < ploidyMax; n++)
																								{
																									line = line + "	" + zeroString;
																								}
																						}
																				}
																			for (int m = 0; m < ploidyMax; m++)
																				{
																					line = line + "	" + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeIDString;
																				}
																			input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual = true;
																			for (int m = (j+1); m < input.loci.size(); m++)
																				{
																					boolean correspondantHaplotype1 = false;
																					for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																						{
																							if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																								{
																									for (int o = 0; o < input.loci.get(m).populations.get(n).individualsGhosts.size(); o++)
																										{
																											if (input.loci.get(m).populations.get(n).individualsGhosts.get(o).indName.equals(input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName))
																												{
																													for (int p = 0; p < ploidyMax; p++)
																														{
																															line = line + "	" + (String) input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeIDString;
																														}
																													input.loci.get(m).populations.get(n).individualsGhosts.get(o).useOfIndividual = true;
																													correspondantHaplotype1 = true;
																												}
																										}
																								}
																						}
																					if (correspondantHaplotype1 == false)
																						{
																							for (int n = 0; n < ploidyMax; n++)
																								{
																									line = line + "	" + zeroString;
																								}
																						}
																				}
																			buffer.add(line0 + line);
																			externalFile1.add(line);
																			coordinates.add(input.loci.get(j).populations.get(k).position[1] + "	" + input.loci.get(j).populations.get(k).position[0]);
																		}
																}
														}
												}
										}
								}
							for (int j = 1; j < input.loci.size(); j++)
								{
									for (int k = 0; k < input.loci.get(j).populations.size(); k++)
										{
											for (int l = 0; l < input.loci.get(j).populations.get(k).individualsGhosts.size(); l++)
												{
													if (input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual == false)
														{
															individualsCounter = individualsCounter + 1;
															String line0 = new String();
															line0 = input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName;
															line0 = line0 + "-" + input.loci.get(j).populations.get(k).popName + "	";
															String line = new String();
															for (int m = 0; m < j; m++)
																{
																	if (m == 0)
																		{
																			line = line + zeroString;
																			for (int n = 1; n < ploidyMax; n++)
																				{
																					line = line + "	" + zeroString;
																				}
																		}
																	else
																		{
																			for (int n = 0; n < ploidyMax; n++)
																				{
																					line = line + "	" + zeroString;
																				}
																		}
																}
															for (int m = 0; m < ploidyMax; m++)
																{
																	line = line + "	" + input.loci.get(j).populations.get(k).individualsGhosts.get(l).nodes.get(m).haplotypeIDString;
																}
															input.loci.get(j).populations.get(k).individualsGhosts.get(l).useOfIndividual = true;
															for (int m = (j+1); m < input.loci.size(); m++)
																{
																	boolean correspondantHaplotype1 = false;
																	for (int n = 0; n < input.loci.get(m).populations.size(); n++)
																		{
																			if (input.loci.get(m).populations.get(n).popName.equals(input.loci.get(j).populations.get(k).popName))
																				{
																					for (int o = 0; o < input.loci.get(m).populations.get(n).individualsGhosts.size(); o++)
																						{
																							if (input.loci.get(m).populations.get(n).individualsGhosts.get(o).indName.equals(input.loci.get(j).populations.get(k).individualsGhosts.get(l).indName))
																								{	
																									for (int p = 0; p < ploidyMax; p++)
																										{
																											line = line + "	" + (String) input.loci.get(m).populations.get(n).individualsGhosts.get(o).nodes.get(p).haplotypeIDString;
																										}
																									input.loci.get(m).populations.get(n).individualsGhosts.get(o).useOfIndividual = true;
																									correspondantHaplotype1 = true;
																								}
																						}
																				}
																		}
																	if (correspondantHaplotype1 == false)
																		{
																			for (int n = 0; n < ploidyMax; n++)
																				{
																					line = line + "	" + zeroString;
																				}
																		}
																}
															buffer.add(line0 + line);
															externalFile1.add(line);
															coordinates.add(input.loci.get(j).populations.get(k).position[1] + "	" + input.loci.get(j).populations.get(k).position[0]);
														}
												}
										}
								}
							OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_Geneland_input_genotype.txt");
							externalMessage.addAll(buffer);
							externalMessage.add("");
							externalMessage.add("GENELAND coordinates input:");
							externalMessage.add("");
							for (int i = 0; i < coordinates.size(); i++)
								{
									String line = new String();
									line = coordinates.get(i);
									externalMessage.add(line);
									externalFile2.add(line);
								}			
							OutputFileWriter.writeOutput1(externalFile2, window.getInputName() + "_Geneland_input_coordinates.txt");
						}
					
					// Creation of the matrix distances for BARRIER:
					if (window.checkBoxMonmonier.isSelected())
						{
							simTestThread.run("Input file creation for BARRIER");
							ArrayList<String> populationsNames = new ArrayList<String>();
							ArrayList<Integer> populationsIndexes = new ArrayList<Integer>();
							for (int h = 0; h < input.loci.size(); h++)
								{
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											boolean newPopName = true;
											for (int j = 0; j < populationsNames.size(); j++)
												{
													if (input.loci.get(h).populations.get(i).popName.equals(populationsNames.get(j)))
														{
															newPopName = false;
														}
												}
											if (newPopName == true)
												{
													populationsNames.add(input.loci.get(h).populations.get(i).popName);
													Integer integer = new Integer(input.loci.get(h).populations.get(i).popDistanceIndex);
													populationsIndexes.add(integer);
												}
										}
								}
							externalMessage.add("");
							externalMessage.add("BARRIER populations coordinates input");
							externalMessage.add("(longitude	latitude):");
							ArrayList<String> externalFile = new ArrayList<String>();
							ArrayList<String> externalFile1 = new ArrayList<String>();
							double[][] populationsCoordinates = new double[populationsNames.size()][2];
							for (int i = 0; i < populationsNames.size(); i++)
								{
									boolean popFound = false;
									String line = new String();	
									for (int h = 0; h < input.loci.size(); h++)
										{
											for (int j = 0; j < input.loci.get(h).populations.size(); j++)
												{
													if (popFound == false & input.loci.get(h).populations.get(j).popName.equals(populationsNames.get(i)))
														{
															popFound = true;
															line = input.loci.get(h).populations.get(j).position[1] + "	" + input.loci.get(h).populations.get(j).position[0];
															populationsCoordinates[i][0] = input.loci.get(h).populations.get(j).position[1];
															populationsCoordinates[i][1] = input.loci.get(h).populations.get(j).position[0];
														}
												}
										}
									externalMessage.add(line);
									externalFile.add(line);
								}
							OutputFileWriter.writeOutput1(externalFile, window.getInputName() + "_Barrier_input_distances.txt");
							
							double[][] geographicalDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
							double[][] geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
							for (int i = 0; i < populationsNames.size(); i++)
								{
									for (int j = 0; j < populationsNames.size(); j++)
										{
											double distance = -1;
											if (input.pairwisePopulationDistances == false)
												{
													double[] position1 = new double[2]; double[] position2 = new double[2];
													position1[0] = populationsCoordinates[i][0]; position1[1] = populationsCoordinates[i][1];
													position2[0] = populationsCoordinates[j][0]; position2[1] = populationsCoordinates[j][1];
													distance = Math.sqrt(((position2[1]-position1[1])*(position2[1]-position1[1])) + ((position2[0]-position1[0])*(position2[0]-position1[0])));
													geographicalDistancesBetweenPopulations[i][j] = distance;
												}
											else
												{
													geographicalDistancesBetweenPopulations[i][j] = input.populationDistances[populationsIndexes.get(i)][populationsIndexes.get(j)];
												}
										}
								}
							
							externalMessage.add("");
							if (input.loci.size() > 1)
								{
									externalMessage.add("BARRIER input, matrix of weighted average pairwise PhiST:");
								}
							else
								{
									externalMessage.add("BARRIER input, matrix of pairwise PhiST (Excoffier et al, 1992):");
								}
							externalFile = new ArrayList<String>(); ArrayList<String> lines = new ArrayList<String>();
							double mFst = 0;
							double mFstN = 0; double mFstD = 0;
							int id1 = -1; int id2 = -1; 
							Double FstN = new Double(0); Double FstD = new Double(0);
							for (int i = 0; i < populationsNames.size(); i++)
								{
									String line = new String();
									for (int j = 0; j < populationsNames.size(); j++)
										{
											mFst = 0;
											mFstN = 0; mFstD = 0;
											for (int h = 0; h < input.loci.size(); h++)
												{
													id1 = -1; id2 = -1;
													for (int k = 0; k < input.loci.get(h).populations.size(); k++)
														{
															if (input.loci.get(h).populations.get(k).popName.equals(populationsNames.get(i)))
																{
																	id1 = k;
																}
															if (input.loci.get(h).populations.get(k).popName.equals(populationsNames.get(j)))
																{
																	id2 = k;
																}
														}
													if ((id1 > -1) & (id2 > -1))
														{
															FstN = new Double(input.loci.get(h).pairwiseFstPopNumerator[id1][id2]);
															FstD = new Double(input.loci.get(h).pairwiseFstPopDenominator[id1][id2]);
															mFstN = mFstN + FstN;
															mFstD = mFstD + FstD;
														}
												}
											mFst = mFstN/mFstD;
											line = line + ((float) mFst) + "	";
										}
									lines.add(line);
								}
							externalMessage.addAll(lines); externalFile.addAll(lines);
							OutputFileWriter.writeOutput1(externalFile, window.getInputName() + "_Barrier_input_matrix_PhiST.txt");
							
							externalMessage.add("");
							externalMessage.add("BARRIER input, matrix of interindividual distances 1 (IID1, distance based on allelic frequencies):");
							if (samePloidy == false)
								{
									externalMessage.add("	this input requires that the different loci all present the same ploidy level.");
								}
							else
								{	
									if (ploidyMax == 1) // haploid case
										{
											externalFile1 = new ArrayList<String>(); ArrayList<String> lines1 = new ArrayList<String>();
											String pop1Name = new String(); ArrayList<ArrayList<Individual>> pop1Individuals = new ArrayList<ArrayList<Individual>>();
											String pop2Name = new String(); ArrayList<ArrayList<Individual>> pop2Individuals = new ArrayList<ArrayList<Individual>>();
											ArrayList<Double> interIndividualGeneticDistances = new ArrayList<Double>();
											ArrayList<Double> interIndividualGeographicalDistances = new ArrayList<Double>();
											geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
											for (int i = 0; i < populationsNames.size(); i++)
												{
													String line1 = new String(); String line2 = new String();
													// Creation of the pop1Individuals ArrayList:
													pop1Name = new String(); pop1Name = populationsNames.get(i); pop1Individuals = new ArrayList<ArrayList<Individual>>();
													for (int h = 0; h < input.loci.size(); h++)
														{
															for (int j = 0; j < input.loci.get(h).populations.size(); j++)
																{
																	if (input.loci.get(h).populations.get(j).popName.equals(pop1Name))
																		{
																			for (int k = 0; k < input.loci.get(h).populations.get(j).individuals.size(); k++)
																				{
																					boolean indAlreadyRecorded = false;
																					for (int l = 0; l < pop1Individuals.size(); l++)
																						{
																							if (input.loci.get(h).populations.get(j).individuals.get(k).indName.equals(pop1Individuals.get(l).get(0).indName))
																								{
																									indAlreadyRecorded = true;
																									pop1Individuals.get(l).add(input.loci.get(h).populations.get(j).individuals.get(k));
																								}
																						}
																					if (indAlreadyRecorded == false)
																						{
																							ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																							newIndividual.add(input.loci.get(h).populations.get(j).individuals.get(k));
																							pop1Individuals.add(newIndividual);
																						}
																				}
																		}
																}
														}
													for (int j = 0; j < populationsNames.size(); j++)
														{
															// Creation of the pop2Individuals ArrayList:
															pop2Name = new String(); pop2Name = populationsNames.get(j); pop2Individuals = new ArrayList<ArrayList<Individual>>();
															for (int h = 0; h < input.loci.size(); h++)
																{
																	for (int k = 0; k < input.loci.get(h).populations.size(); k++)
																		{
																			if (input.loci.get(h).populations.get(k).popName.equals(pop2Name))
																				{
																					for (int l = 0; l < input.loci.get(h).populations.get(k).individuals.size(); l++)
																						{
																							boolean indAlreadyRecorded = false;
																							for (int m = 0; m < pop2Individuals.size(); m++)
																								{
																									if (input.loci.get(h).populations.get(k).individuals.get(l).indName.equals(pop2Individuals.get(m).get(0).indName))
																										{
																											indAlreadyRecorded = true;
																											pop2Individuals.get(m).add(input.loci.get(h).populations.get(k).individuals.get(l));
																										}
																								}
																							if (indAlreadyRecorded == false)
																								{
																									ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																									newIndividual.add(input.loci.get(h).populations.get(k).individuals.get(l));
																									pop2Individuals.add(newIndividual);
																								}
																						}
																				}
																		}
																}
															// Computation of the mean inter-individual distance D between pop1 and pop2:
															double meanD = 0; double nberOfComparedIndividuals = 0;
															for (int k = 0; k < pop1Individuals.size(); k++)
																{
																	for (int l = 0; l < pop2Individuals.size(); l++)
																		{
																			boolean atLeastOneLocusComparison = false;
																			double D = 0; double nberOfComparedLoci = 0;
																			for (int m = 0; m < pop1Individuals.get(k).size(); m++)
																				{
																					for (int n = 0; n < pop2Individuals.get(l).size(); n++)
																						{
																							if (pop1Individuals.get(k).get(m).locusID == pop2Individuals.get(l).get(n).locusID)
																								{
																									atLeastOneLocusComparison = true;
																									nberOfComparedLoci = nberOfComparedLoci+1;
																									double d = 0;
																									int id = pop1Individuals.get(k).get(m).locusID - 1;
																									d = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(0).nodeMismatchesIndex][pop2Individuals.get(l).get(n).nodes.get(0).nodeMismatchesIndex];
																									if (d > 0)
																										{
																											d = 1;
																										}
																									D = D + d;
																								}
																						}
																				}
																			if (atLeastOneLocusComparison == true)
																				{
																					nberOfComparedIndividuals = nberOfComparedIndividuals+1;
																					D = D/nberOfComparedLoci;
																				}
																			meanD = meanD + D;
																			boolean sameIndividual = false;
																			if (populationsNames.get(i).equals(populationsNames.get(j)))
																				{
																					if (pop1Individuals.get(k).get(0).indName.equals(pop1Individuals.get(l).get(0).indName))
																						{
																							sameIndividual = true;
																						}
																				}
																			if (sameIndividual == false)
																				{
																					Double dDouble = new Double(D);
																					interIndividualGeneticDistances.add(dDouble);
																					Double geoDis = new Double(geographicalDistancesBetweenPopulations[i][j]);
																					interIndividualGeographicalDistances.add(geoDis);
																				}
																		}
																}
															meanD = meanD/nberOfComparedIndividuals;	
															line1 = line1 + meanD + "	";
															double distance = geographicalDistancesBetweenPopulations[i][j];
															geneticDistancesBetweenPopulations[i][j] = meanD;
															if (distance > 0)
																{
																	line2 = line2 + (Math.log10(meanD/distance)) + "	";
																}
															else
																{
																	line2 = line2 + "0	";
																}
														}
													lines1.add(line1);
												}
											externalMessage.addAll(lines1); externalFile1.addAll(lines1);
											OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_Barrier_input_matrix_IID1.txt");
										}	
									else // non-haploid case
										{
											externalFile1 = new ArrayList<String>(); ArrayList<String> lines1 = new ArrayList<String>();
											String pop1Name = new String(); ArrayList<ArrayList<Individual>> pop1Individuals = new ArrayList<ArrayList<Individual>>();
											String pop2Name = new String(); ArrayList<ArrayList<Individual>> pop2Individuals = new ArrayList<ArrayList<Individual>>();
											ArrayList<Double> interIndividualGeneticDistances = new ArrayList<Double>();
											ArrayList<Double> interIndividualGeographicalDistances = new ArrayList<Double>();
											geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
											for (int i = 0; i < populationsNames.size(); i++)
												{
													String line1 = new String(); String line2 = new String();
													// Creation of the pop1Individuals ArrayList:
													pop1Name = new String(); pop1Name = populationsNames.get(i); pop1Individuals = new ArrayList<ArrayList<Individual>>();
													for (int h = 0; h < input.loci.size(); h++)
														{
															for (int j = 0; j < input.loci.get(h).populations.size(); j++)
																{
																	if (input.loci.get(h).populations.get(j).popName.equals(pop1Name))
																		{
																			for (int k = 0; k < input.loci.get(h).populations.get(j).individuals.size(); k++)
																				{
																					boolean indAlreadyRecorded = false;
																					for (int l = 0; l < pop1Individuals.size(); l++)
																						{
																							if (input.loci.get(h).populations.get(j).individuals.get(k).indName.equals(pop1Individuals.get(l).get(0).indName))
																								{
																									indAlreadyRecorded = true;
																									pop1Individuals.get(l).add(input.loci.get(h).populations.get(j).individuals.get(k));
																								}
																						}
																					if (indAlreadyRecorded == false)
																						{
																							ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																							newIndividual.add(input.loci.get(h).populations.get(j).individuals.get(k));
																							pop1Individuals.add(newIndividual);
																						}
																				}
																		}
																}
														}
													for (int j = 0; j < populationsNames.size(); j++)
														{
															// Creation of the pop2Individuals ArrayList:
															pop2Name = new String(); pop2Name = populationsNames.get(j); pop2Individuals = new ArrayList<ArrayList<Individual>>();
															for (int h = 0; h < input.loci.size(); h++)
																{
																	for (int k = 0; k < input.loci.get(h).populations.size(); k++)
																		{
																			if (input.loci.get(h).populations.get(k).popName.equals(pop2Name))
																				{
																					for (int l = 0; l < input.loci.get(h).populations.get(k).individuals.size(); l++)
																						{
																							boolean indAlreadyRecorded = false;
																							for (int m = 0; m < pop2Individuals.size(); m++)
																								{
																									if (input.loci.get(h).populations.get(k).individuals.get(l).indName.equals(pop2Individuals.get(m).get(0).indName))
																										{
																											indAlreadyRecorded = true;
																											pop2Individuals.get(m).add(input.loci.get(h).populations.get(k).individuals.get(l));
																										}
																								}
																							if (indAlreadyRecorded == false)
																								{
																									ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																									newIndividual.add(input.loci.get(h).populations.get(k).individuals.get(l));
																									pop2Individuals.add(newIndividual);
																								}
																						}
																				}
																		}
																}
															// Computation of the mean inter-individual distance D between pop1 and pop2:
															double meanD = 0; double nberOfComparedIndividuals = 0;
															for (int k = 0; k < pop1Individuals.size(); k++)
																{
																	for (int l = 0; l < pop2Individuals.size(); l++)
																		{
																			boolean atLeastOneLocusComparison = false;
																			double D = 0; double nberOfComparedLoci = 0;
																			for (int m = 0; m < pop1Individuals.get(k).size(); m++)
																				{
																					for (int n = 0; n < pop2Individuals.get(l).size(); n++)
																						{
																							if (pop1Individuals.get(k).get(m).locusID == pop2Individuals.get(l).get(n).locusID)
																								{
																									atLeastOneLocusComparison = true;
																									nberOfComparedLoci = nberOfComparedLoci+1;
																									double q = 0;
																									locusHaplotypes = new ArrayList<Node>();
																									for (int o = 0; o < pop1Individuals.get(k).get(m).nodes.size(); o++)
																										{
																											boolean newSequence = true;
																											for (int p = 0; p < locusHaplotypes.size(); p++)
																												{
																													double d = 0;
																													int id = pop1Individuals.get(k).get(m).locusID - 1;
																													d = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(o).nodeMismatchesIndex][locusHaplotypes.get(p).nodeMismatchesIndex];
																													if (d == 0)
																														{
																															newSequence = false;
																														}
																												}
																											if (newSequence == true)
																												{
																													locusHaplotypes.add(pop1Individuals.get(k).get(m).nodes.get(o));
																												}
																										}
																									for (int o = 0; o < pop2Individuals.get(l).get(n).nodes.size(); o++)
																										{
																											boolean newSequence = true;
																											for (int p = 0; p < locusHaplotypes.size(); p++)
																												{
																													double d = 0;
																													int id = pop1Individuals.get(k).get(m).locusID - 1;
																													d = input.loci.get(id).nodesMismatches[pop2Individuals.get(l).get(n).nodes.get(o).nodeMismatchesIndex][locusHaplotypes.get(p).nodeMismatchesIndex];
																													if (d == 0)
																														{
																															newSequence = false;
																														}
																												}
																											if (newSequence == true)
																												{
																													locusHaplotypes.add(pop2Individuals.get(l).get(n).nodes.get(o));
																												}
																										}
																									for (int o = 0; o < locusHaplotypes.size(); o++)
																										{
																											double p1 = 0;
																											double p2 = 0;
																											for (int p = 0; p < pop1Individuals.get(k).get(m).nodes.size(); p++)
																												{
																													double d = 0;
																													int id = pop1Individuals.get(k).get(m).locusID - 1;
																													d = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(p).nodeMismatchesIndex][locusHaplotypes.get(o).nodeMismatchesIndex];
																													if (d == 0)
																														{
																															p1 = p1 + 1;
																														}
																												}
																											p1 = p1/ploidyMax;
																											for (int p = 0; p < pop2Individuals.get(l).get(n).nodes.size(); p++)
																												{
																													double d = 0;
																													int id = pop1Individuals.get(k).get(m).locusID - 1;
																													d = input.loci.get(id).nodesMismatches[pop2Individuals.get(l).get(n).nodes.get(p).nodeMismatchesIndex][locusHaplotypes.get(o).nodeMismatchesIndex];
																													if (d == 0)
																														{
																															p2 = p2+1;
																														}
																												}
																											p2 = p2/ploidyMax;
																											q = q + Math.sqrt(p1*p2);
																										}
																									D = D+(1-q);
																								}
																						}
																				}
																			if (atLeastOneLocusComparison == true)
																				{
																					nberOfComparedIndividuals = nberOfComparedIndividuals+1;
																					D = D/nberOfComparedLoci;
																				}
																			meanD = meanD + D;
																			boolean sameIndividual = false;
																			if (populationsNames.get(i).equals(populationsNames.get(j)))
																				{
																					if (pop1Individuals.get(k).get(0).indName.equals(pop1Individuals.get(l).get(0).indName))
																						{
																							sameIndividual = true;
																						}
																				}
																			if (sameIndividual == false)
																				{
																					Double dDouble = new Double(D);
																					interIndividualGeneticDistances.add(dDouble);
																					Double geoDis = new Double(geographicalDistancesBetweenPopulations[i][j]);
																					interIndividualGeographicalDistances.add(geoDis);
																				}
																		}
																}
															meanD = meanD/nberOfComparedIndividuals;
															line1 = line1 + meanD + "	";
															double distance = geographicalDistancesBetweenPopulations[i][j];
															geneticDistancesBetweenPopulations[i][j] = meanD;
															if (distance > 0)
																{
																	line2 = line2 + (Math.log10(meanD/distance)) + "	";
																}
															else
																{
																	line2 = line2 + "0	";
																}
														}
													lines1.add(line1);
												}
											externalMessage.addAll(lines1); externalFile1.addAll(lines1);
											OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_Barrier_input_matrix_IID1.txt");
										}
								}
							
							externalMessage.add("");
							externalMessage.add("BARRIER input, matrix of interindividual distances 2 (IID2, distance based on DNA sequences mismatches averaged over loci):");
							externalFile1 = new ArrayList<String>(); ArrayList<String> lines1 = new ArrayList<String>();	
							String pop1Name = new String(); ArrayList<ArrayList<Individual>> pop1Individuals = new ArrayList<ArrayList<Individual>>();
							String pop2Name = new String(); ArrayList<ArrayList<Individual>> pop2Individuals = new ArrayList<ArrayList<Individual>>();
							ArrayList<Double> interIndividualGeneticDistances = new ArrayList<Double>();
							ArrayList<Double> interIndividualGeographicalDistances = new ArrayList<Double>();
							geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
							for (int i = 0; i < populationsNames.size(); i++)
								{
									String line1 = new String(); String line2 = new String();
									// Creation of the pop1Individuals ArrayList:
									pop1Name = new String(); pop1Name = populationsNames.get(i); pop1Individuals = new ArrayList<ArrayList<Individual>>();
									for (int h = 0; h < input.loci.size(); h++)
										{
											for (int j = 0; j < input.loci.get(h).populations.size(); j++)
												{
													if (input.loci.get(h).populations.get(j).popName.equals(pop1Name))
														{
															for (int k = 0; k < input.loci.get(h).populations.get(j).individuals.size(); k++)
																{
																	boolean indAlreadyRecorded = false;
																	for (int l = 0; l < pop1Individuals.size(); l++)
																		{
																			if (input.loci.get(h).populations.get(j).individuals.get(k).indName.equals(pop1Individuals.get(l).get(0).indName))
																				{
																					indAlreadyRecorded = true;
																					pop1Individuals.get(l).add(input.loci.get(h).populations.get(j).individuals.get(k));
																				}
																		}
																	if (indAlreadyRecorded == false)
																		{
																			ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																			newIndividual.add(input.loci.get(h).populations.get(j).individuals.get(k));
																			pop1Individuals.add(newIndividual);
																		}
																}
														}
												}
										}
									for (int j = 0; j < populationsNames.size(); j++)
										{
											// Creation of the pop2Individuals ArrayList:
											pop2Name = new String(); pop2Name = populationsNames.get(j); pop2Individuals = new ArrayList<ArrayList<Individual>>();
											for (int h = 0; h < input.loci.size(); h++)
												{
													for (int k = 0; k < input.loci.get(h).populations.size(); k++)
														{
															if (input.loci.get(h).populations.get(k).popName.equals(pop2Name))
																{
																	for (int l = 0; l < input.loci.get(h).populations.get(k).individuals.size(); l++)
																		{
																			boolean indAlreadyRecorded = false;
																			for (int m = 0; m < pop2Individuals.size(); m++)
																				{
																					if (input.loci.get(h).populations.get(k).individuals.get(l).indName.equals(pop2Individuals.get(m).get(0).indName))
																						{
																							indAlreadyRecorded = true;
																							pop2Individuals.get(m).add(input.loci.get(h).populations.get(k).individuals.get(l));
																						}
																				}
																			if (indAlreadyRecorded == false)
																				{
																					ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																					newIndividual.add(input.loci.get(h).populations.get(k).individuals.get(l));
																					pop2Individuals.add(newIndividual);
																				}
																		}
																}
														}
												}
											// Computation of the mean inter-individual distance D between pop1 and pop2:
											double meanD = 0; double nberOfComparedIndividuals = 0;
											for (int k = 0; k < pop1Individuals.size(); k++)
												{
													for (int l = 0; l < pop2Individuals.size(); l++)
														{
															boolean atLeastOneLocusComparison = false;
															double D = 0; double nberOfComparedLoci = 0;
															for (int m = 0; m < pop1Individuals.get(k).size(); m++)
																{
																	for (int n = 0; n < pop2Individuals.get(l).size(); n++)
																		{
																			if (pop1Individuals.get(k).get(m).locusID == pop2Individuals.get(l).get(n).locusID)
																				{
																					atLeastOneLocusComparison = true;
																					nberOfComparedLoci = nberOfComparedLoci+1;
																					double d = 0;
																					double nberOfComparedAlleles = 0;
																					for (int o = 0; o < pop1Individuals.get(k).get(m).nodes.size(); o++)
																						{
																							for (int p = 0; p < pop2Individuals.get(l).get(n).nodes.size(); p++)
																								{
																									double a = 0;				
																									nberOfComparedAlleles = nberOfComparedAlleles + 1;
																									int id = pop1Individuals.get(k).get(m).locusID - 1;
																									a = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(o).nodeMismatchesIndex][pop2Individuals.get(l).get(n).nodes.get(p).nodeMismatchesIndex];	
																									a = a/((double) pop1Individuals.get(k).get(m).nodes.get(o).finalSequence.length());
																									d = d + a;
																								}
																						}
																					d = d/nberOfComparedAlleles;
																					D = D + d;	
																				}
																		}
																}
															if (atLeastOneLocusComparison == true)
																{
																	nberOfComparedIndividuals = nberOfComparedIndividuals+1;
																	D = D/nberOfComparedLoci;
																}
															meanD = meanD + D;
															boolean sameIndividual = false;
															if (populationsNames.get(i).equals(populationsNames.get(j)))
																{
																	if (pop1Individuals.get(k).get(0).indName.equals(pop1Individuals.get(l).get(0).indName))
																		{
																			sameIndividual = true;
																		}
																}
															if (sameIndividual == false)
																{
																	Double dDouble = new Double(D);
																	interIndividualGeneticDistances.add(dDouble);
																	Double geoDis = new Double(geographicalDistancesBetweenPopulations[i][j]);
																	interIndividualGeographicalDistances.add(geoDis);
																}
														}
												}
											meanD = meanD/nberOfComparedIndividuals;
											line1 = line1 + meanD + "	";
											double distance = geographicalDistancesBetweenPopulations[i][j];
											geneticDistancesBetweenPopulations[i][j] = meanD;
											if (distance > 0)
												{
													line2 = line2 + (Math.log10(meanD/distance)) + "	";
												}
											else
												{
													line2 = line2 + "0	";
												}
										}
									lines1.add(line1);
								}
							externalMessage.addAll(lines1); externalFile1.addAll(lines1);
							OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_Barrier_input_matrix_IID2.txt");
						}
					
					// Creation of the individuals list with haplotype numbers for GDisPAL & GDivPAL:
					if (window.checkBoxGDPAL.isSelected())
						{
							simTestThread.run("Input file conversion for GDisPAL & GDivPAL");
							ArrayList<String> populationsNames = new ArrayList<String>();
							ArrayList<Integer> populationsIndexes = new ArrayList<Integer>();
							for (int h = 0; h < input.loci.size(); h++)
								{
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											boolean newPopName = true;
											for (int j = 0; j < populationsNames.size(); j++)
												{
													if (input.loci.get(h).populations.get(i).popName.equals(populationsNames.get(j)))
														{
															newPopName = false;
														}
												}
											if (newPopName == true)
												{
													populationsNames.add(input.loci.get(h).populations.get(i).popName);
													Integer integer = new Integer(input.loci.get(h).populations.get(i).popDistanceIndex);
													populationsIndexes.add(integer);
												}
										}
								}
							
							boolean atLeastOneSequencePerLocusInEachPopulation = true;
							externalMessage.add("");
							externalMessage.add("");
							externalMessage.add("Inputs for GDisPAL Matlab or R functions:");	
							for (int h = 0; h < input.loci.size(); h++)
								{
									for (int i = 0; i < populationsNames.size(); i++)
										{
											boolean popMatch = false;
											for (int j = 0; j < input.loci.get(h).populations.size(); j++)
												{
													if (populationsNames.get(i).equals(input.loci.get(h).populations.get(j).popName))
														{
															popMatch = true;
														}
												}
											if (popMatch == false)
												{
													atLeastOneSequencePerLocusInEachPopulation = false;
												}
										}
								}
							if (atLeastOneSequencePerLocusInEachPopulation == false)
								{
									externalMessage.add("	Warning: there is not at least one sampled sequence per locus in each population.");
								}
							// else
								// {
									externalMessage.add("");
									externalMessage.add("GDisPAL populations coordinates input");
									externalMessage.add("(longitude	latitude):");
									ArrayList<String> externalFile = new ArrayList<String>();
									ArrayList<String> externalFile1 = new ArrayList<String>();
									ArrayList<String> externalFile2 = new ArrayList<String>();
									ArrayList<String> externalFile3 = new ArrayList<String>();
									double[][] populationsCoordinates = new double[populationsNames.size()][2];
									for (int i = 0; i < populationsNames.size(); i++)
										{
											boolean popFound = false;
											String line = new String();	
											for (int h = 0; h < input.loci.size(); h++)
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (popFound == false & input.loci.get(h).populations.get(j).popName.equals(populationsNames.get(i)))
																{
																	popFound = true;
																	line = input.loci.get(h).populations.get(j).position[1] + "	" + input.loci.get(h).populations.get(j).position[0];
																	populationsCoordinates[i][0] = input.loci.get(h).populations.get(j).position[1];
																	populationsCoordinates[i][1] = input.loci.get(h).populations.get(j).position[0];
																}
														}
												}
											externalMessage.add(line);
											externalFile.add(line);
										}
									OutputFileWriter.writeOutput1(externalFile, window.getInputName() + "_GDisPAL_input_coordinates.txt");
									
									externalMessage.add("");
									externalMessage.add("Matrix of pairwise geographical distances between populations used for the pseudoslopes computation:");
									double[][] geographicalDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
									double[][] geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
									for (int i = 0; i < populationsNames.size(); i++)
										{
											String line = new String();
											for (int j = 0; j < populationsNames.size(); j++)
												{
													double distance = -1;
													if (input.pairwisePopulationDistances == false)
														{
															double[] position1 = new double[2]; double[] position2 = new double[2];
															position1[0] = populationsCoordinates[i][0]; position1[1] = populationsCoordinates[i][1];
															position2[0] = populationsCoordinates[j][0]; position2[1] = populationsCoordinates[j][1];
															distance = Math.sqrt(((position2[1]-position1[1])*(position2[1]-position1[1])) + ((position2[0]-position1[0])*(position2[0]-position1[0])));
															geographicalDistancesBetweenPopulations[i][j] = distance; line = line + (float) distance + "	";
														}
													else
														{
															geographicalDistancesBetweenPopulations[i][j] = input.populationDistances[populationsIndexes.get(i)][populationsIndexes.get(j)];
														}
												}
											externalMessage.add(line);
										}
									
									externalMessage.add("");
									externalMessage.add("GDisPAL input, matrix of interindividual distances 1 (IID1, distance based on allelic frequencies):");
									if (samePloidy == false)
										{
											externalMessage.add("	this input requires that the different loci all present the same ploidy level.");
										}
									else
										{	
											if (ploidyMax == 1) // haploid case
												{
													externalFile1 = new ArrayList<String>(); ArrayList<String> lines1 = new ArrayList<String>();
													externalFile2 = new ArrayList<String>(); ArrayList<String> lines2 = new ArrayList<String>();			
													externalFile3 = new ArrayList<String>(); ArrayList<String> lines3 = new ArrayList<String>();	
													String pop1Name = new String(); ArrayList<ArrayList<Individual>> pop1Individuals = new ArrayList<ArrayList<Individual>>();
													String pop2Name = new String(); ArrayList<ArrayList<Individual>> pop2Individuals = new ArrayList<ArrayList<Individual>>();
													ArrayList<Double> interIndividualGeneticDistances = new ArrayList<Double>();
													ArrayList<Double> interIndividualGeographicalDistances = new ArrayList<Double>();
													geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
													for (int i = 0; i < populationsNames.size(); i++)
														{
															String line1 = new String(); String line2 = new String();
															// Creation of the pop1Individuals ArrayList:
															pop1Name = new String(); pop1Name = populationsNames.get(i); pop1Individuals = new ArrayList<ArrayList<Individual>>();
															for (int h = 0; h < input.loci.size(); h++)
																{
																	for (int j = 0; j < input.loci.get(h).populations.size(); j++)
																		{
																			if (input.loci.get(h).populations.get(j).popName.equals(pop1Name))
																				{
																					for (int k = 0; k < input.loci.get(h).populations.get(j).individuals.size(); k++)
																						{
																							boolean indAlreadyRecorded = false;
																							for (int l = 0; l < pop1Individuals.size(); l++)
																								{
																									if (input.loci.get(h).populations.get(j).individuals.get(k).indName.equals(pop1Individuals.get(l).get(0).indName))
																										{
																											indAlreadyRecorded = true;
																											pop1Individuals.get(l).add(input.loci.get(h).populations.get(j).individuals.get(k));
																										}
																								}
																							if (indAlreadyRecorded == false)
																								{
																									ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																									newIndividual.add(input.loci.get(h).populations.get(j).individuals.get(k));
																									pop1Individuals.add(newIndividual);
																								}
																						}
																				}
																		}
																}
															for (int j = 0; j < populationsNames.size(); j++)
																{
																	// Creation of the pop2Individuals ArrayList:
																	pop2Name = new String(); pop2Name = populationsNames.get(j); pop2Individuals = new ArrayList<ArrayList<Individual>>();
																	for (int h = 0; h < input.loci.size(); h++)
																		{
																			for (int k = 0; k < input.loci.get(h).populations.size(); k++)
																				{
																					if (input.loci.get(h).populations.get(k).popName.equals(pop2Name))
																						{
																							for (int l = 0; l < input.loci.get(h).populations.get(k).individuals.size(); l++)
																								{
																									boolean indAlreadyRecorded = false;
																									for (int m = 0; m < pop2Individuals.size(); m++)
																										{
																											if (input.loci.get(h).populations.get(k).individuals.get(l).indName.equals(pop2Individuals.get(m).get(0).indName))
																												{
																													indAlreadyRecorded = true;
																													pop2Individuals.get(m).add(input.loci.get(h).populations.get(k).individuals.get(l));
																												}
																										}
																									if (indAlreadyRecorded == false)
																										{
																											ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																											newIndividual.add(input.loci.get(h).populations.get(k).individuals.get(l));
																											pop2Individuals.add(newIndividual);
																										}
																								}
																						}
																				}
																		}
																	// Computation of the mean inter-individual distance D between pop1 and pop2:
																	double meanD = 0; double nberOfComparedIndividuals = 0;
																	for (int k = 0; k < pop1Individuals.size(); k++)
																		{
																			for (int l = 0; l < pop2Individuals.size(); l++)
																				{
																					boolean atLeastOneLocusComparison = false;
																					double D = 0; double nberOfComparedLoci = 0;
																					for (int m = 0; m < pop1Individuals.get(k).size(); m++)
																						{
																							for (int n = 0; n < pop2Individuals.get(l).size(); n++)
																								{
																									if (pop1Individuals.get(k).get(m).locusID == pop2Individuals.get(l).get(n).locusID)
																										{
																											atLeastOneLocusComparison = true;
																											nberOfComparedLoci = nberOfComparedLoci+1;
																											double d = 0;
																											int id = pop1Individuals.get(k).get(m).locusID - 1;
																											d = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(0).nodeMismatchesIndex][pop2Individuals.get(l).get(n).nodes.get(0).nodeMismatchesIndex];
																											if (d > 0)
																												{
																													d = 1;
																												}
																											D = D + d;
																										}
																								}
																						}
																					if (atLeastOneLocusComparison == true)
																						{
																							nberOfComparedIndividuals = nberOfComparedIndividuals+1;
																							D = D/nberOfComparedLoci;
																						}
																					meanD = meanD + D;
																					boolean sameIndividual = false;
																					if (populationsNames.get(i).equals(populationsNames.get(j)))
																						{
																							if (pop1Individuals.get(k).get(0).indName.equals(pop1Individuals.get(l).get(0).indName))
																								{
																									sameIndividual = true;
																								}
																						}
																					if (sameIndividual == false)
																						{
																							Double dDouble = new Double(D);
																							interIndividualGeneticDistances.add(dDouble);
																							Double geoDis = new Double(geographicalDistancesBetweenPopulations[i][j]);
																							interIndividualGeographicalDistances.add(geoDis);
																						}
																				}
																		}
																	meanD = meanD/nberOfComparedIndividuals;	
																	// System.out.println(populationsNames.get(i) + " - " + populationsNames.get(j) + " - " + meanD);
																	line1 = line1 + meanD + "	";
																	double distance = geographicalDistancesBetweenPopulations[i][j];
																	geneticDistancesBetweenPopulations[i][j] = meanD;
																	if (distance > 0)
																		{
																			line2 = line2 + (Math.log10(meanD/distance)) + "	";
																		}
																	else
																		{
																			line2 = line2 + "0	";
																		}
																}
															lines1.add(line1);
															lines2.add(line2);
														}
													externalMessage.addAll(lines1); externalFile1.addAll(lines1);
													OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_GDisPAL_input_distances_matrix_IID1.txt");
													
													externalMessage.add("");
													externalMessage.add("GDisPAL input, matrix of log(10) transformed pseudoslopes between genetic interindividual distances 1 (IID1, distance based on allelic frequencies) and geographical distances:");
													externalMessage.addAll(lines2); externalFile2.addAll(lines2);
													OutputFileWriter.writeOutput1(externalFile2, window.getInputName() + "_GDisPAL_input_log(10)_pseudoslopes_matrix_IID1.txt");
													
													externalMessage.add("");
													externalMessage.add("GDisPAL input, matrix of interindividual distances 1 (IID1, distance based on allelic frequencies) regression residuals:");
													double beta1 = 0; double beta0 = 0;
													double[] x = new double[interIndividualGeneticDistances.size()]; double[] y = new double[interIndividualGeneticDistances.size()];
													double n2 = 0;
													for (int i = 0; i < interIndividualGeneticDistances.size(); i++)
														{
															double Dgen = interIndividualGeneticDistances.get(i).doubleValue();
															double Dgeo = interIndividualGeographicalDistances.get(i).doubleValue();
															x[(int) n2] = Dgeo;
															y[(int) n2] = Dgen;
															n2 = n2 + 1;
														}
													LinearRegression regression = new LinearRegression();
													beta1 = regression.Regression(x, y); // System.out.println(beta1);
													beta0 = regression.beta0; // System.out.println(beta0);
													for (int i = 0; i < populationsNames.size(); i++)
														{
															String line3 = new String();
															for (int j = 0; j < populationsNames.size(); j++)
																{
																	double d = 0;
																	double Dgen = geneticDistancesBetweenPopulations[i][j];
																	double Dgeo = geographicalDistancesBetweenPopulations[i][j];
																	// System.out.println(populationsNames.get(i) + "	-	" + populationsNames.get(j) + "	-	" + Dgen + "	-	" + Dgeo);
																	d = Dgen - ((beta1*Dgeo) + beta0); // System.out.println(Dgen + " - " + ((beta1*Dgeo) + beta0));
																	line3 = line3 + (d) + "	";
																}
															lines3.add(line3);
														}
													externalMessage.addAll(lines3); externalFile3.addAll(lines3);
													OutputFileWriter.writeOutput1(externalFile3, window.getInputName() + "_GDisPAL_input_regression_residuals_matrix_IID1.txt");
												}	
											else // non-haploid case
												{
													externalFile1 = new ArrayList<String>(); ArrayList<String> lines1 = new ArrayList<String>();
													externalFile2 = new ArrayList<String>(); ArrayList<String> lines2 = new ArrayList<String>();
													externalFile3 = new ArrayList<String>(); ArrayList<String> lines3 = new ArrayList<String>();	
													String pop1Name = new String(); ArrayList<ArrayList<Individual>> pop1Individuals = new ArrayList<ArrayList<Individual>>();
													String pop2Name = new String(); ArrayList<ArrayList<Individual>> pop2Individuals = new ArrayList<ArrayList<Individual>>();
													ArrayList<Double> interIndividualGeneticDistances = new ArrayList<Double>();
													ArrayList<Double> interIndividualGeographicalDistances = new ArrayList<Double>();
													geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
													for (int i = 0; i < populationsNames.size(); i++)
														{
															String line1 = new String(); String line2 = new String();
															// Creation of the pop1Individuals ArrayList:
															pop1Name = new String(); pop1Name = populationsNames.get(i); pop1Individuals = new ArrayList<ArrayList<Individual>>();
															for (int h = 0; h < input.loci.size(); h++)
																{
																	for (int j = 0; j < input.loci.get(h).populations.size(); j++)
																		{
																			if (input.loci.get(h).populations.get(j).popName.equals(pop1Name))
																				{
																					for (int k = 0; k < input.loci.get(h).populations.get(j).individuals.size(); k++)
																						{
																							boolean indAlreadyRecorded = false;
																							for (int l = 0; l < pop1Individuals.size(); l++)
																								{
																									if (input.loci.get(h).populations.get(j).individuals.get(k).indName.equals(pop1Individuals.get(l).get(0).indName))
																										{
																											indAlreadyRecorded = true;
																											pop1Individuals.get(l).add(input.loci.get(h).populations.get(j).individuals.get(k));
																										}
																								}
																							if (indAlreadyRecorded == false)
																								{
																									ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																									newIndividual.add(input.loci.get(h).populations.get(j).individuals.get(k));
																									pop1Individuals.add(newIndividual);
																								}
																						}
																				}
																		}
																}
															for (int j = 0; j < populationsNames.size(); j++)
																{
																	// Creation of the pop2Individuals ArrayList:
																	pop2Name = new String(); pop2Name = populationsNames.get(j); pop2Individuals = new ArrayList<ArrayList<Individual>>();
																	for (int h = 0; h < input.loci.size(); h++)
																		{
																			for (int k = 0; k < input.loci.get(h).populations.size(); k++)
																				{
																					if (input.loci.get(h).populations.get(k).popName.equals(pop2Name))
																						{
																							for (int l = 0; l < input.loci.get(h).populations.get(k).individuals.size(); l++)
																								{
																									boolean indAlreadyRecorded = false;
																									for (int m = 0; m < pop2Individuals.size(); m++)
																										{
																											if (input.loci.get(h).populations.get(k).individuals.get(l).indName.equals(pop2Individuals.get(m).get(0).indName))
																												{
																													indAlreadyRecorded = true;
																													pop2Individuals.get(m).add(input.loci.get(h).populations.get(k).individuals.get(l));
																												}
																										}
																									if (indAlreadyRecorded == false)
																										{
																											ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																											newIndividual.add(input.loci.get(h).populations.get(k).individuals.get(l));
																											pop2Individuals.add(newIndividual);
																										}
																								}
																						}
																				}
																		}
																	// Computation of the mean inter-individual distance D between pop1 and pop2:
																	double meanD = 0; double nberOfComparedIndividuals = 0;
																	for (int k = 0; k < pop1Individuals.size(); k++)
																		{
																			for (int l = 0; l < pop2Individuals.size(); l++)
																				{
																					boolean atLeastOneLocusComparison = false;
																					double D = 0; double nberOfComparedLoci = 0;
																					for (int m = 0; m < pop1Individuals.get(k).size(); m++)
																						{
																							for (int n = 0; n < pop2Individuals.get(l).size(); n++)
																								{
																									if (pop1Individuals.get(k).get(m).locusID == pop2Individuals.get(l).get(n).locusID)
																										{
																											atLeastOneLocusComparison = true;
																											nberOfComparedLoci = nberOfComparedLoci+1;
																											double q = 0;
																											locusHaplotypes = new ArrayList<Node>();
																											for (int o = 0; o < pop1Individuals.get(k).get(m).nodes.size(); o++)
																												{
																													boolean newSequence = true;
																													for (int p = 0; p < locusHaplotypes.size(); p++)
																														{
																															double d = 0;
																															int id = pop1Individuals.get(k).get(m).locusID - 1;
																															d = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(o).nodeMismatchesIndex][locusHaplotypes.get(p).nodeMismatchesIndex];
																															if (d == 0)
																																{
																																	newSequence = false;
																																}
																														}
																													if (newSequence == true)
																														{
																															locusHaplotypes.add(pop1Individuals.get(k).get(m).nodes.get(o));
																														}
																												}
																											for (int o = 0; o < pop2Individuals.get(l).get(n).nodes.size(); o++)
																												{
																													boolean newSequence = true;
																													for (int p = 0; p < locusHaplotypes.size(); p++)
																														{
																															double d = 0;
																															int id = pop1Individuals.get(k).get(m).locusID - 1;
																															d = input.loci.get(id).nodesMismatches[pop2Individuals.get(l).get(n).nodes.get(o).nodeMismatchesIndex][locusHaplotypes.get(p).nodeMismatchesIndex];
																															if (d == 0)
																																{
																																	newSequence = false;
																																}
																														}
																													if (newSequence == true)
																														{
																															locusHaplotypes.add(pop2Individuals.get(l).get(n).nodes.get(o));
																														}
																												}
																											for (int o = 0; o < locusHaplotypes.size(); o++)
																												{
																													double p1 = 0;
																													double p2 = 0;
																													for (int p = 0; p < pop1Individuals.get(k).get(m).nodes.size(); p++)
																														{
																															double d = 0;
																															int id = pop1Individuals.get(k).get(m).locusID - 1;
																															d = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(p).nodeMismatchesIndex][locusHaplotypes.get(o).nodeMismatchesIndex];
																															if (d == 0)
																																{
																																	p1 = p1 + 1;
																																}
																														}
																													p1 = p1/ploidyMax;
																													for (int p = 0; p < pop2Individuals.get(l).get(n).nodes.size(); p++)
																														{
																															double d = 0;
																															int id = pop1Individuals.get(k).get(m).locusID - 1;
																															d = input.loci.get(id).nodesMismatches[pop2Individuals.get(l).get(n).nodes.get(p).nodeMismatchesIndex][locusHaplotypes.get(o).nodeMismatchesIndex];
																															if (d == 0)
																																{
																																	p2 = p2+1;
																																}
																														}
																													p2 = p2/ploidyMax;
																													q = q + Math.sqrt(p1*p2);
																												}
																											D = D+(1-q);
																										}
																								}
																						}
																					if (atLeastOneLocusComparison == true)
																						{
																							nberOfComparedIndividuals = nberOfComparedIndividuals+1;
																							D = D/nberOfComparedLoci;
																						}
																					meanD = meanD + D;
																					boolean sameIndividual = false;
																					if (populationsNames.get(i).equals(populationsNames.get(j)))
																						{
																							if (pop1Individuals.get(k).get(0).indName.equals(pop1Individuals.get(l).get(0).indName))
																								{
																									sameIndividual = true;
																								}
																						}
																					if (sameIndividual == false)
																						{
																							Double dDouble = new Double(D);
																							interIndividualGeneticDistances.add(dDouble);
																							Double geoDis = new Double(geographicalDistancesBetweenPopulations[i][j]);
																							interIndividualGeographicalDistances.add(geoDis);
																						}
																				}
																		}
																	meanD = meanD/nberOfComparedIndividuals;	
																	// System.out.println(populationsNames.get(i) + " - " + populationsNames.get(j) + " - " + meanD);
																	line1 = line1 + meanD + "	";
																	double distance = geographicalDistancesBetweenPopulations[i][j];
																	geneticDistancesBetweenPopulations[i][j] = meanD;
																	if (distance > 0)
																		{
																			line2 = line2 + (Math.log10(meanD/distance)) + "	";
																		}
																	else
																		{
																			line2 = line2 + "0	";
																		}
																}
															lines1.add(line1);
															lines2.add(line2);
														}
													externalMessage.addAll(lines1); externalFile1.addAll(lines1);
													OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_GDisPAL_input_distances_matrix_IID1.txt");
													
													externalMessage.add("");
													externalMessage.add("GDisPAL input, matrix of log(10) transformed pseudoslopes between genetic interindividual distances 1 (IID1, distance based on allelic frequencies) and geographical distances:");
													externalMessage.addAll(lines2); externalFile2.addAll(lines2);
													OutputFileWriter.writeOutput1(externalFile2, window.getInputName() + "_GDisPAL_input_log(10)_pseudoslopes_matrix_IID1.txt");

													externalMessage.add("");
													externalMessage.add("GDisPAL input, matrix of interindividual distances 1 (IID1, distance based on allelic frequencies) regression residuals:");
													double beta1 = 0; double beta0 = 0;
													double[] x = new double[interIndividualGeneticDistances.size()]; double[] y = new double[interIndividualGeneticDistances.size()];
													double n2 = 0;
													for (int i = 0; i < interIndividualGeneticDistances.size(); i++)
														{
															double Dgen = interIndividualGeneticDistances.get(i).doubleValue();
															double Dgeo = interIndividualGeographicalDistances.get(i).doubleValue();
															x[(int) n2] = Dgeo;
															y[(int) n2] = Dgen;
															n2 = n2 + 1;
														}
													LinearRegression regression = new LinearRegression();
													beta1 = regression.Regression(x, y); // System.out.println(beta1);
													beta0 = regression.beta0; // System.out.println(beta0);
													for (int i = 0; i < populationsNames.size(); i++)
														{
															String line3 = new String();
															for (int j = 0; j < populationsNames.size(); j++)
																{
																	double d = 0;
																	double Dgen = geneticDistancesBetweenPopulations[i][j];
																	double Dgeo = geographicalDistancesBetweenPopulations[i][j];
																	// System.out.println(populationsNames.get(i) + "	-	" + populationsNames.get(j) + "	-	" + Dgen + "	-	" + Dgeo);
																	d = Dgen - ((beta1*Dgeo) + beta0); // System.out.println(Dgen + " - " + ((beta1*Dgeo) + beta0));
																	line3 = line3 + (d) + "	";
																}
															lines3.add(line3);
														}
													externalMessage.addAll(lines3); externalFile3.addAll(lines3);
													OutputFileWriter.writeOutput1(externalFile3, window.getInputName() + "_GDisPAL_input_regression_residuals_matrix_IID1.txt");
												}
										}
									
									externalMessage.add("");
									externalMessage.add("GDisPAL input, matrix of interindividual distances 2 (IID2, distance based on DNA sequences mismatches averaged over loci):");
									externalFile1 = new ArrayList<String>(); ArrayList<String> lines1 = new ArrayList<String>();
									externalFile2 = new ArrayList<String>(); ArrayList<String> lines2 = new ArrayList<String>();
									externalFile3 = new ArrayList<String>(); ArrayList<String> lines3 = new ArrayList<String>();	
									String pop1Name = new String(); ArrayList<ArrayList<Individual>> pop1Individuals = new ArrayList<ArrayList<Individual>>();
									String pop2Name = new String(); ArrayList<ArrayList<Individual>> pop2Individuals = new ArrayList<ArrayList<Individual>>();
									ArrayList<Double> interIndividualGeneticDistances = new ArrayList<Double>();
									ArrayList<Double> interIndividualGeographicalDistances = new ArrayList<Double>();
									geneticDistancesBetweenPopulations = new double[populationsNames.size()][populationsNames.size()];
									for (int i = 0; i < populationsNames.size(); i++)
										{
											String line1 = new String(); String line2 = new String();
											// Creation of the pop1Individuals ArrayList:
											pop1Name = new String(); pop1Name = populationsNames.get(i); pop1Individuals = new ArrayList<ArrayList<Individual>>();
											for (int h = 0; h < input.loci.size(); h++)
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (input.loci.get(h).populations.get(j).popName.equals(pop1Name))
																{
																	for (int k = 0; k < input.loci.get(h).populations.get(j).individuals.size(); k++)
																		{
																			boolean indAlreadyRecorded = false;
																			for (int l = 0; l < pop1Individuals.size(); l++)
																				{
																					if (input.loci.get(h).populations.get(j).individuals.get(k).indName.equals(pop1Individuals.get(l).get(0).indName))
																						{
																							indAlreadyRecorded = true;
																							pop1Individuals.get(l).add(input.loci.get(h).populations.get(j).individuals.get(k));
																						}
																				}
																			if (indAlreadyRecorded == false)
																				{
																					ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																					newIndividual.add(input.loci.get(h).populations.get(j).individuals.get(k));
																					pop1Individuals.add(newIndividual);
																				}
																		}
																}
														}
												}
											for (int j = 0; j < populationsNames.size(); j++)
												{
													// Creation of the pop2Individuals ArrayList:
													pop2Name = new String(); pop2Name = populationsNames.get(j); pop2Individuals = new ArrayList<ArrayList<Individual>>();
													for (int h = 0; h < input.loci.size(); h++)
														{
															for (int k = 0; k < input.loci.get(h).populations.size(); k++)
																{
																	if (input.loci.get(h).populations.get(k).popName.equals(pop2Name))
																		{
																			for (int l = 0; l < input.loci.get(h).populations.get(k).individuals.size(); l++)
																				{
																					boolean indAlreadyRecorded = false;
																					for (int m = 0; m < pop2Individuals.size(); m++)
																						{
																							if (input.loci.get(h).populations.get(k).individuals.get(l).indName.equals(pop2Individuals.get(m).get(0).indName))
																								{
																									indAlreadyRecorded = true;
																									pop2Individuals.get(m).add(input.loci.get(h).populations.get(k).individuals.get(l));
																								}
																						}
																					if (indAlreadyRecorded == false)
																						{
																							ArrayList<Individual> newIndividual = new ArrayList<Individual>();
																							newIndividual.add(input.loci.get(h).populations.get(k).individuals.get(l));
																							pop2Individuals.add(newIndividual);
																						}
																				}
																		}
																}
														}
													// Computation of the mean inter-individual distance D between pop1 and pop2:
													double meanD = 0; double nberOfComparedIndividuals = 0;
													for (int k = 0; k < pop1Individuals.size(); k++)
														{
															for (int l = 0; l < pop2Individuals.size(); l++)
																{
																	boolean atLeastOneLocusComparison = false;
																	double D = 0; double nberOfComparedLoci = 0;
																	for (int m = 0; m < pop1Individuals.get(k).size(); m++)
																		{
																			for (int n = 0; n < pop2Individuals.get(l).size(); n++)
																				{
																					if (pop1Individuals.get(k).get(m).locusID == pop2Individuals.get(l).get(n).locusID)
																						{
																							atLeastOneLocusComparison = true;
																							nberOfComparedLoci = nberOfComparedLoci+1;
																							double d = 0;
																							double nberOfComparedAlleles = 0;
																							for (int o = 0; o < pop1Individuals.get(k).get(m).nodes.size(); o++)
																								{
																									for (int p = 0; p < pop2Individuals.get(l).get(n).nodes.size(); p++)
																										{
																											double a = 0;				
																											nberOfComparedAlleles = nberOfComparedAlleles + 1;
																											int id = pop1Individuals.get(k).get(m).locusID - 1;
																											a = input.loci.get(id).nodesMismatches[pop1Individuals.get(k).get(m).nodes.get(o).nodeMismatchesIndex][pop2Individuals.get(l).get(n).nodes.get(p).nodeMismatchesIndex];	
																											a = a/((double) pop1Individuals.get(k).get(m).nodes.get(o).finalSequence.length());
																											d = d + a;
																										}
																								}
																							d = d/nberOfComparedAlleles;
																							D = D + d;	
																						}
																				}
																		}
																	if (atLeastOneLocusComparison == true)
																		{
																			nberOfComparedIndividuals = nberOfComparedIndividuals+1;
																			D = D/nberOfComparedLoci;
																		}
																	meanD = meanD + D;
																	boolean sameIndividual = false;
																	if (populationsNames.get(i).equals(populationsNames.get(j)))
																		{
																			if (pop1Individuals.get(k).get(0).indName.equals(pop1Individuals.get(l).get(0).indName))
																				{
																					sameIndividual = true;
																				}
																		}
																	if (sameIndividual == false)
																		{
																			Double dDouble = new Double(D);
																			interIndividualGeneticDistances.add(dDouble);
																			Double geoDis = new Double(geographicalDistancesBetweenPopulations[i][j]);
																			interIndividualGeographicalDistances.add(geoDis);
																		}
																}
														}
													meanD = meanD/nberOfComparedIndividuals;	
													// System.out.println(populationsNames.get(i) + " - " + populationsNames.get(j) + " - " + meanD);
													line1 = line1 + meanD + "	";
													double distance = geographicalDistancesBetweenPopulations[i][j];
													geneticDistancesBetweenPopulations[i][j] = meanD;
													if (distance > 0)
														{
															line2 = line2 + (Math.log10(meanD/distance)) + "	";
														}
													else
														{
															line2 = line2 + "0	";
														}
												}
											lines1.add(line1);
											lines2.add(line2);
										}
									externalMessage.addAll(lines1); externalFile1.addAll(lines1);
									OutputFileWriter.writeOutput1(externalFile1, window.getInputName() + "_GDisPAL_input_distances_matrix_IID2.txt");

									externalMessage.add("");
									externalMessage.add("GDisPAL input, matrix of log(10) transformed pseudoslopes between genetic interindividual distances 2 (IID2, distance based on DNA sequences mismatches averaged over loci) and geographical distances:");
									externalMessage.addAll(lines2); externalFile2.addAll(lines2);
									OutputFileWriter.writeOutput1(externalFile2, window.getInputName() + "_GDisPAL_input_log(10)_pseudoslopes_matrix_IID2.txt");
									
									externalMessage.add("");
									externalMessage.add("GDisPAL input, matrix of interindividual distances 2 (IID2, distance based on allelic frequencies) regression residuals:");
									double beta1 = 0; double beta0 = 0;
									double[] x = new double[interIndividualGeneticDistances.size()]; double[] y = new double[interIndividualGeneticDistances.size()];
									double n2 = 0;
									for (int i = 0; i < interIndividualGeneticDistances.size(); i++)
										{
											double Dgen = interIndividualGeneticDistances.get(i).doubleValue();
											double Dgeo = interIndividualGeographicalDistances.get(i).doubleValue();
											x[(int) n2] = Dgeo;
											y[(int) n2] = Dgen;
											n2 = n2 + 1;
										}
									LinearRegression regression = new LinearRegression();
									beta1 = regression.Regression(x, y); // System.out.println(beta1);
									beta0 = regression.beta0; // System.out.println(beta0);
									for (int i = 0; i < populationsNames.size(); i++)
										{
											String line3 = new String();
											for (int j = 0; j < populationsNames.size(); j++)
												{
													double d = 0;
													double Dgen = geneticDistancesBetweenPopulations[i][j];
													double Dgeo = geographicalDistancesBetweenPopulations[i][j];
													// System.out.println(populationsNames.get(i) + "	-	" + populationsNames.get(j) + "	-	" + Dgen + "	-	" + Dgeo);
													d = Dgen - ((beta1*Dgeo) + beta0); // System.out.println(Dgen + " - " + ((beta1*Dgeo) + beta0));
													line3 = line3 + (d) + "	";
												}
											lines3.add(line3);
										}
									externalMessage.addAll(lines3); externalFile3.addAll(lines3);
									OutputFileWriter.writeOutput1(externalFile3, window.getInputName() + "_GDisPAL_input_regression_residuals_matrix_IID2.txt");
								// }
							
							boolean minimumTwoSequencesPerPopulation = true;
							externalMessage.add("");
							externalMessage.add("");
							externalMessage.add("Inputs for GDivPAL Matlab or R functions:");
							// Computation of 4 mean diversity statistics in each population (Nh/Nseq, Ar, Pi and Pir):
							ArrayList<Double> meanNpopNhtots = new ArrayList<Double>();
							ArrayList<ArrayList<Double>> nHapnSeqsArrayList = new ArrayList<ArrayList<Double>>(); 
							ArrayList<Double> meanArs = new ArrayList<Double>();
							ArrayList<ArrayList<Double>> arsArrayList = new ArrayList<ArrayList<Double>>(); 
							ArrayList<Double> meanPis = new ArrayList<Double>();
							ArrayList<ArrayList<Double>> pisArrayList = new ArrayList<ArrayList<Double>>(); 
							ArrayList<Double> meanPirs = new ArrayList<Double>();
							ArrayList<ArrayList<Double>> pirsArrayList = new ArrayList<ArrayList<Double>>(); 
							String popsWithoutAtLeast2Nodes = new String();
							ArrayList<ArrayList<String>> populationsNamesByLocus = new ArrayList<ArrayList<String>>();
							for (int h = 0; h < input.loci.size(); h++)
								{
									ArrayList<String> populationsNamesBuffer = new ArrayList<String>();
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											if (input.loci.get(h).populations.get(i).nodes.size() > 1)
												{
													boolean newPopName = true;
													for (int j = 0; j < populationsNamesBuffer.size(); j++)
														{
															if (input.loci.get(h).populations.get(i).popName.equals(populationsNamesBuffer.get(j)))
																{
																	newPopName = false;
																}
														}
													if (newPopName == true)
														{
														populationsNamesBuffer.add(input.loci.get(h).populations.get(i).popName);
														}
												}
											else
												{
													minimumTwoSequencesPerPopulation = false;
													popsWithoutAtLeast2Nodes = popsWithoutAtLeast2Nodes + input.loci.get(h).populations.get(i).popName + "(locus" + input.loci.get(h).ID + ")	";
												}
										}
									populationsNamesByLocus.add(populationsNamesBuffer);
								}
					
							double[] Nss = new double[input.loci.size()];
							// Computation of one Ns/locus for Ar (allelic richness):
							for (int h = 0; h < input.loci.size(); h++)
								{
									double Ns = input.loci.get(h).nodes.size(); // starting value for Ns
									for (int i = 0; i < populationsNames.size(); i++)
										{
											boolean atLeast2GeneCopiesInThisPopForThisLocus = false;
											for (int j = 0; j < populationsNamesByLocus.get(h).size(); j++)
												{
													if (populationsNamesByLocus.get(h).get(j).equals(populationsNames.get(i)))
														{
															atLeast2GeneCopiesInThisPopForThisLocus = true;
														}
												}
											if (atLeast2GeneCopiesInThisPopForThisLocus == false)
												{	}
											else
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (populationsNames.get(i).equals(input.loci.get(h).populations.get(j).popName))
																{
																	double nS = 0;
																	nS = nS + input.loci.get(h).populations.get(j).nodes.size();
																	if (nS < Ns)
																		{
																			Ns = nS;
																		}
																}
														}
												}
										}
									Nss[h] = Ns;
								}

							for (int i = 0; i < populationsNames.size(); i++)
								{
									ArrayList<Double> nHapnSeqs = new ArrayList<Double>();
									ArrayList<Double> ars = new ArrayList<Double>();
									ArrayList<Double> pis = new ArrayList<Double>();
									ArrayList<Double> pirs = new ArrayList<Double>();
									for (int h = 0; h < input.loci.size(); h++)
										{
											boolean atLeast2GeneCopiesInThisPopForThisLocus = false;
											for (int j = 0; j < populationsNamesByLocus.get(h).size(); j++)
												{
													if (populationsNamesByLocus.get(h).get(j).equals(populationsNames.get(i)))
														{
															atLeast2GeneCopiesInThisPopForThisLocus = true;
														}
												}
											if (atLeast2GeneCopiesInThisPopForThisLocus == false)
												{
													Double nHapnSeqDouble = new Double(-999); nHapnSeqs.add(nHapnSeqDouble);
													Double arsDouble = new Double(-999); ars.add(arsDouble);
													Double piDouble = new Double(-999); pis.add(piDouble);
													Double pirDouble = new Double(-999); pirs.add(pirDouble);
												}
											else
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (populationsNames.get(i).equals(input.loci.get(h).populations.get(j).popName))
																{
																	// Computation of NhNseq in the given population:
																	ArrayList<Node> differentSequencesInPop = new ArrayList<Node>();
																	differentSequencesInPop.add(input.loci.get(h).populations.get(j).nodes.get(0));
																	for (int k = 1; k < input.loci.get(h).populations.get(j).nodes.size(); k++)
																		{
																			int b = 0;
																			for (int l = 0; l < k; l++)
																				{
																					int a = 0;
																					for (int m = 0; m < input.loci.get(h).populations.get(j).nodes.get(k).finalSequence.length(); m++)
																						{
																							double n = input.loci.get(h).nodesMismatches[input.loci.get(h).populations.get(j).nodes.get(k).nodeMismatchesIndex][input.loci.get(h).populations.get(j).nodes.get(l).nodeMismatchesIndex]; 
																							if (n == 0)
																								{	}
																							else {	a = a + 1; }
																						}
																					if (a == 0)
																						{
																							b = b + 1;
																						}
																				}
																			if (b == 0)
																				{
																					differentSequencesInPop.add(input.loci.get(h).populations.get(j).nodes.get(k));
																				}
																		}
																	double nHap = differentSequencesInPop.size();
																	double nSeq = input.loci.get(h).populations.get(j).nodes.size();
																	Double nHapnSeq = new Double(nHap/nSeq); // System.out.println("npop/nh = " + npop/nh);
																	nHapnSeqs.add(nHapnSeq);
																	
																	// Computation of Ar in the given population:
																	double Rg = 0;
																	double Ng = input.loci.get(h).populations.get(j).nodes.size();
																	for (int l = 0; l < input.loci.get(h).haplotypes.size(); l++)
																		{
																			double Ngj = 0;
																			for (int m = 0; m < Ng; m++)
																				{
																					int a = 0;
																					a = input.loci.get(h).nodesMismatches[input.loci.get(h).haplotypes.get(l).nodeMismatchesIndex][input.loci.get(h).populations.get(j).nodes.get(m).nodeMismatchesIndex];
																					if (a == 0)
																						{
																							Ngj = Ngj + 1;
																						}
																				}
																			if (Nss[h] > (Ng-Ngj))
																				{
																					Rg = Rg + 1;
																				}
																			else
																				{
																					double c1 = this.binomialCoefficient((Ng-Ngj),Nss[h]);
																					double c2 = this.binomialCoefficient(Ng,Nss[h]);
																					Rg = Rg + (1-(c1/c2));
																				} 	
																		}
																	Double arDouble = new Double(Rg); // System.out.println("ar = " + ar);
																	ars.add(arDouble);									
																	
																	// Computation of Pi in the given population:
																	double n = 0;
																	double pi = 0;
																	for (int k = 1; k < input.loci.get(h).populations.get(j).nodes.size(); k++)
																		{
																			for (int l = 0; l < k; l++)
																				{
																					double a = 0;				
																					double p = 0;
																					n = n + 1;
																					a = input.loci.get(h).nodesMismatches[input.loci.get(h).populations.get(j).nodes.get(k).nodeMismatchesIndex][input.loci.get(h).populations.get(j).nodes.get(l).nodeMismatchesIndex]; 
																					p = a/(input.loci.get(h).length);
																					pi = pi + p;
																				}
																		}
																	pi = pi/n;
																	Double piDouble = new Double(pi); // System.out.println("pi = " + pi);
																	pis.add(piDouble);
																		
																	// Computation of Pir in the given population:
																	n = 0;
																	pi = 0;
																	double pir = 0;
																	for (int k = 1; k < input.loci.get(h).populations.get(j).nodes.size(); k++)
																		{
																			for (int l = 0; l < k; l++)
																				{
																					double a = 0;				
																					double p = 0;
																					n = n + 1;
																					a = input.loci.get(h).nodesMismatches[input.loci.get(h).populations.get(j).nodes.get(k).nodeMismatchesIndex][input.loci.get(h).populations.get(j).nodes.get(l).nodeMismatchesIndex]; 
																					p = a/(input.loci.get(h).length);
																					pi = pi + p;
																				}
																		}
																	pi = pi/n;
																	ArrayList<Node> rest = new ArrayList<Node> ();
																	for (int k = 0; k < input.loci.get(h).populations.size(); k++)
																		{
																			if (input.loci.get(h).populations.get(k).popID != input.loci.get(h).populations.get(j).popID)
																				{
																					rest.addAll(input.loci.get(h).populations.get(k).nodes);
																				}
																		}
									
																	double nRest = 0;
																	double piRest = 0;
																	for (int k = 1; k < rest.size(); k++)
																		{
																			for (int l = 0; l < k; l++)
																				{
																					double a = 0;				
																					double p = 0;
																					nRest = nRest + 1;
																					a = input.loci.get(h).nodesMismatches[rest.get(k).nodeMismatchesIndex][rest.get(l).nodeMismatchesIndex];
																					p = a/(input.loci.get(h).length);
																					piRest = piRest + p;
																				}
																		}
																	piRest = piRest/nRest;
																	pir = pi/piRest;
																	Double pirDouble = new Double(pir); // System.out.println("pir = " + pir);
																	pirs.add(pirDouble);
																}							
														}
												}
										}
									nHapnSeqsArrayList.add(nHapnSeqs);
									arsArrayList.add(ars);
									pisArrayList.add(pis);
									pirsArrayList.add(pirs);
								}
							ArrayList<String> populationsNamesBuffer = new ArrayList<String>();
							for (int i = 0; i < populationsNames.size(); i++)
								{
									double nberOfStats = 0;
									double meanNpopNhtot = 0;
									double meanAr = 0;
									double meanPi = 0;
									double meanPir = 0;
									boolean twoGeneCopiesForAtLeastForOneLocus = false;
									for (int h = 0; h < input.loci.size(); h++)
										{
											if (nHapnSeqsArrayList.get(i).get(h).doubleValue() == -999)
												{
													// System.out.print("input.loci.get(h).ID = " + input.loci.get(h).ID);
													// System.out.println(" - " + populationsNames.get(i));
												}
											else
												{
													twoGeneCopiesForAtLeastForOneLocus = true;
													nberOfStats = nberOfStats + 1;
													meanNpopNhtot = meanNpopNhtot + nHapnSeqsArrayList.get(i).get(h).doubleValue();
													meanAr = meanAr + arsArrayList.get(i).get(h).doubleValue();
													meanPi = meanPi + pisArrayList.get(i).get(h).doubleValue();
													meanPir = meanPir + pirsArrayList.get(i).get(h).doubleValue();
												}
										}
									if (twoGeneCopiesForAtLeastForOneLocus == true)
										{
											populationsNamesBuffer.add(populationsNames.get(i));
											Double meanNpopNhtotDouble = new Double(meanNpopNhtot/nberOfStats);
											Double meanArDouble = new Double(meanAr/nberOfStats);
											Double meanPiDouble = new Double(meanPi/nberOfStats);
											Double meanPirDouble = new Double(meanPir/nberOfStats);
											meanNpopNhtots.add(meanNpopNhtotDouble);
											meanArs.add(meanArDouble);
											meanPis.add(meanPiDouble);
											meanPirs.add(meanPirDouble);
										}
								}
							populationsNames = new ArrayList<String>(); populationsNames.addAll(populationsNamesBuffer);
							if (minimumTwoSequencesPerPopulation == false)
								{	
									externalMessage.add("	some populations with less than 2 sampled sequences/locus were discarded from the GDivPAL input building: " + popsWithoutAtLeast2Nodes);
									minimumTwoSequencesPerPopulation = true;
								}
							if (minimumTwoSequencesPerPopulation == true)
								{
									boolean popFound = false;
									externalMessage.add("");
									externalMessage.add("GDivPAL inputs based on allelic richness estimated within each population");
									externalMessage.add("(longitude	latitude	Ar):");
									externalFile = new ArrayList<String>();
									for (int i = 0; i < populationsNames.size(); i++)
										{
											popFound = false;
											String line = new String();				
											for (int h = 0; h < input.loci.size(); h++)
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (popFound == false & input.loci.get(h).populations.get(j).popName.equals(populationsNames.get(i)))
																{
																	popFound = true;
																	line = input.loci.get(h).populations.get(j).position[1] + "	" + input.loci.get(h).populations.get(j).position[0] + "	" + meanArs.get(i).doubleValue();
																}
														}
												}
											externalMessage.add(line);
											externalFile.add(line);
										}
									OutputFileWriter.writeOutput1(externalFile, window.getInputName() + "_GDivPAL_input_Ar.txt");
									
									externalMessage.add("");
									externalMessage.add("GDivPAL inputs based on nucleotide diversity estimated within each population");
									externalMessage.add("(longitude	latitude	Pi):");
									externalFile = new ArrayList<String>();
									for (int i = 0; i < populationsNames.size(); i++)
										{
											popFound = false;
											String line = new String();				
											for (int h = 0; h < input.loci.size(); h++)
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (popFound == false & input.loci.get(h).populations.get(j).popName.equals(populationsNames.get(i)))
																{
																	popFound = true;
																	line = input.loci.get(h).populations.get(j).position[1] + "	" + input.loci.get(h).populations.get(j).position[0] + "	" + meanPis.get(i).doubleValue();
																}
														}
												}
											externalMessage.add(line);
											externalFile.add(line);
										}
									OutputFileWriter.writeOutput1(externalFile, window.getInputName() + "_GDivPAL_input_Pi.txt");
									
									externalMessage.add("");
									externalMessage.add("GDivPAL inputs based on relative nucleotide diversity estimated for each population");
									externalMessage.add("(longitude	latitude	Pir):");
									externalFile = new ArrayList<String>();
									for (int i = 0; i < populationsNames.size(); i++)
										{
											popFound = false;
											String line = new String();	
											for (int h = 0; h < input.loci.size(); h++)
												{
													for (int j = 0; j < input.loci.get(h).populations.size(); j++)
														{
															if (popFound == false & input.loci.get(h).populations.get(j).popName.equals(populationsNames.get(i)))
																{
																	popFound = true;
																	line = input.loci.get(h).populations.get(j).position[1] + "	" + input.loci.get(h).populations.get(j).position[0] + "	" + meanPirs.get(i).doubleValue();
																}
														}
												}
											externalMessage.add(line);
											externalFile.add(line);
										}
									OutputFileWriter.writeOutput1(externalFile, window.getInputName() + "_GDivPAL_input_Pir.txt");
								}	
						}
				}
		}
	
	// Method to compute a binomial coefficient from parameters n & p:
	public double binomialCoefficient(double n, double p)
		{
			double a = (n-(p-1)); double c = 1;
			for (int i = (int) (n-(p-1)); i < n; i++)
				{
					a = a*(i+1);
				}
			for (int i = 0; i < p; i++)
				{
					c = c*(i+1);
				}
			// System.out.println(n + " - " + p + " - " + a + " - " + c);
			return (a/c);
		}
}
