package spads1;

// Class created by Robert Sedgewick and Kevin Wayne

public class LinearRegression { 

	public double beta1;
	public double beta0;

    public LinearRegression()
    	{  }
    
    public double Regression(double[] x, double[] y)
    	{ 
	        int n = x.length;

	        // First pass: read in data, compute xbar and ybar
	        double sumx = 0.0, sumy = 0.0, sumx2 = 0.0;
	        for (int i = 0; i < n; i++) 
		        {
		            sumx = sumx + x[i]; // System.out.println("y = " + y[i]);
		            sumx2 = sumx2 + (x[i]*x[i]);
		            sumy = sumy + y[i]; // System.out.println("y = " + y[i]);
		            // System.out.println(y[i] + "	" + x[i]);
		        }
	        double xbar = sumx/n; 
	        double ybar = sumy/n;
	
	        // Second pass: compute summary statistics
	        double xxbar = 0, yybar = 0, xybar = 0;
	        for (int i = 0; i < n; i++) 
		        {
		            xxbar = xxbar + ((x[i] - xbar) * (x[i] - xbar));
		            yybar = yybar + ((y[i] - ybar) * (y[i] - ybar));
		            xybar = xybar + ((x[i] - xbar) * (y[i] - ybar));
		        }
	        beta1 = xybar / xxbar;
	        beta0 = ybar - beta1 * xbar;
	
	        /* To print results:
	        System.out.println("y   = " + beta1 + " * x + " + beta0); */
	        /* To analyze results:
	        int df = n - 2;
	        double rss = 0.0;      // residual sum of squares
	        double ssr = 0.0;      // regression sum of squares
	        for (int i = 0; i < n; i++) 
		        {
		            double fit = beta1*x[i] + beta0;
		            rss += (fit - y[i]) * (fit - y[i]);
		            ssr += (fit - ybar) * (fit - ybar);
		        }
	        double R2 = ssr / yybar;
	        double svar = rss / df;
	        double svar1 = svar / xxbar;
	        double svar0 = svar/n + xbar*xbar*svar1;
	        svar0 = svar * sumx2 / (n * xxbar);
	        System.out.println("R^2 = " + R2);
	        System.out.println("std error of beta_1 = " + Math.sqrt(svar1));
	        System.out.println("std error of beta_0 = " + Math.sqrt(svar0));
	        System.out.println("std error of beta_0 = " + Math.sqrt(svar0));
	        System.out.println("SSTO = " + yybar);
	        System.out.println("SSE = " + rss);
	        System.out.println("SSR = " + ssr); */
	        return beta1;
    	}
}
