package spads1;

// Class created by Simon Dellicour (June 2011)

import java.util.ArrayList;

public class SummaryStatistics 
{
	private InputFileReader input;
	public ArrayList<String> results;
	public ArrayList<ArrayList<Node>> nodesInGroupPerLocus;
	public ArrayList<String> externalMessage;
	public SimThread simTestThread;
	
	public SummaryStatistics(InputFileReader input0, Interface window, SimThread simTestThread0)
		{
			input = input0;
			results = new ArrayList<String>();
			results.add("Summary statistics computations: ");
			nodesInGroupPerLocus = new ArrayList<ArrayList<Node>>();
			externalMessage = new ArrayList<String>();
			simTestThread = simTestThread0;
			
			// 1 step: computing Nhtot, the number of polymorphic sites and building the "nodesMismatches" and "pairwiseFst" matrices:
			for (int h = 0; h < input.numberOfLoci; h++)
				{
					ArrayList<Node> nodes = new ArrayList<Node>();
					for (int i = 0; i < input.loci.get(h).populations.size(); i++)
						{
							nodes.addAll(input.loci.get(h).populations.get(i).nodes);
						}
					input.loci.get(h).nodes = new ArrayList<Node>();
					input.loci.get(h).nodes.addAll(nodes);
					
					input.loci.get(h).nodesMismatches = new int[nodes.size()][nodes.size()];
					input.loci.get(h).haplotypes = new ArrayList<Node>();
					double[] polymorphicSites = new double[(int) input.loci.get(h).length];
					for (int i = 0; i < polymorphicSites.length; i++)
						{
							polymorphicSites[i] = 0;
						}
					boolean uncertainty = false;
					try {	
							for (int i = 0; i < nodes.size(); i++)
								{
									int c = 0;
									for (int l = 0; l < nodes.get(i).sequence.size(); l++)
										{
											String b = new String(); b = nodes.get(i).sequence.get(l);
											if (b.equals("a")|b.equals("c")|b.equals("t")|b.equals("g")|b.equals("A")|b.equals("C")|b.equals("T")|b.equals("G"))
												{	}
											else {	c = c+1; }
										}
									nodes.get(i).nberOfUncertainties = c;
									// System.out.println(nodes.get(i).nodeName + "-" + nodes.get(i).popName + " " + nodes.get(i).nberOfUncertainties);
								}
							for (int i = 0; i < nodes.size(); i++)
								{
									nodes.get(i).nodeMismatchesIndex = i;
									for (int j = 0; j < nodes.size(); j++)
										{
											int a = 0;
											for (int l = 0; l < nodes.get(i).sequence.size(); l++)
												{
													uncertainty = false;
													if (nodes.get(i).sequence.get(l).equalsIgnoreCase(nodes.get(j).sequence.get(l)))
														{	}
													else 
														{	
															String b = new String(); b = nodes.get(i).sequence.get(l);
															String c = new String(); c = nodes.get(j).sequence.get(l);
															if (b.equals("a")|b.equals("c")|b.equals("t")|b.equals("g")|b.equals("A")|b.equals("C")|b.equals("T")|b.equals("G"))
																{	}
															else {	uncertainty = true; }
															if (c.equals("a")|c.equals("c")|c.equals("t")|c.equals("g")|c.equals("A")|c.equals("C")|c.equals("T")|c.equals("G"))
																{	}
															else {	uncertainty = true; }
															if (uncertainty == false)
																{
																	a = a + 1;
																	polymorphicSites[l] = 1;
																}
														}
												}
											input.loci.get(h).nodesMismatches[i][j] = a; input.loci.get(h).nodesMismatches[j][i] = a; // System.out.print(a + " ");
										}
								}							
							for (int i = 0; i < polymorphicSites.length; i++)
								{
									input.loci.get(h).polymorphicSites = input.loci.get(h).polymorphicSites + (double)polymorphicSites[i];
								}
							
							int index = 0;
							nodes.get(0).haplotypeMismatchesIndex = index;
							input.loci.get(h).haplotypes.add(nodes.get(0));
							for (int i = 0; i < nodes.size(); i++)
								{
									int a = 0;
									boolean lessUncertainties = false;
									int haplotypeToReplace = -1;
									for (int j = 0; j < input.loci.get(h).haplotypes.size(); j++)
										{
											if (0 == input.loci.get(h).nodesMismatches[nodes.get(i).nodeMismatchesIndex][input.loci.get(h).haplotypes.get(j).nodeMismatchesIndex])
												{	
													a = a + 1;
													nodes.get(i).haplotypeMismatchesIndex = input.loci.get(h).haplotypes.get(j).haplotypeMismatchesIndex;
													if (input.loci.get(h).haplotypes.get(j).nberOfUncertainties > nodes.get(i).nberOfUncertainties)
														{
															lessUncertainties = true;
															haplotypeToReplace = j;
														}
												}
										}
									if (a == 0)
										{
											input.loci.get(h).haplotypes.add(nodes.get(i));
											index = index + 1;
											nodes.get(i).haplotypeMismatchesIndex = index;
										}
									if ((a > 0) & (lessUncertainties == true))
										{
											input.loci.get(h).haplotypes.set(haplotypeToReplace, nodes.get(i));
										}
								}
							input.loci.get(h).haplotypesMismatches = new int[input.loci.get(h).haplotypes.size()][input.loci.get(h).haplotypes.size()];
							for (int i = 0; i < input.loci.get(h).haplotypes.size(); i++)
								{
									for (int j = 0; j < input.loci.get(h).haplotypes.size(); j++)
										{
											input.loci.get(h).haplotypesMismatches[i][j] = input.loci.get(h).nodesMismatches[input.loci.get(h).haplotypes.get(i).nodeMismatchesIndex][input.loci.get(h).haplotypes.get(j).nodeMismatchesIndex];
											// System.out.print(input.loci.get(h).haplotypesMismatches[i][j] + "	");
										}	// System.out.println();
								}			// System.out.println();
							
							input.loci.get(h).haplotypesInPopsWithMoreThanOneGeneCopy = new ArrayList<Node>();
							for (int i = 0; i < input.loci.get(h).haplotypes.size(); i++)
								{
									double a = 0;
									for (int j = 0; j < input.loci.get(h).populations.size(); j++)
										{
											if (input.loci.get(h).populations.get(j).nodes.size() > 1)
												{
													for (int k = 0; k < input.loci.get(h).populations.get(j).nodes.size(); k++)
														{
															if (0 == input.loci.get(h).nodesMismatches[input.loci.get(h).haplotypes.get(i).nodeMismatchesIndex][input.loci.get(h).populations.get(j).nodes.get(k).nodeMismatchesIndex])
																{	a = a + 1; }
														}
												}
										}
									if (a > 0)
										{
											input.loci.get(h).haplotypesInPopsWithMoreThanOneGeneCopy.add(input.loci.get(h).haplotypes.get(i));
										}	
								}
							input.loci.get(h).pairwiseFstPop = new double[input.loci.get(h).populations.size()][input.loci.get(h).populations.size()];
							input.loci.get(h).pairwiseFstPopNumerator = new double[input.loci.get(h).populations.size()][input.loci.get(h).populations.size()];
							input.loci.get(h).pairwiseFstPopDenominator = new double[input.loci.get(h).populations.size()][input.loci.get(h).populations.size()];
							double[] FST = new double[3];
							for (int i = 0; i < input.loci.get(h).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(h).populations.size(); j++)
										{
											FST = new double[3];
											ArrayList<Population> populations0 = new ArrayList<Population>();											
											populations0.add(input.loci.get(h).populations.get(i));
											populations0.add(input.loci.get(h).populations.get(j));
											FST = this.globalFst(input.loci.get(h), populations0, nodes, false, false);
											input.loci.get(h).pairwiseFstPop[i][j] = FST[0];
											input.loci.get(h).pairwiseFstPop[j][i] = FST[0];
											input.loci.get(h).pairwiseFstPopNumerator[i][j] = FST[1];
											input.loci.get(h).pairwiseFstPopNumerator[j][i] = FST[1];
											input.loci.get(h).pairwiseFstPopDenominator[i][j] = FST[2];
											input.loci.get(h).pairwiseFstPopDenominator[j][i] = FST[2];
										}
								}
							if (input.pairwiseMonmonierDistances == false)
								{
									double fst = 0;
									input.loci.get(h).monmonierDistances = new double[input.loci.get(h).populations.size()][input.loci.get(h).populations.size()];
									Double Fst = new Double(0);
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < input.loci.get(h).populations.size(); j++)
												{
													fst = 0; fst = input.loci.get(h).pairwiseFstPop[i][j];
													Fst = new Double(fst);
													if (Fst.isNaN())
														{
															fst = 0;
														}
													input.loci.get(h).monmonierDistances[i][j] = fst;
													input.loci.get(h).monmonierDistances[j][i] = fst;                        
												}
										}
								}
							/* To print a matrix of population distances based on the Euclidian distance between geographic coordinates:
							double dgeo = 0;
							for (int i = 0; i < input.loci.get(h).populations.size(); i++)
								{
									for (int j = 0; j < input.loci.get(h).populations.size(); j++)
										{
											ArrayList<Population> populations0 = new ArrayList<Population>();											
											populations0.add(input.loci.get(h).populations.get(i));
											populations0.add(input.loci.get(h).populations.get(j));	
											dgeo = this.populationsDistance(input.loci.get(h).populations, i, j);
											System.out.print(dgeo + "	");
										}	System.out.println();
								} 			System.out.println();//*/
						}
					catch (Exception e1) 
						{	}
				}
			
			double combinedGst = 0; double GstNumerator = 0; double GstDenominator = 0; double combinedGstpValue = 0;
			double combinedNst = 0; double NstNumerator = 0; double NstDenominator = 0; double combinedNstpValue = 0;
			double combinedNst_Gst = 0; double combinedNst_GstpValue = 0;
			double combinedFst = 0; double FstNumerator = 0; double FstDenominator = 0; double combinedFstpValue = 0;
			double combinedAmovaFsc = 0; double amovaFscNumerator = 0; double amovaFscDenominator = 0; double combinedAmovaFscpValue = 0;
			double combinedAmovaFst = 0; double amovaFstNumerator = 0; double amovaFstDenominator = 0; double combinedAmovaFstpValue = 0;
			double combinedAmovaFct = 0; double amovaFctNumerator = 0; double amovaFctDenominator = 0; double combinedAmovaFctpValue = 0;

			Amova amova = new Amova();
			// 2 step: performing the permutations for the different F-statistics:
			for (int h = 0; h < input.numberOfLoci; h++)
				{
					ArrayList<Node> nodes = new ArrayList<Node>();
					for (int i = 0; i < input.loci.get(h).populations.size(); i++)
						{
							nodes.addAll(input.loci.get(h).populations.get(i).nodes);
						}
					if (window.checkBoxGstNst.isSelected())
						{
							double[] GstNst = this.globalGstNst(input.loci.get(h),nodes,false,input.loci.get(h).nodesMismatches); // to compute the real values
							input.loci.get(h).Gst = GstNst[0]; input.loci.get(h).Nst = GstNst[1];
							input.loci.get(h).NstGst = input.loci.get(h).Nst-input.loci.get(h).Gst;
							GstNumerator = GstNumerator + GstNst[2]; GstDenominator = GstDenominator + GstNst[3];
							NstNumerator = NstNumerator + GstNst[4]; NstDenominator = NstDenominator + GstNst[5];
						}
					if (window.checkBoxFst.isSelected())
						{
						    double[] FST = new double[3]; FST = this.globalFst(input.loci.get(h), input.loci.get(h).populations, nodes, false, false);
							input.loci.get(h).Fst = FST[0];
							FstNumerator = FstNumerator + FST[1]; FstDenominator = FstDenominator + FST[2];
						}
					if (window.checkBoxAMOVA.isSelected() & (input.loci.get(h).userGroups.size() > 1))
						{
							ArrayList<Node> nodesInGroups = new ArrayList<Node>();
							for (int i = 0; i < input.loci.get(h).userGroups.size(); i++)
								{
									for (int j = 0; j < input.loci.get(h).userGroups.get(i).populations.size(); j++)
										{
											nodesInGroups.addAll(input.loci.get(h).userGroups.get(i).populations.get(j).nodes);
										}
								}
							nodesInGroupPerLocus.add(nodesInGroups);
							double[] Fstats = new double[12]; Fstats = amova.amova(h, input.loci.get(h), input.loci.get(h).userGroups, nodesInGroups, 0, simTestThread);
							input.loci.get(h).amovaFsc = Fstats[0]; amovaFscNumerator = amovaFscNumerator + Fstats[6]; amovaFscDenominator = amovaFscDenominator + Fstats[7];
							input.loci.get(h).amovaFst = Fstats[1]; amovaFstNumerator = amovaFstNumerator + Fstats[8]; amovaFstDenominator = amovaFstDenominator + Fstats[9];
							input.loci.get(h).amovaFct = Fstats[2]; amovaFctNumerator = amovaFctNumerator + Fstats[10]; amovaFctDenominator = amovaFctDenominator + Fstats[11];
							// System.out.println(Fstats[6] + "	" + Fstats[7] + "	" + Fstats[8] + "	" + Fstats[9] + "	" + Fstats[10] + "	" + Fstats[11]);
						}
				}
			combinedGst = GstNumerator/GstDenominator;
			combinedNst = NstNumerator/NstDenominator;
			combinedNst_Gst = combinedNst - combinedGst;
			combinedFst = FstNumerator/FstDenominator;
			combinedAmovaFsc = amovaFscNumerator/amovaFscDenominator;
			combinedAmovaFst = amovaFstNumerator/amovaFstDenominator;
			combinedAmovaFct = amovaFctNumerator/amovaFctDenominator;
			
			ArrayList<Node> permutationsNodes = new ArrayList<Node>();
			ArrayList<Node> permutationsHaplotypes = new ArrayList<Node>();
			Permutations permutations = new Permutations(); double[] permutationsGstNst = new double[6];
			double permutationsGst = 0; double permutationsNst = 0; double permutationsNstGst = 0;
			double permutCombinedGst = 0; double permutGstNumerator = 0; double permutGstDenominator = 0; 
			double permutCombinedNst = 0; double permutNstNumerator = 0; double permutNstDenominator = 0;
			double permutGstNumeratorDif = 0; double permutGstDenominatorDif = 0; 
			double permutNstNumeratorDif = 0; double permutNstDenominatorDif = 0;
			double permutCombinedNst_Gst = 0;
			if (window.checkBoxGstNst.isSelected() & (window.getPermutationsGstNst() > 0))
				{
					for (int i = 0; i < (int) window.getPermutationsGstNst(); i++)
						{
							permutCombinedGst = 0; permutGstNumerator = 0; permutGstDenominator = 0; 
							permutCombinedNst = 0; permutNstNumerator = 0; permutNstDenominator = 0;
							permutGstNumeratorDif = 0; permutGstDenominatorDif = 0; 
							permutNstNumeratorDif = 0; permutNstDenominatorDif = 0;
							permutCombinedNst_Gst = 0;
							for (int h = 0; h < input.loci.size(); h++)
								{
									permutationsNodes = new ArrayList<Node>();
									permutationsHaplotypes = new ArrayList<Node>();
									permutations = new Permutations();
									permutations.permutationsGlabalGstNstFst(input.loci.get(h).nodes);
									permutationsGstNst = this.globalGstNst(input.loci.get(h),input.loci.get(h).nodes,true,input.loci.get(h).nodesMismatches);
									permutationsGst = permutationsGstNst[0]; permutationsNst = permutationsGstNst[1];
									permutGstNumerator = permutGstNumerator + permutationsGstNst[2]; permutGstDenominator = permutGstDenominator + permutationsGstNst[3];
									permutNstNumerator = permutNstNumerator + permutationsGstNst[4]; permutNstDenominator = permutNstDenominator + permutationsGstNst[5];
									
									permutationsHaplotypes = permutations.permutationsHaplotypes(input.loci.get(h).haplotypes);
									input.loci.get(h).permutHaplotypesMismatches = new int[input.loci.get(h).haplotypes.size()][input.loci.get(h).haplotypes.size()];
									for (int j = 0; j < permutationsHaplotypes.size(); j++)
										{
											for (int k = 0; k < permutationsHaplotypes.size(); k++)
												{
													input.loci.get(h).permutHaplotypesMismatches[j][k] = input.loci.get(h).nodesMismatches[permutationsHaplotypes.get(j).nodeMismatchesIndex][permutationsHaplotypes.get(k).nodeMismatchesIndex];
													// System.out.print(input.loci.get(h).permutHaplotypesMismatches[j][k] + "	");
												}	// System.out.println();
										}			// System.out.println();
									input.loci.get(h).permutHaplotypesNodesMismatches = new int[input.loci.get(h).nodes.size()][input.loci.get(h).nodes.size()];
									for (int j = 0; j < input.loci.get(h).nodes.size(); j++)
										{
											for (int k = 0; k < input.loci.get(h).nodes.size(); k++)
												{
													input.loci.get(h).permutHaplotypesNodesMismatches[j][k] = input.loci.get(h).permutHaplotypesMismatches[input.loci.get(h).nodes.get(j).haplotypeMismatchesIndex][input.loci.get(h).nodes.get(k).haplotypeMismatchesIndex];
												}
										}
									permutationsGstNst = this.globalGstNst(input.loci.get(h),input.loci.get(h).nodes,false,input.loci.get(h).permutHaplotypesNodesMismatches);
									permutationsNstGst = permutationsGstNst[1]-permutationsGstNst[0];
									permutGstNumeratorDif = permutGstNumeratorDif + permutationsGstNst[2]; permutGstDenominatorDif = permutGstDenominatorDif + permutationsGstNst[3];
									permutNstNumeratorDif = permutNstNumeratorDif + permutationsGstNst[4]; permutNstDenominatorDif = permutNstDenominatorDif + permutationsGstNst[5];
									
									if (permutationsGst < input.loci.get(h).Gst)
										{	}
									else
										{
											input.loci.get(h).pValueGst = input.loci.get(h).pValueGst + 1;
										}
									if (permutationsNst < input.loci.get(h).Nst)
										{	}
									else
										{
											input.loci.get(h).pValueNst = input.loci.get(h).pValueNst + 1;
										}
									if (permutationsNstGst < input.loci.get(h).NstGst)
										{	}
									else
										{
											input.loci.get(h).pValueNstGst = input.loci.get(h).pValueNstGst + 1;
										}
								}
							simTestThread.run("   Gst & Nst, permutation " + (i+1)/* + "       " + (((double)(Math.round(permutationsGst*1000)))/1000)*/);
							
							permutCombinedGst = permutGstNumerator/permutGstDenominator;
							permutCombinedNst = permutNstNumerator/permutNstDenominator;
							permutCombinedNst_Gst = (permutNstNumeratorDif/permutNstDenominatorDif) - (permutGstNumeratorDif/permutGstDenominatorDif);
							if (permutCombinedGst < combinedGst)
								{	}
							else
								{
									combinedGstpValue = combinedGstpValue + 1;
								}
							if (permutCombinedNst < combinedNst)
								{	}
							else
								{
									combinedNstpValue = combinedNstpValue + 1;
								}
							if (permutCombinedNst_Gst < combinedNst_Gst)
								{	}
							else
								{
									combinedNst_GstpValue = combinedNst_GstpValue + 1;
								}
						}
					for (int h = 0; h < input.loci.size(); h++)
						{
							input.loci.get(h).pValueGst = (input.loci.get(h).pValueGst/window.getPermutationsGstNst());
							input.loci.get(h).pValueNst = (input.loci.get(h).pValueNst/window.getPermutationsGstNst());
							input.loci.get(h).pValueNstGst = (input.loci.get(h).pValueNstGst/window.getPermutationsGstNst());
						}
				}
			if (window.checkBoxGstNst.isSelected() & (input.numberOfLoci > 1))
				{
					results.add("");
					results.add("	Gst (Pons & Petit, 1995) on combined loci = " + (float) combinedGst + "	(p-val = " + (combinedGstpValue/window.getPermutationsGstNst()) + ")");
					results.add("	Nst (Pons & Petit, 1996) on combined loci = " + (float) combinedNst + "	(p-val = " + (combinedNstpValue/window.getPermutationsGstNst()) + ")"); 
					results.add("	Nst-Gst on combined loci = " + (float) combinedNst_Gst + "	(p-val = " + (combinedNst_GstpValue/window.getPermutationsGstNst()) + ")"); //*/
				}
			
			double permutationsFst = 0;
			double permutCombinedFst = 0; double permutFstNumerator = 0; double permutFstDenominator = 0;
			if (window.checkBoxFst.isSelected() & (window.getPermutationsFst() > 0))
				{
					for (int i = 0; i < (int) window.getPermutationsFst(); i++)
						{
							permutCombinedFst = 0; permutFstNumerator = 0; permutFstDenominator = 0;
							for (int h = 0; h < input.loci.size(); h++)
								{
									permutationsNodes = new ArrayList<Node>(); permutations = new Permutations();
									permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(input.loci.get(h).nodes));
									double[] FST = new double[3]; FST = this.globalFst(input.loci.get(h), input.loci.get(h).populations, permutationsNodes, true, false); // to compute a "permut" Fst
									permutationsFst = FST[0];
									permutFstNumerator = permutFstNumerator + FST[1]; permutFstDenominator = permutFstDenominator + FST[2];
									if (permutationsFst < input.loci.get(h).Fst)
										{	}
									else
										{
											input.loci.get(h).pValueFst = input.loci.get(h).pValueFst + 1;
										}
								}
							simTestThread.run("   PhiST, permutation " + (i+1)/* + "       " + (((double)(Math.round(permutationsFst*1000)))/1000)*/);
							permutCombinedFst = permutFstNumerator/permutFstDenominator;
							if (permutCombinedFst < combinedFst)
								{	}
							else
								{
									combinedFstpValue = combinedFstpValue + 1;
								}
						}
					for (int h = 0; h < input.loci.size(); h++)
						{
							input.loci.get(h).pValueFst = (input.loci.get(h).pValueFst/window.getPermutationsFst());
						}
				}
			if (window.checkBoxFst.isSelected() & (input.numberOfLoci > 1))
				{
					results.add("	PhiST (Excoffier et al, 1992) on combined loci = " + (float) combinedFst + "	(p-val = " + (combinedFstpValue/window.getPermutationsFst()) + ")");
				}
				
			ArrayList<Group> permutationsGroups = new ArrayList<Group>();
			double permutationsAMOVAFsc = 0; double permutationsAMOVAFst = 0; double permutationsAMOVAFct = 0;
			double[] Fstats = new double[12];
			double permutCombinedAmovaFsc = 0; double permutAmovaFscNumerator = 0; double permutAmovaFscDenominator = 0;
			double permutCombinedAmovaFst = 0; double permutAmovaFstNumerator = 0; double permutAmovaFstDenominator = 0;
			double permutCombinedAmovaFct = 0; double permutAmovaFctNumerator = 0; double permutAmovaFctDenominator = 0;
			if (window.checkBoxAMOVA.isSelected() & (window.getPermutationsAMOVA() > 0) & (input.sameNodesInDifferentGroups == false))
				{
					if (input.loci.get(0).userGroups.size() < 2)
						{
							simTestThread.run("    groups of populations.");
							simTestThread.run("AMOVA analysis requires at least two defined");
						}
					else
						{
							for (int i = 0; i < (int) window.getPermutationsAMOVA(); i++)
								{
									permutCombinedAmovaFsc = 0; permutAmovaFscNumerator = 0; permutAmovaFscDenominator = 0;
									permutCombinedAmovaFst = 0; permutAmovaFstNumerator = 0; permutAmovaFstDenominator = 0;
									permutCombinedAmovaFct = 0; permutAmovaFctNumerator = 0; permutAmovaFctDenominator = 0;
									for (int h = 0; h < input.loci.size(); h++)
										{
											permutationsAMOVAFsc = 0;
											permutationsNodes = new ArrayList<Node>(); permutations = new Permutations();
											// permutationsNodes.addAll(permutations.permutationsAMOVAFsc(input.loci.get(h).nodes, input.loci.get(h).userGroups)); FALSE!!
											permutationsNodes.addAll(permutations.permutationsAMOVAFsc(nodesInGroupPerLocus.get(h), input.loci.get(h).userGroups));
											Fstats = new double[9]; Fstats = amova.amovaFstatistics(input.loci.get(h), input.loci.get(h).userGroups, permutationsNodes, true, false);
											permutationsAMOVAFsc = Fstats[0]; 
											permutAmovaFscNumerator = permutAmovaFscNumerator + Fstats[3]; permutAmovaFscDenominator = permutAmovaFscDenominator + Fstats[4];									
											if (permutationsAMOVAFsc < input.loci.get(h).amovaFsc)
												{	}
											else
												{
													input.loci.get(h).pValueamovaFsc = input.loci.get(h).pValueamovaFsc + 1;
												}
										}
									simTestThread.run("   AMOVA PhiSC, permutation " + (i+1)/* + "       " + (((double)(Math.round(permutationsFst*1000)))/1000)*/);
									permutCombinedAmovaFsc = permutAmovaFscNumerator/permutAmovaFscDenominator;
									if (permutCombinedAmovaFsc < combinedAmovaFsc)
										{	}
									else
										{
											combinedAmovaFscpValue = combinedAmovaFscpValue + 1;
										}
								}
							for (int h = 0; h < input.loci.size(); h++)
								{
									input.loci.get(h).pValueamovaFsc = (input.loci.get(h).pValueamovaFsc/window.getPermutationsAMOVA());
								}
							for (int i = 0; i < (int) window.getPermutationsAMOVA(); i++)
								{
									for (int h = 0; h < input.loci.size(); h++)
										{
											permutationsAMOVAFst = 0;
											permutationsNodes = new ArrayList<Node>(); permutations = new Permutations();
											// permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(input.loci.get(h).nodes)); FALSE!!
											permutationsNodes.addAll(permutations.permutationsGlabalGstNstFst(nodesInGroupPerLocus.get(h)));
											Fstats = new double[9]; Fstats = amova.amovaFstatistics(input.loci.get(h), input.loci.get(h).userGroups, permutationsNodes, true, false);
											permutationsAMOVAFst = Fstats[1];
											permutAmovaFstNumerator = permutAmovaFstNumerator + Fstats[5]; permutAmovaFstDenominator = permutAmovaFstDenominator + Fstats[6];
											if (permutationsAMOVAFst < input.loci.get(h).amovaFst)
												{	}
											else
												{
													input.loci.get(h).pValueamovaFst = input.loci.get(h).pValueamovaFst + 1;
												}
										}
									simTestThread.run("   AMOVA PhiST, permutation " + (i+1)/* + "       " + (((double)(Math.round(permutationsFst*1000)))/1000)*/);
									permutCombinedAmovaFst = permutAmovaFstNumerator/permutAmovaFstDenominator;
									if (permutCombinedAmovaFst < combinedAmovaFst)
										{	}
									else
										{
											combinedAmovaFstpValue = combinedAmovaFstpValue + 1;
										}
								}
							for (int h = 0; h < input.loci.size(); h++)
								{
									input.loci.get(h).pValueamovaFst = (input.loci.get(h).pValueamovaFst/window.getPermutationsAMOVA());
								}
							for (int i = 0; i < (int) window.getPermutationsAMOVA(); i++)
								{
									for (int h = 0; h < input.loci.size(); h++)
										{
											permutationsAMOVAFct = 0;
											permutationsGroups = new ArrayList<Group>(); permutations = new Permutations();
											permutationsGroups.addAll(permutations.permutationsAMOVAFct(input.loci.get(h).userGroups));
											Fstats = new double[9]; Fstats = amova.amovaFstatistics(input.loci.get(h),  permutationsGroups, input.loci.get(h).nodes, false, true);
											permutationsAMOVAFct = Fstats[2];
											permutAmovaFctNumerator = permutAmovaFctNumerator + Fstats[7]; permutAmovaFctDenominator = permutAmovaFctDenominator + Fstats[8];
											if (permutationsAMOVAFct < input.loci.get(h).amovaFct)
												{	}
											else
												{
													input.loci.get(h).pValueamovaFct = input.loci.get(h).pValueamovaFct + 1;
												}
										}
									simTestThread.run("   AMOVA PhiCT, permutation " + (i+1)/* + "       " + (((double)(Math.round(permutationsFst*1000)))/1000)*/);
									permutCombinedAmovaFct = permutAmovaFctNumerator/permutAmovaFctDenominator;
									if (permutCombinedAmovaFct < combinedAmovaFct)
										{	}
									else
										{
											combinedAmovaFctpValue = combinedAmovaFctpValue + 1;
										}
								}
							for (int h = 0; h < input.loci.size(); h++)
								{
									input.loci.get(h).pValueamovaFct = (input.loci.get(h).pValueamovaFct/window.getPermutationsAMOVA());
								}
						}
				}
			if (window.checkBoxAMOVA.isSelected() & (input.numberOfLoci > 1))
				{
					results.add("	AMOVA Phi-statistics on combined loci:");
					results.add("		PhiSC:   " + (float) combinedAmovaFsc + " (p-val = " + (combinedAmovaFscpValue/window.getPermutationsAMOVA()) + ")");
					results.add("		PhiST:   " + (float) combinedAmovaFst + " (p-val = " + (combinedAmovaFstpValue/window.getPermutationsAMOVA()) + ")");
					results.add("		PhiCT:   " + (float) combinedAmovaFct + " (p-val = " + (combinedAmovaFctpValue/window.getPermutationsAMOVA()) + ")");
					results.add("");
				}
	
			// 3 step: computation of the remaining statistics: 
			for (int h = 0; h < input.numberOfLoci; h++)
				{
					results.add("");
					results.add("LOCUS " + input.loci.get(h).ID);
					results.add("");
					ArrayList<Node> nodes = new ArrayList<Node>();
					for (int i = 0; i < input.loci.get(h).populations.size(); i++)
						{
							nodes.addAll(input.loci.get(h).populations.get(i).nodes);
						}
					
					// (1) Estimation of Nhtot, nodesIdentical and nodesMismatches matrices:											
					if (window.checkBoxNhtot.isSelected())
						{
							results.add("	Total number of haplotypes: " + input.loci.get(h).haplotypes.size());
						}
							
					// (2) and (3) Estimation of the Gst and Nst statistics (Pons & Petit, 1995, 1996):
					//		cfr. additional notations in green (x, X & deltaX) in the red notebook (29/12/10)
					try {		
							if (window.checkBoxGstNst.isSelected())
								{
									results.add("	Gst (Pons & Petit, 1995) = " + (float) input.loci.get(h).Gst + "	(p-val = " + input.loci.get(h).pValueGst + ")");
									results.add("	Nst (Pons & Petit, 1996) = " + (float) input.loci.get(h).Nst + "	(p-val = " + input.loci.get(h).pValueNst + ")"); 
									results.add("	Nst-Gst = " + (float) input.loci.get(h).NstGst + "	(p-val = " + input.loci.get(h).pValueNstGst + ")");
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Gst and Nst statistics.");
						}
					
					// (4) Estimation of the global Fst statistics for K=1 (Excoffier et al, 1992):
					try {
							if (window.checkBoxFst.isSelected()) 
								{
									results.add("	Global PhiST for K=1 (Excoffier et al, 1992) = " + (float) input.loci.get(h).Fst + "	(p-val = " + input.loci.get(h).pValueFst + ")");
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the global PhiST statistic.");
						}
					
					// (5) Estimation of the mFst/dgeo statistics, a new summary statistics (cfr. formula, mean of the ratios between Fst and geographic distance between populations):
					try {
							if (window.checkBoxmFstdgeo.isSelected())
								{
									double mFstdgeo = 0;
									double a = 0;
									for (int i = 1; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													a = a + 1;
													double Fst = 0; double dgeo = 0;
													ArrayList<Population> populations0 = new ArrayList<Population>();											
													populations0.add(input.loci.get(h).populations.get(i));
													populations0.add(input.loci.get(h).populations.get(j));
													double[] FST = new double[3]; FST = this.globalFst(input.loci.get(h), populations0, nodes, false, false);
													Fst = FST[0];
													dgeo = this.populationsDistance(input.loci.get(h).populations, i, j);
													if (Double.isNaN(Fst/dgeo))	{	}
													else 
														{
															mFstdgeo = mFstdgeo + (Fst/dgeo);
														}
												}
										}
									if (a > 0)
										{						
											mFstdgeo = mFstdgeo/a;
											results.add("	mPhiSTdgeo = " + (float) mFstdgeo);
										}
									else 
										{	}
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the mPhiSTdgeo statistic.");
						}	

					// (6) Estimation of the IBD regression slope coefficient (Rousset et al, 1996):
					try {
							if (window.checkBoxIBDSC.isSelected())
								{
									double beta1 = 0;
									double n1 = 0;
									for (int i = 1; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													double Fst = 0;
													ArrayList<Population> populations0 = new ArrayList<Population>();											
													populations0.add(input.loci.get(h).populations.get(i));
													populations0.add(input.loci.get(h).populations.get(j));
													double[] FST = new double[3]; FST = this.globalFst(input.loci.get(h), populations0, nodes, false, false);
													Fst = FST[0];
													if (Double.isNaN(Fst) | Double.isInfinite((Fst/(1-Fst)))) {	}
													else
														{
															n1 = n1 + 1;
														}						
												}
										}
									double[] x = new double[(int) n1]; double[] y = new double[(int) n1];
									double n2 = 0;
									for (int i = 1; i < input.loci.get(h).populations.size(); i++)
										{
											for (int j = 0; j < i; j++)
												{
													double Fst = 0;
													ArrayList<Population> populations0 = new ArrayList<Population>();											
													populations0.add(input.loci.get(h).populations.get(i));
													populations0.add(input.loci.get(h).populations.get(j));
													double[] FST = new double[3]; FST = this.globalFst(input.loci.get(h), populations0, nodes, false, false);
													Fst = FST[0];
													if (Double.isNaN(Fst) | Double.isInfinite((Fst/(1-Fst)))) {	}
													else
														{
															x[(int) n2] = Math.log(this.populationsDistance(input.loci.get(h).populations, j, i));
															y[(int) n2] = (Fst/(1-Fst));
															n2 = n2 + 1;
														}						
												}
										}
									LinearRegression regression = new LinearRegression();
									beta1 = regression.Regression(x,y);
									results.add("	IBD regression slope coefficient = " + (float) beta1);
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the IBD regression slope coefficient.");
						}
					
					if (input.loci.get(h).userGroups.size() > 0)
						{
							String groupsName = new String();
							for (int i = 0; i < (int) input.loci.get(h).userGroups.size(); i++)
								{
									groupsName = groupsName + input.loci.get(h).userGroups.get(i).name + "	";
								}
							results.add(" ");
							results.add("	User-defined groups:		" + groupsName);
							
							// (7.1) Estimation of the number of different haplotypes in each user-defined groups (Xhi):
							try {
									if (window.checkBoxXh.isSelected()) 
										{
											String Nseq = new String();
											String Nhis = new String();
											String Xhis = new String();
							
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double Nh = 0;
													for (int j = 0; j < input.loci.get(h).userGroups.get(i).nodes.size(); j++)
														{
															int b = 0;
															for (int k = 0; k < j; k++)
																{
																	int a = 0;
																	a = input.loci.get(h).nodesMismatches[input.loci.get(h).userGroups.get(i).nodes.get(j).nodeMismatchesIndex][input.loci.get(h).userGroups.get(i).nodes.get(k).nodeMismatchesIndex];
																	if (a == 0)
																		{
																			b = b + 1;
																		}
																}
															if (b == 0)
																{
																	Nh = Nh + 1;
																}
														}
													Nseq = Nseq + input.loci.get(h).userGroups.get(i).nodes.size() + "	";
													Nhis = Nhis + (int) Nh + "	";
													Xhis = Xhis + (float) (Nh/((double) input.loci.get(h).haplotypes.size())) + "	";
												}	
											results.add("		Nseq:	" + Nseq);
											results.add("		Nh:	" + Nhis);
											results.add("		Xh:	" + Xhis);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the Xh statistics.");
								}
							
							// (7.2) Estimation of nucleotidic diversity in each user-defined groups ( or "Pi"):
							try {
									if (window.checkBoxPi.isSelected()) 
										{
											String Pis = new String();
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double N = 0;
													double Pi = 0;
													for (int j = 1; j < input.loci.get(h).userGroups.get(i).nodes.size(); j++)
														{
															for (int k = 0; k < j; k++)
																{
																	N = N + 1;
																	double P = 0;
																	double a = 0;				
																	a = input.loci.get(h).nodesMismatches[input.loci.get(h).userGroups.get(i).nodes.get(j).nodeMismatchesIndex][input.loci.get(h).userGroups.get(i).nodes.get(k).nodeMismatchesIndex];
																	P = a/((double) input.loci.get(h).length);
																	Pi = Pi + P;
																}
														}
													Pis = Pis + (float) (Pi/N) + "	";
												}
											results.add("		Pi:	" + Pis);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the Pi (and PiS) statistics.");
								}
							
							// (7.3) Estimation of a relative nucleotidic diversity in each user-defined groups (Pir, cfr. notes & Mardulyn et al (2009)
								// Pir(i) = Pi(i)/Pi(of the "rest" = of the group formed by all the other populations which are not in the considered group)
							try {
									if (window.checkBoxPirs.isSelected()) 
										{
											String Pir = new String();
											double[] Pis = new double[input.loci.get(h).userGroups.size()];
											double[] PiRest = new double[input.loci.get(h).userGroups.size()];
											
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double N = 0;
													double Pi = 0;
													for (int j = 1; j < input.loci.get(h).userGroups.get(i).nodes.size(); j++)
														{
															for (int k = 0; k < j; k++)
																{
																	N = N + 1;
																	double P = 0;
																	double a = 0;				
																	a = input.loci.get(h).nodesMismatches[input.loci.get(h).userGroups.get(i).nodes.get(j).nodeMismatchesIndex][input.loci.get(h).userGroups.get(i).nodes.get(k).nodeMismatchesIndex];
																	P = a/((double) input.loci.get(h).length);
																	Pi = Pi + P;
																}
														}
													Pis[i] = Pi/N;
													
													ArrayList<Node> rest = new ArrayList<Node> ();
													for (int j = 0; j < input.loci.get(h).userGroups.size(); j++)
														{
															if (input.loci.get(h).userGroups.get(j).groupID != input.loci.get(h).userGroups.get(i).groupID)
																{
																	rest.addAll(input.loci.get(h).userGroups.get(j).nodes);
																}
														}
				
													double NRest = 0;
													double piRest = 0;
													for (int j = 1; j < rest.size(); j++)
														{
															for (int k = 0; k < j; k++)
																{
																	NRest = NRest + 1;
																	double P = 0;
																	double a = 0;				
																	a = input.loci.get(h).nodesMismatches[rest.get(j).nodeMismatchesIndex][rest.get(k).nodeMismatchesIndex];
																	P = a/((double) input.loci.get(h).length);
																	piRest = piRest + P;
																}
														}
													PiRest[i] = piRest/NRest;
													Pir = Pir + (float) (Pis[i]/PiRest[i]) + "	";
												}
											results.add("		Pir:	" + Pir);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the Pir (and PirS) statistics.");
								}
							
							// (7.4) Estimation of the allelic richness Rg (El Mousadik & Petit, 1996):
							try {
									if (window.checkBoxAr.isSelected())
										{
											String RA = new String();
											// (5.4.1) Estimation of Ns:
											double Ntot = 0; 
											for (int i = 0; i < input.loci.get(h).populations.size(); i ++)
												{
													Ntot = Ntot + input.loci.get(h).populations.get(i).nodes.size();
												}
											double Ns = Ntot; // number of individuals in the smallest group
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double nS = 0;
													for (int j = 0; j < input.loci.get(h).userGroups.get(i).populations.size(); j ++)
														{
															nS = nS + input.loci.get(h).userGroups.get(i).populations.get(j).nodes.size();
														}
													if (nS < Ns)
														{
															Ns = nS;
														}
												}
											// computation of each Rg:
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i ++)
												{
													double Rg = 0; // allelic richness in group g
													double Ng = input.loci.get(h).userGroups.get(i).nodes.size(); // number of individuals in group g
													for (int j = 0; j < input.loci.get(h).haplotypes.size(); j++)
														{
															double Ngj = 0;
															for (int k = 0; k < Ng; k++)
																{
																	int a = 0;
																	a = input.loci.get(h).nodesMismatches[input.loci.get(h).haplotypes.get(j).nodeMismatchesIndex][input.loci.get(h).userGroups.get(i).nodes.get(k).nodeMismatchesIndex];
																	if (a == 0)
																		{
																			Ngj = Ngj + 1;
																		}
																}
															if (Ns > (Ng-Ngj))
																{
																	Rg = Rg + 1;
																}
															else
																{
																	double c1 = this.binomialCoefficient((Ng-Ngj),Ns);
																	double c2 = this.binomialCoefficient(Ng,Ns);
																	Rg = Rg + (1-(c1/c2));
																} 	
														}
													RA = RA + (float) Rg + "	";
												}
											results.add("		Ar:	" + RA);
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the computation of the groups allelic richnesses.");
								}
							
							// (7.5) Estimation of the AMOVA F-statistics (Excoffier et al, 1992):
							try {
									if (window.checkBoxAMOVA.isSelected()  & (input.sameNodesInDifferentGroups == false))
										{
											results.add("");
											results.add("		AMOVA Phi-statistics:");
											results.add("		PhiSC:   " + (float) input.loci.get(h).amovaFsc + " (p-val = " + input.loci.get(h).pValueamovaFsc + ")");
											results.add("		PhiST:   " + (float) input.loci.get(h).amovaFst + " (p-val = " + input.loci.get(h).pValueamovaFst + ")");
											results.add("		PhiCT:   " + (float) input.loci.get(h).amovaFct + " (p-val = " + input.loci.get(h).pValueamovaFct + ")");
										}
								}
							catch (Exception e1) 
								{	
									externalMessage.add("There is a problem with the AMOVA analysis.");
								}
							
							// (7.6) Estimation of the groups pairwise Fst (Excoffier et al, 1992):
							try {
									if (window.checkBoxPairwiseFst.isSelected())
										{
											results.add("");
											results.add("		Fst matrix between all groups of populations: ");
											ArrayList<Population> populations = new ArrayList<Population>();
											ArrayList<Node> nodesToPermut = new ArrayList<Node>();
											ArrayList<String> lines = new ArrayList<String>();
											ArrayList<Node> nodesBeforePermutation = new ArrayList<Node>();
											double fst = 0; int pairCounter = 0;
											double pValueFst = 0;
											for (int i = 0; i < input.loci.get(h).userGroups.size(); i++)
												{
										 			String line1 = new String(); line1 = "		";
										 			String line2 = new String(); line2 = "		";
													for (int j = 0; j < input.loci.get(h).userGroups.size(); j++)
													 	{
														 	if (j < i)
															// if (i != j)
														 		{
														 			pairCounter = pairCounter + 1;
														 			populations = new ArrayList<Population>();											
														 			Population pop1 = new Population(input.loci.get(h).userGroups.get(i).name,input.loci.get(h).userGroups.get(i).groupID);
														 			Population pop2 = new Population(input.loci.get(h).userGroups.get(j).name,input.loci.get(h).userGroups.get(j).groupID);
														 			pop1.nodes.addAll(input.loci.get(h).userGroups.get(i).nodes); 
														 			pop2.nodes.addAll(input.loci.get(h).userGroups.get(j).nodes);
																	for (int k = 0; k < pop1.nodes.size(); k++)
																		{
																			pop1.nodes.get(k).permutPopID = pop1.popID;
																			pop1.nodes.get(k).currentGroup = pop1.popID;
																		}
																	for (int k = 0; k < pop2.nodes.size(); k++)
																		{
																			pop2.nodes.get(k).permutPopID = pop2.popID;
																			pop2.nodes.get(k).currentGroup = pop2.popID;
																		}
																	populations.add(pop1);
																	populations.add(pop2);
																	// System.out.println(this.groupsFst(input.loci.get(h), input.loci.get(h).userGroups.get(i), input.loci.get(h).userGroups.get(j)));
														 			nodesToPermut = new ArrayList<Node>();
																	nodesToPermut.addAll(pop1.nodes); nodesToPermut.addAll(pop2.nodes);
																	double[] FST = new double[3];
																	FST = this.globalFst(input.loci.get(h), populations, nodesToPermut, false, true);
																	fst = FST[0];																
																	line1 = line1 + (float) fst + "	";
																	pValueFst = 0; double[] permutationsFST = new double[3];
																	for (int k = 0; k < (int) window.getPermutationsPairwiseFst(); k++)
																		{
																			simTestThread.run("   Pairwise Fst, locus " + input.loci.get(h).ID + ", pair " + pairCounter + ", permutation " + (k+1));
																			nodesBeforePermutation = new ArrayList<Node>(); nodesBeforePermutation.addAll(nodesToPermut);
																			permutationsNodes = new ArrayList<Node>(); permutationsNodes.addAll(nodesToPermut);
																			for (int l = 0; l < permutationsNodes.size(); l++)
																				{
																					int r = (int) (Math.random()*nodesBeforePermutation.size());
																					int currentPop = nodesBeforePermutation.get(r).currentGroup;
																					permutationsNodes.get(l).permutPopID = currentPop;
																					nodesBeforePermutation.remove(r);
																				}
																			permutationsFST = this.globalFst(input.loci.get(h), populations, permutationsNodes, true, true);
																			permutationsFst = permutationsFST[0];
																			if (permutationsFst < fst)
																				{	}
																			else
																				{
																					pValueFst = pValueFst + 1;
																				}
																		}
																	line2 = line2 + ((float) (pValueFst/window.getPermutationsPairwiseFst())) + "	";
														 		}	
														 	else if (j == i)
															 	{
														 			line1 = line1 + 0 + "	";
														 			line2 = line2 + 0 + "	";
															 	}		
													 	} 
													results.add(line1);
													lines.add(line2);
												}
											results.add("");
											results.add("		Corresponding p-Value matrix: ");
											for (int i = 0; i < lines.size(); i++)
												{
													results.add(lines.get(i));
												}
											input.loci.get(h).pairwiseFstGroup = new double[input.loci.get(0).userGroups.size()][input.loci.get(0).userGroups.size()];
											input.loci.get(h).pairwiseFstGroupNumerator = new double[input.loci.get(0).userGroups.size()][input.loci.get(0).userGroups.size()];
											input.loci.get(h).pairwiseFstGroupDenominator = new double[input.loci.get(0).userGroups.size()][input.loci.get(0).userGroups.size()];
											for (int i1 = 0; i1 < input.loci.get(0).userGroups.size(); i1++)
												{
													int i = -1;
													for (int i2 = 0; i2 < input.loci.get(h).userGroups.size(); i2++)
														{
															if (input.loci.get(0).userGroups.get(i1).name.equals(input.loci.get(h).userGroups.get(i2).name))
																{
																	i = i2;
																}
														}
													for (int j1 = 0; j1 < (i1+1); j1++)
													 	{
															int j = -1;
															for (int j2 = 0; j2 < input.loci.get(h).userGroups.size(); j2++)
																{
																	if (input.loci.get(0).userGroups.get(j1).name.equals(input.loci.get(h).userGroups.get(j2).name))
																		{
																			j = j2;
																		}
																}
															if ((i!=-1)|(j!=-1))
														 		{
														 			if (j < i)
														 				{
																			pairCounter = pairCounter + 1;
																 			populations = new ArrayList<Population>();											
																 			Population pop1 = new Population(input.loci.get(h).userGroups.get(i).name,input.loci.get(h).userGroups.get(i).groupID);
																 			Population pop2 = new Population(input.loci.get(h).userGroups.get(j).name,input.loci.get(h).userGroups.get(j).groupID);
																 			pop1.nodes.addAll(input.loci.get(h).userGroups.get(i).nodes); populations.add(pop1);
																 			pop2.nodes.addAll(input.loci.get(h).userGroups.get(j).nodes); populations.add(pop2);
																			for (int k = 0; k < pop1.nodes.size(); k++)
																				{
																					pop1.nodes.get(k).permutPopID = pop1.popID;
																					pop1.nodes.get(k).currentGroup = pop1.popID;
																				}
																			for (int k = 0; k < pop2.nodes.size(); k++)
																				{
																					pop2.nodes.get(k).permutPopID = pop2.popID;
																					pop2.nodes.get(k).currentGroup = pop2.popID;
																				}
																 			nodesToPermut = new ArrayList<Node>();
																			nodesToPermut.addAll(pop1.nodes); nodesToPermut.addAll(pop2.nodes);
																			double[] FST = new double[3];
																			FST = this.globalFst(input.loci.get(h), populations, nodesToPermut, false, true);
																			fst = FST[0];
																			input.loci.get(h).pairwiseFstGroupNumerator[i1][j1] = FST[1];
																			input.loci.get(h).pairwiseFstGroupNumerator[j1][i1] = FST[1];
																			input.loci.get(h).pairwiseFstGroupDenominator[i1][j1] = FST[2];
																			input.loci.get(h).pairwiseFstGroupDenominator[j1][i1] = FST[2];
														 				}
														 		}
															else
																{
																	input.loci.get(h).pairwiseFstGroupNumerator[i1][j1] = -9999;
																	input.loci.get(h).pairwiseFstGroupNumerator[j1][i1] = -9999;
																	input.loci.get(h).pairwiseFstGroupDenominator[i1][j1] = -9999;
																	input.loci.get(h).pairwiseFstGroupDenominator[j1][i1] = -9999;
																}
													 	} 
												}
										}
								}
							catch (Exception e1) 
								{	} //*/
						}
					results.add("");
			
					// results.add("	Additionnal summary statistics computed by PhyloGeoSim 1.0: ");
					// (8) Estimation of the Dgeo statistics, a new summary statistics (cfr. formula):
					/* try {
							if (window.dgeoButton.isSelected())
								{
									double Dgeo = 0;
									double B = 0;
									ArrayList<Integer> popID = new ArrayList<Integer>(); // ArrayList with the sorted popID's
									
									// Creation of the "PopID" ArrayList:
									nodes = new ArrayList<Node>();
									for (int i = 0; i < input.loci.get(h).populations.size(); i++)
										{
											nodes.addAll(input.loci.get(h).populations.get(i).nodes);
										}
									ArrayList<Integer> popID0 = new ArrayList<Integer>(); // ArrayList with the non sorted popID's
									popID0.add(Integer.valueOf(nodes.get(0).currentPop));
									for (int i = 1; i < nodes.size(); i++)
										{
											int a = 0;
											for (int j = 0; j < i; j++)
												{
													if (nodes.get(i).currentPop == nodes.get(j).currentPop)
														{
															a = a + 1;
														}
												}
											if (a == 0)
												{
													popID0.add(Integer.valueOf(nodes.get(i).currentPop)); 
												}
										}
									int popIDsize = 0; popIDsize = popID0.size(); 
									for (int i = 0; i < popIDsize; i++) // necessary step to sort the popID's
										{
											int index = 0;
											int bufferID = 0;
											bufferID = popID0.get(0).intValue();
											for (int j = 1; j < popID0.size(); j++)
												{
													if (popID0.get(j).intValue() < bufferID)
														{
															bufferID = popID0.get(j).intValue();
															index = j;
														}
												}
											popID0.remove(index);
											popID.add(bufferID);
										}	
									double n = (double) popID.size();
									
									// computation of B:
									for (int i = 1; i < popID.size(); i ++)
										{
											for (int j = 0; j < i; j ++) // these 2 first lines allow to compute "B" for each pair of sampled populations
												{																																							
													// (1) Estimation of dgeo:
													double dgeo = 0;
													dgeo = this.populationsDistance(input.loci.get(h).populations, i, j);
									
													// (2) Estimation of Nk1:
													double Nk1 = 0;
													ArrayList<Node> population1 = new ArrayList<Node>();
													ArrayList<ArrayList<String>> sequencesInPop1 = new ArrayList<ArrayList<String>>();
													for (int k = 0; k < nodes.size(); k++) 
														{
															if (nodes.get(k).currentPop == popID.get(j))
																{
																	Nk1 = Nk1 + 1;
																	population1.add(nodes.get(k));
																	sequencesInPop1.add(nodes.get(k).sequence);
																}
														}
									
													// (3) Estimation of Nk2:
													double Nk2 = 0;
													ArrayList<Node> population2 = new ArrayList<Node>();
													ArrayList<ArrayList<String>> sequencesInPop2 = new ArrayList<ArrayList<String>>();
													for (int k = 0; k < nodes.size(); k++) 
														{
															if (nodes.get(k).currentPop == popID.get(i))
																{
																	Nk2 = Nk2 + 1;
																	population2.add(nodes.get(k));
																	sequencesInPop2.add(nodes.get(k).sequence);
																}
														} 
									
													// (4) Estimation of A:
													double A = 0;
													for (int k = 0; k < (int) Nk1; k++)
														{
															for (int l = 0; l < (int) Nk2; l++)
																{
																	double Pij = 0;
																	double a = 0;
																	for (int m = 0; m < input.loci.get(h).length; m++)
																		{
																			if (sequencesInPop1.get(k).get(m).equals(sequencesInPop2.get(l).get(m)) == false)
																				{
																					a = a + 1;
																				}
																		}
																	Pij = (a/input.loci.get(h).length);
																	A = A + Pij;
																}
														}
									
													B = B + (A/(dgeo*Nk1*Nk2));
												}
										}
					
									double n1 = 1; // it will correspond to "n!"
									for (int i = 1; i < (n+1); i++)
										{
											n1 = n1*i;
										}
					
									double n2 = 1; // it will correspond to "(n-2)!"
									for (int i = 1; i < (n+1-2); i++)
										{
											n2 = n2*i;
										}
					
									Dgeo = ((2*n2)/n1)*B;
									results.add("	Dgeo = " + (float) Dgeo);
								}
						}
					catch (Exception e1) 
						{	
							externalMessage.add("There is a problem with the computation of the Dgeo statistic.");
						} */
										
					/* (9) Estimation of the distribution of pairwise differences:
					try {
							externalMessage.add("");
							externalMessage.add("Distribution of pairwise differences for locus " + input.loci.get(h).ID + ": ");
				 			String line1 = new String(); String line2 = new String();
				 			int numberOfPairwiseDifferences = 0; double maximumNumberOfPairwiseDifferences = 0;
				 			for (int j = 1; j < nodes.size(); j++)
								{
				 					for (int k = 0; k < j; k++)
										 {
				 							numberOfPairwiseDifferences = numberOfPairwiseDifferences + 1;
										 }
								}
				 			double[] pairwiseDifferences = new double[numberOfPairwiseDifferences];
				 			numberOfPairwiseDifferences = 0;
				 			for (int j = 1; j < nodes.size(); j++)
								{
				 					for (int k = 0; k < j; k++)
										 {
											double a = 0;
											a = input.loci.get(h).nodesMismatches[nodes.get(j).nodeMismatchesIndex][nodes.get(k).nodeMismatchesIndex];
											pairwiseDifferences[numberOfPairwiseDifferences] = a;
											numberOfPairwiseDifferences = numberOfPairwiseDifferences + 1;
											if (a > maximumNumberOfPairwiseDifferences)
												{
													maximumNumberOfPairwiseDifferences = a;
												}
										 }		
								}
				 			for (int j = 0; j < (maximumNumberOfPairwiseDifferences+1); j++)
				 				{
				 					line1 = line1 + "	" + j;
				 					int counter = 0;
				 					for (int k = 0; k < pairwiseDifferences.length; k++)
				 						{
				 							if ((int) pairwiseDifferences[k] == j)
				 								{
				 									counter = counter + 1;
				 								}
				 						}
				 					line2 = line2 + "	" + counter;
				 				}
							line1 = "Pairwise differences: " + line1; externalMessage.add(line1); 
							line2 = "Number of occurences: " + line2; externalMessage.add(line2);
						}
					catch (Exception e1) 
						{	}
					
					// results.add(" "); // results.add(" "); */
					
					/* To print a pairwise Fst matrix between all the sampled populations:
					System.out.println(); System.out.println("Fst matrix between all the sampled populations: ");
					for (int i = 0; i < input.loci.get(h).populations.size(); i++)
						{
							 for (int j = 0; j < input.loci.get(h).populations.size(); j++)
							 	{
								 	//if (delaunayTriangulation[i][j] != 0)
								 		//{
								 			ArrayList<Population> populations0 = new ArrayList<Population>();
									 		int popID1 = input.loci.get(h).populations.get(i).popID; populations0.add(input.loci.get(h).populations.get(popID1-1));
											int popID2 = input.loci.get(h).populations.get(j).popID; populations0.add(input.loci.get(h).populations.get(popID2-1));
											double fst[] = this.globalFst(input.loci.get(h), populations0, input.loci.get(h).nodes, false);
											// System.out.println(popID1 + " - " + popID2); System.out.println(fst[0] + " ");
											System.out.print(fst[0] + " ");
								 		//}	
								 	//else
									 	//{
								 			//System.out.print((highestFst-0.1) + " ");
									 	//}		
							 	}			System.out.println();
						}					System.out.println(); //*/
				}
			
			if (window.checkBoxPairwiseFst.isSelected() & (input.loci.size() > 1))
				{
					results.add("");
					results.add("");
					results.add("Combined Fst matrix between all groups of populations: ");
					String groupsName = new String();
					for (int i = 0; i < (int) input.loci.get(0).userGroups.size(); i++)
						{
							groupsName = groupsName + input.loci.get(0).userGroups.get(i).name + "	";
						}
					results.add(" ");
					results.add(groupsName);
					for (int i = 0; i < input.loci.get(0).userGroups.size(); i++)
						{
			 				String line1 = new String(); line1 = "";
			 				for (int j = 0; j < input.loci.get(0).userGroups.size(); j++)
						 		{
			 						if (j < i)
			 						// if (i != j)
						 				{
			 								double fst = 0; double fstN = 0; double fstD = 0;
			 								for (int k = 0; k < input.loci.size(); k++)
			 									{
			 										if ((input.loci.get(k).pairwiseFstGroupNumerator[i][j] != -9999)&(!Double.isNaN(input.loci.get(k).pairwiseFstGroupNumerator[i][j])))
			 											{
			 												fstN = fstN + input.loci.get(k).pairwiseFstGroupNumerator[i][j];
			 												fstD = fstD + input.loci.get(k).pairwiseFstGroupDenominator[i][j];
			 											}
			 									}
			 								fst = fstN/fstD;
			 								line1 = line1 + (float) fst + "	";
						 				}
			 						if (j == i)
			 							{
			 								line1 = line1 + 0 + "	";
			 							}
						 		}
			 				results.add(line1);							
						}
				}
		}
	
	// Method to compute the global Gst and Nst (Pons & Petit, 1995, 1996):
	public double[] globalGstNst(Locus locus, ArrayList<Node> nodes, boolean permutation, int[][] nodesMismatches)
		{
			ArrayList<Population> populations = new ArrayList<Population>();
			for (int i = 0; i < locus.populations.size(); i++)
				{
					Population population = new Population(locus.populations.get(i).popName, locus.populations.get(i).popID);
					if (permutation == false)
						{
							for (int j = 0; j < nodes.size(); j++)
								{
									if (population.popID == nodes.get(j).currentPop)
										{
											population.nodes.add(nodes.get(j));
										}
								}
						}
					else
						{
							for (int j = 0; j < nodes.size(); j++)
								{
									if (population.popID == nodes.get(j).permutPopID)
										{
											population.nodes.add(nodes.get(j));
										}
								}
						}		
					if (population.nodes.size() > 1)
						{
							populations.add(population);
						}
				}
			double[][] allelicFrequenciesInPops = new double[populations.size()][locus.haplotypesInPopsWithMoreThanOneGeneCopy.size()];
			for (int i = 0; i < populations.size(); i++)
				{
					for (int j = 0; j < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); j++)
						{
							double a = 0;
							for (int k = 0; k < populations.get(i).nodes.size(); k++)
								{
									if (0 == nodesMismatches[locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(j).nodeMismatchesIndex][populations.get(i).nodes.get(k).nodeMismatchesIndex])
										{
											a = a + 1;
										}
								}
							allelicFrequenciesInPops[i][j] = (a/(double) populations.get(i).nodes.size());
						}
				}
			double[] meanAllelicFrequenciesInPops = new double[locus.haplotypesInPopsWithMoreThanOneGeneCopy.size()];
			for (int i = 0; i < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); i++)
				{
					double a = 0;
					for (int j = 0; j < populations.size(); j++)
						{
							a = a + allelicFrequenciesInPops[j][i];
						}
					meanAllelicFrequenciesInPops[i] = (a/(double) populations.size());
				}
			
			double n = 0; n = (double) populations.size();
			double Gst = 0;
			double Hs = 0; double hs = 0; double Nk = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					Nk = (double) populations.get(i).nodes.size();
					double x = 0;
					for (int j = 0; j < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); j++)
						{
							x = x + ((allelicFrequenciesInPops[i][j])*(allelicFrequenciesInPops[i][j]));
						}
					hs = 1 - x;
					hs = (hs*Nk)/(Nk-1);
					Hs = Hs + hs;
				}
			Hs = Hs/n;
			double X = 0;
			for (int i = 0; i < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); i++)
				{
					X = X + ((meanAllelicFrequenciesInPops[i])*(meanAllelicFrequenciesInPops[i]));
				}
			double deltaX = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					Nk = (double) populations.get(i).nodes.size();
					for (int j = 0; j < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); j++)
						{
							deltaX = deltaX + ((allelicFrequenciesInPops[i][j]-meanAllelicFrequenciesInPops[j])*(allelicFrequenciesInPops[i][j]-meanAllelicFrequenciesInPops[j]));
						}
				}
			double Ht = 0;
			Ht = 1 - X + (1/(n*(n-1)))*deltaX;
			// System.out.println("Hs = " + Hs); System.out.println("X = " + X); System.out.println("deltaX = " + deltaX);
			Gst = 1 - (Hs/Ht);
			
			double Nst = 0;
			double Vs = 0;
			double Pi = 0; double xki = 0; double xkj = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					double Vk = 0;
					Pi = 0; xki = 0; xkj = 0;
					for (int j = 1; j < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); j++)
						{
							for (int k = 0; k < j; k++)
								{
									Pi = 0; xki = 0; xkj = 0;
									Pi = nodesMismatches[locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(j).nodeMismatchesIndex][locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(k).nodeMismatchesIndex];
									Pi = Pi/((double) locus.length);
									xki = allelicFrequenciesInPops[i][j];
									xkj = allelicFrequenciesInPops[i][k];
									Vk = Vk + (Pi*xki*xkj);
								}
						}			
					Nk = 0; Nk = (double) populations.get(i).nodes.size(); 
					Vk = ((Nk*Vk)/(Nk-1));
					Vs = Vs + Vk;
				}
			Vs = Vs/populations.size();	
			double Vt1 = 0;
			double xi = 0; double xj = 0;
			for (int i = 1; i < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); i++)
				{
					for (int j = 0; j < i; j++)
						{
							Pi = 0; xi = 0; xj = 0;
							Pi = nodesMismatches[locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(i).nodeMismatchesIndex][locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(j).nodeMismatchesIndex];
							Pi = Pi/((double) locus.length);
							xi = meanAllelicFrequenciesInPops[i];
							xj = meanAllelicFrequenciesInPops[j];
							Vt1 = Vt1 + (Pi*xi*xj);
						}			
				}		
			double Vt2 = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					double Vk = 0;
					Pi = 0; xi = 0; xj = 0; xki = 0; xkj = 0;
					for (int j = 1; j < locus.haplotypesInPopsWithMoreThanOneGeneCopy.size(); j++)
						{
							for (int k = 0; k < j; k++)
								{
									Pi = 0; xi = 0; xj = 0;
									Pi = nodesMismatches[locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(j).nodeMismatchesIndex][locus.haplotypesInPopsWithMoreThanOneGeneCopy.get(k).nodeMismatchesIndex];
									Pi = Pi/((double) locus.length);
									xi = meanAllelicFrequenciesInPops[j];
									xj = meanAllelicFrequenciesInPops[k];
									xki = allelicFrequenciesInPops[i][j];
									xkj = allelicFrequenciesInPops[i][k];
									Vk = Vk + (Pi*(xki-xi)*(xkj-xj));
								}
						}			
					Vt2 = Vt2 + Vk;
				}			
			double Vt = 0;
			Vt = Vt1 - (Vt2*(1/(n*(n-1)))); 
			// System.out.println("Vs = " + Vs); System.out.println("Vt1 = " + Vt1); System.out.println("Vt2 = " + Vt2);
			Nst = 1 - (Vs/Vt);
			
			double[] GSTNST = new double[6];
			GSTNST[0] = Gst; GSTNST[1] = Nst;
			GSTNST[2] = Ht-Hs; GSTNST[3] = Ht;
			GSTNST[4] = Vt-Vs; GSTNST[5] = Vt;
			return GSTNST;
		}
	
	// Method to compute the global Fst (Excoffier et al, 1992):
	public double[] globalFst(Locus locus, ArrayList<Population> populations0, ArrayList<Node> nodes, boolean permutation, boolean groupFst)
		{	
			ArrayList<Population> populations = new ArrayList<Population>();
			double numberOfNodes = 0;
			for (int i = 0; i < populations0.size(); i++)
				{
					Population population = new Population(populations0.get(i).popName, populations0.get(i).popID);
					if (permutation == false)
						{
							for (int j = 0; j < nodes.size(); j++)
								{
									if (groupFst == false)
										{
											if (population.popID == nodes.get(j).currentPop)
												{
													population.nodes.add(nodes.get(j));
												}
										}
									if (groupFst == true)
										{
											if (population.popID == nodes.get(j).currentGroup)
												{
													population.nodes.add(nodes.get(j));
												}
										}
								}
						}
					else
						{
							for (int j = 0; j < nodes.size(); j++)
								{
									if (population.popID == nodes.get(j).permutPopID)
										{
											population.nodes.add(nodes.get(j));
										}
								}
						}	
					populations.add(population);
					numberOfNodes = numberOfNodes + population.nodes.size();
				}
	
			double N = (double) numberOfNodes; double n = (double) populations.size();
			double SSDwp = 0; double ssdwp = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					ssdwp = 0;
					for (int j = 0; j < populations.get(i).nodes.size(); j++)
						{
							for (int k = 0; k < populations.get(i).nodes.size(); k++)
								{
									ssdwp = ssdwp + locus.nodesMismatches[populations.get(i).nodes.get(j).nodeMismatchesIndex][populations.get(i).nodes.get(k).nodeMismatchesIndex];
								}
						}
					SSDwp = SSDwp + ssdwp/(2*((double) populations.get(i).nodes.size()));
				}
			
			double SSDap1 = 0; double Nk2 = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					for (int j = 0; j < populations.get(i).nodes.size(); j++)
						{
							for (int k = 0; k < populations.size(); k++)
								{
									for (int l = 0; l < populations.get(k).nodes.size(); l++)
										{
											SSDap1 = SSDap1 + locus.nodesMismatches[populations.get(i).nodes.get(j).nodeMismatchesIndex][populations.get(k).nodes.get(l).nodeMismatchesIndex];
										}
								}
						}
					Nk2 = Nk2 + (2*populations.get(i).nodes.size());
				}
			SSDap1 = SSDap1/Nk2;
			double SSDap2 = 0;
			SSDap2 = SSDwp;
			
			double Fst = 0;																			
			double SSDap = SSDap1-SSDap2;																					
			double MSDwp = SSDwp/(N-n);																					
			double MSDap = SSDap/(n-1);
			double nPrime = 0;
			double Nk = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					Nk = (double) populations.get(i).nodes.size();
					nPrime = nPrime + ((Nk*Nk)/N);
				}
			nPrime = ((N - nPrime)/(n-1));																	
			double Ob = MSDwp;																					
			double Oa = (MSDap - Ob)/nPrime;																					
			double O = Oa + Ob;																					
			Fst = Oa/O;
			
			double[] FST = new double[3];
			FST[0] = Fst;
			FST[1] = Oa;
			FST[2] = O;
			return FST;
		}
	
	// Method to compute the pairwise Fst between two groups of populations (Excoffier et al, 1992):
	// (this method is NOT used any more, pairwise Fst's are now computed with the globalFst method!!)
	public double[] groupsFst(Locus locus, Group group1, Group group2)
		{	
			ArrayList<Population> populations = new ArrayList<Population>();
			ArrayList<Group> groups = new ArrayList<Group>(); groups.add(group1); groups.add(group2);
			double numberOfNodes = 0;
			for (int i = 0; i < groups.size(); i++)
				{
					Population population = new Population(groups.get(i).name, groups.get(i).groupID);
					for (int j = 0; j < groups.get(i).populations.size(); j++)
						{
							population.nodes.addAll(groups.get(i).populations.get(j).nodes);
						}
					populations.add(population);
					numberOfNodes = numberOfNodes + population.nodes.size();
				}
			
			double N = (double) numberOfNodes; double n = (double) populations.size();
			double SSDwp = 0; double ssdwp = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					ssdwp = 0;
					for (int j = 0; j < populations.get(i).nodes.size(); j++)
						{
							for (int k = 0; k < populations.get(i).nodes.size(); k++)
								{
									ssdwp = ssdwp + locus.nodesMismatches[populations.get(i).nodes.get(j).nodeMismatchesIndex][populations.get(i).nodes.get(k).nodeMismatchesIndex];
								}
						}
					SSDwp = SSDwp + ssdwp/(2*((double) populations.get(i).nodes.size()));
				}
			
			double SSDap1 = 0; double Nk2 = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					for (int j = 0; j < populations.get(i).nodes.size(); j++)
						{
							for (int k = 0; k < populations.size(); k++)
								{
									for (int l = 0; l < populations.get(k).nodes.size(); l++)
										{
											SSDap1 = SSDap1 + locus.nodesMismatches[populations.get(i).nodes.get(j).nodeMismatchesIndex][populations.get(k).nodes.get(l).nodeMismatchesIndex];
										}
								}
						}
					Nk2 = Nk2 + (2*populations.get(i).nodes.size());
				}
			SSDap1 = SSDap1/Nk2;
			double SSDap2 = 0;
			SSDap2 = SSDwp;
			
			double[] FST = new double[3];																			
			double SSDap = SSDap1-SSDap2;																					
			double MSDwp = SSDwp/(N-n);																					
			double MSDap = SSDap/(n-1);
			double nPrime = 0;
			double Nk = 0;
			for (int i = 0; i < populations.size(); i++)
				{
					Nk = (double) populations.get(i).nodes.size();
					nPrime = nPrime + ((Nk*Nk)/N);
				}
			nPrime = ((N - nPrime)/(n-1));																	
			double Ob = MSDwp;																					
			double Oa = (MSDap - Ob)/nPrime;																					
			double O = Oa + Ob;																					
			FST[0] = Oa/O;
			FST[1] = Oa;
			FST[2] = O;
			return FST;
		}
	
	// Method to compute the distance (dgeo) between 2 populations from a "populations" ArrayList:
	public double populationsDistance(ArrayList<Population> populations, int popID1, int popID2)
		// Important note: popID1 and popID2 are NOT some population ID BUT simply indices for the "populations" ArrayList !!!
		{
			double distance = -1;
			if (input.pairwisePopulationDistances == false)
				{
					double[] position1 = new double[2]; double[] position2 = new double[2];
					position1 = populations.get(popID1).position;
					position2 = populations.get(popID2).position;
					distance = Math.sqrt(((position2[1]-position1[1])*(position2[1]-position1[1])) + ((position2[0]-position1[0])*(position2[0]-position1[0])));
				}
			else
				{
					distance = input.populationDistances[populations.get(popID1).popDistanceIndex][populations.get(popID2).popDistanceIndex];
				}
			return distance; 
		}
	
	// Method to compute a binomial coefficient from parameters n & p:
	public double binomialCoefficient(double n, double p)
		{
			double a = (n-(p-1)); double c = 1;
			for (int i = (int) (n-(p-1)); i < n; i++)
				{
					a = a*(i+1);
				}
			for (int i = 0; i < p; i++)
				{
					c = c*(i+1);
				}
			// System.out.println(n + " - " + p + " - " + a + " - " + c);
			return (a/c);
		}
}
